/*###########################################################################
#                                                                           #
#      		         SPItbVt@CVXe					#
#                 ܂ꂽt@C̃y[WAۏ؂				#
#	    {W[gp̑OFatFs/AT45DB161D̏sĂ	#
#																			#
# iR[obN֐                                                      #
# void func( uint16_t val ,uint16_t max )									#
# val : il                                                              #
# max : ől																#
###########################################################################*/
#define __FLASH_SYS_C__
#include "project.h"

#if WDT_MODE
#include <avr/wdt.h>
#endif

#define FSID "FLASH_FS"									/* t@CVXeID			*/
#define INDEX_PAGE ( HEADER_PAGE + 1 )					/* CfbNẌ擪y[Wԍ	*/
#define INDEXS_PER_PAGE ( 512 / sizeof(FLASH_FS_INFO) )	/* Py[W̃CfbNX	*/
#define INDEX_PAGES ( INDEX_COUNT / INDEXS_PER_PAGE )	/* t@CCfbNẌy[W	*/
#define DATA_PAGE ( INDEX_PAGE + INDEX_PAGES )			/* f[^̈Jny[Wԍ			*/

/* [J֐vg^Cv錾	*/
static uint8_t file_flash_write( uint16_t topPage ,char *fname ,uint16_t pageLimit ,uint16_t *nPage ,void (*func)( uint16_t ,uint16_t ) );
static uint8_t bmp_flash_write( uint16_t topPage ,char *fname ,uint16_t pageLimit ,uint16_t *nPage ,FLASH_FS_INFO *fs ,void (*func)( uint16_t ,uint16_t ) );
static void flashFs_readHeader( FLASH_FS_HEADER *h );
static uint8_t flashFs_writeHeader( FLASH_FS_HEADER *h );
static uint8_t flashFs_writeIndex( uint16_t index ,FLASH_FS_INFO *info );

/****************************************************************************
*						SPItbVtH[}bg
* Fvoid
* ߒlFuint8_t 0:OK  !0:NG
****************************************************************************/
uint8_t flashFs_format( void )
{
	FLASH_FS_HEADER h;
	uint16_t i;

	/* tbVt@Cwb_l	*/
	memcpy_P( h.id ,PSTR(FSID) ,8 );			/* ID					*/
	h.indexMax = INDEX_COUNT;					/* ǗCfbNX		*/
	h.startDataPage = DATA_PAGE;				/* f[^擪y[Wԍ		*/
	h.nextPage = DATA_PAGE;						/* 񊄂蓖ăy[Wԍ	*/
	h.freePages = LAST_PAGE - DATA_PAGE + 1;	/* 󂫃y[W				*/
	if ( flashFs_writeHeader( &h ) != 0 ) {
		return ( 1 );
	}

	/* t@CCfbNẌNA		*/
	flashBufferWrite( FLASH_BUFFER1 ,0 );
	for ( i = 0 ;i < 128 ;i++ ) {
		flashWriteBYTE( 0x00 );
		flashWriteBYTE( 0x00 );
		flashWriteBYTE( 0x00 );
		flashWriteBYTE( 0x00 );
	}
	FLASH_DISABLE_CS();

	for ( i = INDEX_PAGE ;i < INDEX_PAGE + INDEX_PAGES ;i++ ) {
		flashBufferToPage( FLASH_BUFFER1 ,i );
		if ( flashComparePageToBuffer( FLASH_BUFFER1 ,i ) != 0 ) {
			return ( 2 );
		}
	}

	return ( 0 );
}

/*****************************************************************************
*					tbVt@CVXe`FbN
* Fvoid
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
uint8_t flashFs_checkSystem( void )
{
	FLASH_FS_HEADER h;

	/* wb_擾						*/
	flashFs_readHeader( &h );

	/* ʕ`FbN				*/
	if ( memcmp_P( h.id ,PSTR(FSID) ,8 ) != 0 ) {
		return ( 1 );
	}

	/* Ǘt@C`FbN			*/
	if ( h.indexMax != INDEX_COUNT ) {
		return ( 2 );
	}

	/* 񊄂蓖ăy[Wԍ`FbN	*/
	if ( h.nextPage < DATA_PAGE ) {
		return ( 3 );
	}

	/* 񊄂蓖ăy[Wԍ`FbN	*/
	if ( h.freePages != ( ( LAST_PAGE + 1 ) - h.nextPage ) ) {
		return ( 4 );
	}

	/* 擪f[^y[Wԍ`FbN		*/
	if ( h.startDataPage != DATA_PAGE ) {
		return ( 5 );
	}

	return ( 0 );
}

/*****************************************************************************
*					tbVt@CVXe󂫃ubN擾
* Fvoid
* ߒlFuint16_t ubN
*****************************************************************************/
uint16_t flashFs_getFreeBlockCount( void )
{
	FLASH_FS_HEADER h;
	flashFs_readHeader( &h );
	return ( h.freePages );
}

/*****************************************************************************
*				tbVt@CVXewCfbNXǍ
* Fuint16_t      index CfbNXԍ(0`)
*       FLASH_FS_INFO *info CfbNX
* ߒlFvoid
*****************************************************************************/
void flashFs_readIndex( uint16_t index ,FLASH_FS_INFO *info )
{
	uint16_t page;
	uint16_t offset;

	page = INDEX_PAGE + ( index / INDEXS_PER_PAGE );
	offset = ( index % INDEXS_PER_PAGE ) * sizeof(FLASH_FS_INFO);

	flashContinuousArrayRead( page ,offset );
	flashReadBLOCK( info ,sizeof( FLASH_FS_INFO ) );
	FLASH_DISABLE_CS();
}

/*****************************************************************************
*			SDJ[h̎wt@CtbVt@CVXeɃ[h
* Fuint8_t  mode   0:^CX^vrĕKvȏꍇ̂݃[h
*                       1:[h
*		uint16_t index  CfbNXԍ
*		char     *fname t@C
*		uint8_t  ftype  t@C^Cv FLASH_FS_FILE  : t@C̓ê܂ܓ]
*						               FLASH_FS_IMAGE : R5G6B5`̃C[Wɕϊē]
*		uint16_t n      mۂy[W(AUTO_RESERV:)
*		void (*func)(uint16_t ,uint16_t) i\p̃R[obN֐
* ߒlFuint8_t         0:OK
*						255:SDJ[hANZXs܂̓t@C݂Ȃ
*						>=1 : G[
*****************************************************************************/
uint8_t flashFs_loadFile( uint8_t mode ,uint16_t index ,char *fname ,uint8_t ftype ,uint16_t n ,void (*func)(uint16_t ,uint16_t) )
{
	FILINFO ff;
	FLASH_FS_INFO fs;
	FLASH_FS_HEADER h;
	uint8_t update = 0;
	uint8_t newFlag = 0;
	uint8_t ret;
	uint16_t usePage;

	char *f = getFileName( fname );				/* pX̃t@Cl[			*/

	if ( index > INDEX_COUNT ) {
		return ( 1 );
	}

	if ( *f == '\0' ) {
		return ( 2 );
	}

	if ( f_stat( (const TCHAR *)fname ,&ff ) != FR_OK ) {	/* SDJ[ht@C	*/
		return ( 0xff );
	}

	flashFs_readHeader( &h );					/* tbVt@CVXewb_	*/
	flashFs_readIndex( index ,&fs );			/* CfbNX					*/

	/* [h̃tOݒ			*/
	if ( mode != 0 ) {
		update = 1;
	}

	/* t@C^Cv`FbN			*/
	if ( update == 0 ) {
		if ( fs.ftype != ftype ) {
			update = 1;
		}
	}

	/* t@C`FbN				*/
	if ( update == 0 ) {
		if ( strcasecmp( f ,fs.fname ) != 0 ) {
			update = 1;
		}
	}

	/* ^CX^vr				*/
	if ( update == 0 ) {
		if ( ( ff.fdate > fs.fdate ) || ( ( ff.fdate == fs.fdate ) && ( ff.ftime > fs.ftime ) ) ) {
			update = 1;
		}
	}

	/* XV̕Kvꍇ͏I		*/
	if ( update == 0 ) {
		if ( func ) {
			(*func)( 100 ,100 );
		}
		return ( 0 );
	}

	if ( func ) {
		(*func)( 0 ,100 );
	}

	/* CfbNX쐬				*/
	if ( fs.fname[0] == '\0' ) {
		newFlag = 1;
		memset( &fs ,0x00 ,sizeof(FLASH_FS_INFO) );
		fs.topPage = h.nextPage;
		if ( n == AUTO_RESERV ) {
			fs.pageCount = h.freePages;
		} else if ( n <= h.freePages ) {
			fs.pageCount = n;
		} else {
			return ( 3 );
		}
	}

	fs.ftype = ftype;									/* t@C^Cv					*/

	memset( fs.fname ,0x00 ,13 );
	memcpy( fs.fname ,ff.fname ,12 );					/* t@C						*/

	fs.fdate = ff.fdate;								/* ^CX^v					*/
	fs.ftime = ff.ftime;

	/* t@C[h					*/
	if ( ftype == FLASH_FS_FILE ) {
		fs.fsize = ff.fsize;
		fs.bytesPerLine = 0;
		fs.width = 0;
		fs.height = 0;
		ret = file_flash_write( fs.topPage ,fname ,fs.pageCount ,&usePage ,func );
		if ( ret != 0 ) {
			return ( 100 + ret );
		}
	} else {
		ret = bmp_flash_write( fs.topPage ,fname ,fs.pageCount ,&usePage ,&fs ,func );
		if ( ret != 0 ) {
			return ( 200 + ret );
		}
	}

	/* tbVt@CVXewb_XV	*/
	if ( newFlag == 1 ) {
		if ( n == AUTO_RESERV ) {
			fs.pageCount = usePage;
		}
		h.nextPage += usePage;
		h.freePages -= usePage;
		if ( flashFs_writeHeader( &h ) != 0 ) {
			return ( 6 );
		}
	}

	/* CfbNX񏑍				*/
	if ( flashFs_writeIndex( index ,&fs ) != 0 ) {
		return ( 7 );
	}

	return ( 0 );
}

/*****************************************************************************
*					t@CtbVt@Cɏ
* Fuint16_t topPage   ݐ擪y[Wԍ
*		char     *fname    BMPt@C
*		uint16_t pageLimit ݉\ȃy[W
*		uint16_t *nPage    񂾃y[W 
*		void (*func)(uint16_t ,uint16_t) i\p̃R[obN֐
* ߒlFuint8_t          0:OK !0:NG
*****************************************************************************/
static uint8_t file_flash_write( uint16_t topPage ,char *fname ,uint16_t pageLimit ,uint16_t *nPage ,void (*func)( uint16_t ,uint16_t ) )
{
	uint8_t pageBuffer[512];
	uint16_t len;
	uint16_t n;
	uint16_t page ,pageMax ,pageCount;
	uint32_t fsize;
	FIL fl;

	*nPage = 0;

	/* t@CI[v	*/
	if ( f_open( &fl ,(const TCHAR *)fname ,FA_READ ) != FR_OK ) {
		return ( 1 );
	}

	pageMax = ( fl.fsize + 511L ) / 512L;
	pageCount = 0;
	fsize = fl.fsize;
	page = topPage;

	/* ݃C	*/
	while ( fsize ) {
		/* EIb`hbN^C}[Zbg	*/
		#if (WDT_MODE)
		wdt_reset();
		#endif

		/* i\	*/
		if ( func ) {
			if ( ( pageCount % 8 ) == 0 ) {
				(*func)( pageCount ,pageMax );
			}
		}

		if ( pageCount >= pageLimit ) {
			f_close( &fl );
			return ( 2 );
		}

		if ( fsize >= 512L ) {
			len = 512;
		} else {
			len = (uint16_t)fsize;
		}
		fsize -= (uint32_t)len;

		/* t@Cǂݍ		*/
		if ( ( f_read( &fl ,pageBuffer ,len ,&n ) != FR_OK ) || ( n != len ) ) {
			f_close( &fl );
			return ( 3 );
		}

		/* SPItbV֓]	*/
		if ( flashWritePage( page++ ,pageBuffer ) != 0 ) {
			f_close( &fl );
			return ( 4 );
		}

		pageCount++;
	}

	/* i\	*/
	if ( func ) {
		(*func)( pageCount ,pageMax );
	}

	f_close( &fl );
	*nPage = pageCount;

	return ( 0 );
}

/*****************************************************************************
*					BMPt@CtbVt@Cɏ
* Fuint16_t topPage   ݐ擪y[Wԍ
*		char     *fname    BMPt@C
*		uint16_t pageLimit ݉\ȃy[W
*		uint16_t *nPage    񂾃y[W 
*		FLASH_FS_INFO *fs  t@CCfbNX\
*		void (*func)(uint16_t ,uint16_t) i\p̃R[obN֐
* ߒlFuint8_t          0:OK !0:NG
*****************************************************************************/
static uint8_t bmp_flash_write( uint16_t topPage ,char *fname ,uint16_t pageLimit ,uint16_t *nPage ,FLASH_FS_INFO *fs ,void (*func)( uint16_t ,uint16_t ) )
{
	uint8_t pageBuffer[512] ,*p;
	uint8_t buf[4];
	uint16_t n;
	uint16_t x ,y;
	uint16_t page ,pageCount;
	uint32_t fpos;
	uint8_t bpc;						/* 1hbgӂ̃oCg			*/
	BMP_HEADER bmp;
	FIL fl;

	*nPage = 0;

	/* BMPt@CI[v			*/
	if ( f_open( &fl ,(const TCHAR *)fname ,FA_READ ) != FR_OK ) {
		return ( 1 );
	}

	/* BMPwb_ǂݍ			*/
	if ( ( f_read( &fl ,&bmp ,sizeof(BMP_HEADER) ,&n ) != FR_OK ) || ( n != sizeof(BMP_HEADER) ) ) {
		f_close( &fl );
		return ( 2 );
	}

	/* 'BM' ʕ`FbN		*/
	if ( bmp.bfType != 0x4d42 ) {
		f_close( &fl );
		return ( 2 );
	}

	/* sNZtH[}bg`FbN	*/
	if ( ( bmp.biBitCount != 24 ) && ( bmp.biBitCount != 16 ) ) {
		f_close( &fl );
		return ( 3 );
	}

	/* f`FbN				*/
	if ( ( bmp.biHeight == 0L ) || ( bmp.biWidth == 0L ) ) {
		f_close( &fl );
		return ( 4 );
	}

	/* t@C̐擪sNZf[^܂ł̃oCg`FbN	*/
	if ( bmp.bfOffBits != 54L ) {
		f_close( &fl );
		return ( 5 );
	}

	/* \̂̃TCY`FbN		*/
	if ( bmp.biSize != 40L ) {
		f_close( &fl );
		return ( 6 );
	}

	/* 摜TCY`FbN			*/
	if ( ( bmp.biHeight == 0L ) || ( bmp.biWidth == 0L ) ) {
		f_close( &fl );
		return ( 7 );
	}

	if ( ( bmp.biHeight > 2048L ) || ( bmp.biWidth == 2048L ) ) {
		f_close( &fl );
		return ( 8 );
	}

	/* v[`FbN			*/
	if ( bmp.biPlanes != 1L ) {
		f_close( &fl );
		return ( 9 );
	}

	/* k^Cv`FbN			*/
	if ( bmp.biCompression != 0L ) {
		f_close( &fl );
		return ( 10 );
	}

	/* gpJ[CfbNX`FbN	*/
	if ( bmp.biClrUsed != 0L ) {
		f_close( &fl );
		return ( 11 );
	}

	bpc = (uint8_t)( bmp.biBitCount / 8 );			/* 1hbg̃oCg	*/

	/* t@CCfbNXZbg		*/
	fs->width = (uint16_t)bmp.biWidth;
	fs->height = (uint16_t)bmp.biHeight;

	fs->bytesPerLine = (uint16_t)bpc * fs->width;	/* 1Cӂ̃oCg*/
	if ( fs->bytesPerLine % 4 ) {					/* 4oCgACg	*/
		fs->bytesPerLine = ( ( fs->bytesPerLine / 4 ) + 1 ) * 4;
	}

	fs->fsize = (uint32_t)fs->bytesPerLine * (uint32_t)bmp.biHeight;

	/* f[^TCY`FbN	*/
	if ( fs->fsize != bmp.biSizeImage ) {
		f_close( &fl );
		return ( 12 );
	}

	fpos = bmp.bfOffBits + fs->fsize;
	if ( fl.fsize < fpos ) {
		f_close( &fl );
		return ( 13 );
	}

	/* ep[^	*/
	page = topPage;
	pageCount = 0;
	p = pageBuffer;

	/* C[v	*/
	for ( y = 0 ;y < fs->height ;y++ ) {

		/* EIb`hbN^C}[Zbg	*/
		#if (WDT_MODE)
		wdt_reset();
		#endif

		/* i\	*/
		if ( func ) {
			if ( ( y % 8 ) == 0 ) {
				(*func)( y ,fs->height );
			}
		}

		/* s̐擪ʒuɃt@C|C^ړ		*/
		fpos -= (uint32_t)fs->bytesPerLine;
		if ( f_lseek( &fl ,fpos ) != FR_OK ) {
			f_close( &fl );
			return ( 14 );
		}

		for ( x = 0 ;x < fs->width ;x++ ) {

			/* 1sNZ擾				*/
			if ( ( f_read( &fl ,buf ,bpc ,&n ) != FR_OK ) || ( n != bpc ) ) {
				f_close( &fl );
				return ( 15 );
			}

			/* tJ[摜̏ꍇA16bitlɕϊ	*/
			if ( bpc == 3 ) {
				*p++ = ( buf[2] & 0xf8 ) | ( buf[1] >> 5);
				*p++ = ( ( buf[1] & 0x1c ) << 3 ) | ( buf[0] >> 3);

			/* 16bit摜̏ꍇAoCgI[_[ϊ*/
			} else {
				*p++ = buf[1];
				*p++ = buf[0];
			}

			/* SPItbV֓]	*/
			if ( ( p - pageBuffer ) == 512 ) {
				if ( pageCount >= pageLimit ) {
					f_close( &fl );
					return ( 16 );
				}
				if ( flashWritePage( page++ ,pageBuffer ) != 0 ) {
					f_close( &fl );
					return ( 17 );
				}
				p = pageBuffer;
				pageCount++;
			}
		}
	}

	/* ݂̃tbVy[W	*/
	if ( p != pageBuffer ) {
		if ( pageCount >= pageLimit ) {
			f_close( &fl );
			return ( 18 );
		}
		if ( flashWritePage( page++ ,pageBuffer ) != 0 ) {
			f_close( &fl );
			return ( 19 );
		}
		pageCount++;
	}

	/* i\	*/
	if ( func ) {
		(*func)( y ,fs->height );
	}

	f_close( &fl );

	/* 摜p[^ČvZ				*/
	fs->bytesPerLine = fs->width * 2;
	fs->fsize = (uint32_t)fs->bytesPerLine * (uint32_t)bmp.biHeight;

	*nPage = pageCount;

	return ( 0 );
}

/*****************************************************************************
*					tbVt@CVXewb_
* FFLASH_FS_HEADER *h
* ߒlFuint8_t         0:OK !0:NG
*****************************************************************************/
static uint8_t flashFs_writeHeader( FLASH_FS_HEADER *h )
{
	/* tbVobt@OɃf[^	*/
	flashBufferWrite( FLASH_BUFFER1 ,0 );
	flashWriteBLOCK( h ,sizeof(FLASH_FS_HEADER) );
	for ( uint16_t offset = sizeof(FLASH_FS_HEADER) ;offset < 512 ;offset++ ) {
		flashWriteBYTE( 0x00 );
	}
	FLASH_DISABLE_CS();

	/* tbVy[Wɏ				*/
	flashBufferToPage( FLASH_BUFFER1 ,HEADER_PAGE );
	
	/* RyA								*/
	return ( flashComparePageToBuffer( FLASH_BUFFER1 ,HEADER_PAGE ) );
}

/*****************************************************************************
*					tbVt@CVXewb_Ǎ
* FFLASH_FS_HEADER *h
* ߒlFvoid
*****************************************************************************/
static void flashFs_readHeader( FLASH_FS_HEADER *h )
{
	flashContinuousArrayRead( HEADER_PAGE ,0 );
	flashReadBLOCK( h ,sizeof( FLASH_FS_HEADER ) );
	FLASH_DISABLE_CS();
}

/*****************************************************************************
*				tbVt@CVXewCfbNX񏑍
* Fuint16_t      index CfbNXԍ(0`)
*       FLASH_FS_INFO *info CfbNX
* ߒlFuinr8_t             0:OK !0:NG
*****************************************************************************/
static uint8_t flashFs_writeIndex( uint16_t index ,FLASH_FS_INFO *info )
{
	uint16_t page;
	uint16_t offset;

	page = INDEX_PAGE + ( index / INDEXS_PER_PAGE );
	offset = ( index % INDEXS_PER_PAGE ) * sizeof(FLASH_FS_INFO);

	flashPageToBuffer( FLASH_BUFFER1 ,page );		/* Yy[WǍ		*/

	flashBufferWrite( FLASH_BUFFER1 ,offset );		/* YCfbNXXV	*/
	flashWriteBLOCK( info ,sizeof(FLASH_FS_INFO) );
	FLASH_DISABLE_CS();

	flashBufferToPage( FLASH_BUFFER1 ,page );		/* y[W			*/

	return ( flashComparePageToBuffer( FLASH_BUFFER1 ,page ) ); /* RyA	*/
}
