/*###########################################################################
#                                                                           #
#  			             OtBbNCu								#
#                                                                           #
###########################################################################*/
#ifndef __GRAPHIC_H__
#define __GRAPHIC_H__

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "EGO028Q02.h"
#include "fonts.h"

#define BG_MAX 4							/* wi摜ő吔				*/
#define IMAGE_MAX 256						/* ACR摜ő吔			*/

/* BG摜i[t@CCfbNXԍ	*/
#define FL_BG_START ( FL_FONT_START + ( FONT_COUNT_MAX * 2 ) )
#define FL_IMG_START ( FL_BG_START + BG_MAX )

/* XyAi\pp[^		*/
//#define SP_BG_COLOR RGB(31,11,83)			/* XyAiwiF				*/
#define SP_BG_COLOR RGB(0,0,0)				/* XyAiwiF				*/
#define SP_COUNT 14     					/* XyAif[^								*/
#define SP_WIDTH 6							/* XyAi\(ۂ̓Mbv+1ƂȂ)		*/
#define SP_HEIGHT 31						/* ύXs!!									*/

/* 摜\[h				*/
#define G_OPAQUE 0x00						/* C[Ŵ܂ܕ`						*/
#define G_HALF_ALL 0x81	 					/* SsNZ𔼓`						*/
#define G_TRANSPARENT 0x82					/* wF𓧖ŕ` / ̑̐Fʏ`	*/
#define G_HALF 0x83		 					/* wF𓧖ŕ` / ̑̐F𔼓`	*/
typedef uint8_t G_DRAWMODE;

/* BG(wi)ݒl				*/
typedef enum {
	G_BGMODE_COLOR ,						/* wFwiFƂ			*/
	G_BGMODE_IMAGE 							/* w摜wiƂ			*/
} G_BGMODE;

/* eLXgXN[\\	*/
typedef struct G_SCROLL_t {
	G_DRAWMODE mode;
	uint8_t fontNum;						/* tHgԍ								*/
	uint16_t fontColor;						/* \tHgF						*/
	uint16_t bgColor;
	uint8_t enable;							/* 0: 1:L							*/
	uint8_t xposOffset;						/* 擪tHg̉ItZbgl			*/
	uint16_t x ,y;								/* \GA̍W						*/
	uint16_t x1 ,x2;							/* \GA̍[^E[XW				*/
	uint8_t fontWidth;						/* \tHg̉						*/
	uint16_t code;							/* ݕ\̐擪R[h				*/
	char *s;								/* \ւ̃|C^					*/
	char *ss;								/* \Jnւ̃|C^					*/
} G_SCROLL;

#ifndef NA
#define NA 0
#endif

/* ֐vg^Cv錾			*/
void g_init( void );
void g_images_init( void );
void g_off( void );
void g_on( void );
void g_setBrightness( uint8_t lv );
uint8_t g_setBgColor( G_BGMODE mode ,uint16_t color );
void g_cls( void );
void g_pset( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t color );
void g_line( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color );
void g_box( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color );
void g_boxF( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color );
void g_circle( G_DRAWMODE mode ,uint16_t x0, uint16_t y0, uint8_t r, uint16_t color );
void g_image( uint16_t index ,G_DRAWMODE mode ,uint16_t color ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 );
void g_puts( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,char *str ,uint16_t fColor ,uint16_t bColor );
void g_puts_P( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,const prog_char *str ,uint16_t fColor ,uint16_t bColor );
void g_scrollFirst( G_DRAWMODE mode ,uint8_t fontNum ,G_SCROLL *sp ,uint16_t x ,uint16_t y ,uint16_t xclip ,char *str ,uint16_t fColor ,uint16_t bColor );
void g_scrollNext( G_SCROLL *sp );
void g_drawSpectrum( uint16_t *dat ,G_DRAWMODE  mode ,uint16_t x ,uint16_t y );

#endif
