/*###########################################################################
#                                                                           #
#                              CW[                             #
#                                                                           #
###########################################################################*/
#define __MAIN_C__
#include "project.h"

/* Timer3 EGCgpɎgp		*/
#define TIMER_NUM 3
#include "MYUTIL/timer.h"

/* gpUSART|[g`				*/
#define GLCD_PORT 1						/* USART gp|[gԍ 0 or 1		*/
#define GLCD_BAUD ( 500L * 1000L )		/* USARTʐMx					*/

#define BUTTON_MAX 50					/* o^\{^(keys.h̒萔킹邱	*/

/* obt@TCY`				*/
#define TELOP_TEXT_BUFFER_SIZE 1030		/* ebveLXgobt@TCY	*/
#define RX_BUFFER_SIZE 1080				/* Mobt@TCY				*/
#define TEXT_BUFFER_SIZE 520			/* Mobt@TCY			*/

/* USART|[g`				*/
#if ( GLCD_PORT == 0 )
#define UBRR  UBRR0
#define UCSRA UCSR0A
#define UCSRB UCSR0B
#define UDRE  UDRE0
#define UDR   UDR0
#define TXC   TXC0
#define RXC   RXC0
#define RXEN  RXEN0
#define TXEN  TXEN0
#define RXCIE RXCIE0
#define U2X   U2X0

#elif ( GLCD_PORT == 1 )
#define UBRR  UBRR1
#define UCSRA UCSR1A
#define UCSRB UCSR1B
#define UDRE  UDRE1
#define UDR   UDR1
#define TXC   TXC1
#define RXC   RXC1
#define RXEN  RXEN1
#define TXEN  TXEN1
#define RXCIE RXCIE1
#define U2X   U2X1
#endif

/* ACK/NAK萔						*/
#define ACK 0x06
#define NAK 0x15

/* USART Mݐ				*/
#define USART_ENABLE() ( UCSRB |= _BV(RXCIE) )
#define USART_DISABLE() ( UCSRB &= ~_BV(RXCIE) )

/* ^C~OJEgl				*/
#define TIMER1_MS10_COUNT ( (uint16_t)( ( F_CPU / 256L ) / 100L ) )	/* 256 10msec	*/
#define TIMER2_MS1_COUNT ( (uint16_t)( ( F_CPU / 256L ) / 1000L ) )	/* 256 1msec	*/

/* ebv\				*/
static struct {
	G_SCROLL sp;
	char telopBuf[TELOP_TEXT_BUFFER_SIZE];
	uint8_t telopEnable;
	uint8_t telopInterval;
	volatile uint8_t telopTimer;
} telopInfo;

/* XyAi\				*/
static struct {
	uint16_t spVal[SP_COUNT];
	uint16_t spX;
	uint16_t spY;
	G_DRAWMODE spMode;
	uint8_t spInterval;
	uint8_t spEnable;
	volatile uint8_t spTimer;
} spInfo;

/* O[oϐ					*/
FATFS fs;

/* ^b`pl{^		*/
static uint8_t buttonBuffer[ sizeof(BUTTON_LIST) + sizeof(BUTTON) * BUTTON_MAX ];
static char buttonTextBuffer[1024];					/* {^eLXgobt@	*/
static uint16_t freeButtonTextSize = sizeof( buttonTextBuffer );
static char *pButtonText = buttonTextBuffer;
BUTTON_LIST *_pBtl = (BUTTON_LIST *)buttonBuffer;

/* USART Mobt@Ǘϐ		*/
static uint8_t rxBuf[RX_BUFFER_SIZE];				/* Mobt@{			*/
static uint8_t *wp;									/* Cg|C^			*/
static uint8_t *rp;									/* [h|C^			*/
static uint8_t *endPoint;							/* Mobt@ŏIʒu		*/
static volatile uint16_t rxUsed;					/* Mf[^				*/

static volatile uint8_t tickMs10 = 0;				/* 10mseco߃tO			*/

static BUTTON *touchButton = NULL;					/* ݃^b`Ă{^\	*/

/* [J֐vg^Cv錾		*/
static void hardwareInit( void );

static void usart_send_byte( uint8_t c );
static void usart_send_word( uint16_t w );
static void usart_send_string( char *str );

static uint8_t rx_read_byte( void );
static uint16_t rx_read_word( void );
static void rx_read_string( uint16_t size ,char *str );

static void command( void );

#if ( DEMO == 0 )
static uint8_t wait_init( void );
#endif

/*****************************************************************************
*							USART1 M
*****************************************************************************/
ISR( SIG_USART1_RECV )
{
	if ( rxUsed < RX_BUFFER_SIZE ) {
		*wp++ = UDR;
		rxUsed++;
		if ( wp > endPoint ) wp = rxBuf;
	} else {
		lcdPuts_P( 0 ,0 ,PSTR(" USART buffer over flow ") ,RGB( 255 ,0 ,0 ) );
		lcdSetBrightness( 200 );
		while ( 1 );
	}
}

/*****************************************************************************
*						timer1(16bit)ɂ10msec̊荞
*								VXe^C}[
*****************************************************************************/
ISR( SIG_OUTPUT_COMPARE1A ,ISR_NOBLOCK )		/* USART̎M肱ڂȂׂɕKv	*/
{
	/* timer1ɂ鑽d荞݋֎~		*/
	TIMSK1 &= ~_BV(OCIE1A);

	tickMs10 = 1;

	/* ebv^C}[					*/
	if ( telopInfo.telopTimer ) {
		telopInfo.telopTimer--;
	}

	/* XyAi^C}[					*/
	if ( spInfo.spTimer ) {
		spInfo.spTimer--;
	}

	/* timer1݋					*/
	TIMSK1 |= _BV(OCIE1A);
}

/*****************************************************************************
*						timer2(8bit)ɂ1msec̊荞
*								^b`pl|[O
*****************************************************************************/
ISR( SIG_OUTPUT_COMPARE2A ,ISR_NOBLOCK )		/* USART̎M肱ڂȂׂɕKv	*/
{
	/* timer2ɂ鑽d荞݋֎~		*/
	TIMSK2 &= ~_BV(OCIE2A);

	/* ^b`pl|[O			*/
	touct_poll();

	/* timer2݋					*/
	TIMSK2 |= _BV(OCIE2A);
}

/*****************************************************************************
*								AVR
*@Fvoid
*@ߒlFvoid
*****************************************************************************/
static void hardwareInit( void )
{
	/* d̓Jbg											*/
	ACSR = _BV(ACD);							/* AiORp[^d͒~	*/

	/* 	PortA +--------7: ZHI    : AD7											*/
	/*        |+-------6: ZHI    : AD6											*/
	/*        ||+------5: ZHI    : AD5											*/
	/*        |||+-----4: ZHI    : AD4											*/
	/*        ||||+----3: ZHI    : AD3											*/
	/*        |||||+---2: ZHI    : AD2	 										*/
	/*        ||||||+--1: ZHI    : AD1											*/
	/*        |||||||+-0: ZHI    : AD0											*/
	DDRA  = 0b00000000;
	PORTA = 0b00000000;

	/* 	PortB +--------7:Out(H) : LCD #BACK-LIGHT								*/
	/*        |+-------6:Out(L)	: LCD #RESET									*/
	/*        ||+------5:Out(L) : FLSAH #CS										*/
	/*        |||+-----4:Out(L) : FLASH #RESET									*/
	/*        ||||+----3:ZHI    : SD-CARD SO									*/
	/*        |||||+---2:Out(H) : SD-CARD SI									*/
	/*        ||||||+--1:Out(L) : SD-CARD SCK 									*/
	/*        |||||||+-0:Out(H) : SD-CARD #CS									*/
	DDRB  = 0b11110111;
	PORTB = 0b10000101;

	/* 	PortC +--------7: ZHI    : AD15											*/
	/*        |+-------6: ZHI    : AD14											*/
	/*        ||+------5: ZHI    : AD13											*/
	/*        |||+-----4: ZHI    : AD12											*/
	/*        ||||+----3: ZHI    : AD11											*/
	/*        |||||+---2: ZHI    : AD10	 										*/
	/*        ||||||+--1: ZHI    : AD9											*/
	/*        |||||||+-0: ZHI    : AD8											*/
	DDRC  = 0b00000000;
	PORTC = 0b00000000;

	/* 	PortD +--------7: Pullup :                                              */
	/*        |+-------6: Pullup :                                              */
	/*        ||+------5: Pullup :                                              */
	/*        |||+-----4: Pullup :                                              */
	/*        ||||+----3: Pullup :                                              */
	/*        |||||+---2: Pullup :                                              */
	/*        ||||||+--1: Pullup :                                              */
	/*        |||||||+-0: Pullup :                                              */
	DDRD  = 0b00000000;
	PORTD = 0b11111111;

	/* 	PortE +--------7: Pullup : NC											*/
	/*        |+-------6: Pullup : NC											*/
	/*        ||+------5: Pullup : NC											*/
	/*        |||+-----4: Pullup : NC											*/
	/*        ||||+----3: Pullup : NC											*/
	/*        |||||+---2: Out(L) : FLSAH SCLK									*/
	/*        ||||||+--1: Out(H) : FLASH SI          							*/
	/*        |||||||+-0: ZHI    : FLASH SO            							*/
	DDRE  = 0b00000110;
	PORTE = 0b11111010;

	/* 	PortF +--------7: Pullup : NC											*/
	/*        |+-------6: Pullup :                                              */
	/*        ||+------5: Pullup :                                              */
	/*        |||+-----4: Pullup : NC											*/
	/*        ||||+----3: Pullup : X+											*/
	/*        |||||+---2: Pullup : Y+											*/
	/*        ||||||+--1: Pullup : X-											*/
	/*        |||||||+-0: Pullup : Y-											*/
	DDRF  = 0b00000000;
	PORTF = 0b11111111;

	/* 	PortG +--------7: Pullup : ----											*/
	/*        |+-------6: Pullup : ----											*/
	/*        ||+------5: Pullup : NC											*/
	/*        |||+-----4: Pullup : NC											*/
	/*        ||||+----3: Pullup : NC											*/
	/*        |||||+---2: ZHI    : ALE											*/
	/*        ||||||+--1: ZHI    : #WR											*/
	/*        |||||||+-0: ZHI    : #RD											*/
	DDRG  = 0b00000000;
	PORTG = 0b11110000;

	/* C^[tF[X		*/
//	XMCRA = 0b11001111;									/* 2WAIT				*/
//	XMCRA = 0b11000101;									/* 1WAIT				*/
	XMCRA = 0b11000000;									/* 0WAIT				*/
	XMCRB = 0;

	/*	^C}[1(16bit)ݒ VXe^C}[(10msec)	*/
	TCCR1A = _BV(WGM11);								/* CTC				*/
	TCCR1B = 0x04;										/* F_CPU / 256			*/
	OCR1A = TIMER1_MS10_COUNT;
	TIMSK1 = _BV(OCIE1A);

	/*	^C}[2(8bit)ݒ ^b`plp(1msec)		*/
	TCCR2A = _BV(WGM21);								/* CTC				*/
	TCCR2B = 0x06;										/* F_CPU / 256			*/
	OCR2A = TIMER2_MS1_COUNT;
	TIMSK2 = _BV(OCIE2A);

	/* LCD						*/
	g_init();
	lcdPuts_P( 0 ,0 ,PSTR("GLCD system start") ,RGB( 0 ,255 ,0 ) );

	/* VAtbV			*/
	if ( flashInit() != 0 ) {
		lcdPuts_P( 0 ,16 ,PSTR("serial flash init error !!") ,RGB( 255 ,0 ,0 ) );
		while ( 1 );
	}

	/* O[oC^vgL		*/
	sei();

	/* ^b`pl				*/
	touch_init();

	/* e탂W[				*/
	system_init();
}

/*****************************************************************************
*									C
*****************************************************************************/
int main( void )
{
	uint8_t demo = 0;
	POINT pos;
	BUTTON *btn;

	/* ϐNA							*/
	memset( &spInfo ,0x00 ,sizeof(spInfo) );
	memset( &telopInfo ,0x00 ,sizeof(telopInfo) );

	_pBtl->count = 0;
	pButtonText = buttonTextBuffer;
	freeButtonTextSize = sizeof( buttonTextBuffer );

	/* VXe						*/
	hardwareInit();

	/* zXg҂						*/
	#if ( DEMO == 0 )
		if ( wait_init() != 0 ) {
			demo = 1;
		}
	#else
		demo = 1;
	#endif

	/* f[hp					*/
	if ( demo ) {
		char msg[64] ,txt[64];
		uint8_t ret;
		G_DRAWMODE gmode;

		strcpy_P( txt ,PSTR("") );
		while ( 1 ) {
			g_off();
			if ( g_setBgColor( G_BGMODE_IMAGE ,1 ) == 0 ) {
				gmode = G_HALF_ALL;
				g_boxF( G_HALF_ALL ,0 ,0 ,DISPLAY_WIDTH - 1 ,DISPLAY_HEIGHT - 1 ,0x0000 );
			} else {
				gmode = G_OPAQUE;
			}
			g_on();

			lcdPuts_P( 0 ,0 ,PSTR("GLCD ILI9325 DEMO MODE") ,RGB( 255 ,255 ,0 ) );
			strcpy_P( msg ,PSTR("̓{bNXfXg[V") );
			ret = inputBox( gmode ,msg ,txt );
			lcdClear();
			if ( ret == 0 ) {
				strcpy_P( txt ,PSTR("OK") );
			} else {
				strcpy_P( txt ,PSTR("CANCEL") );
			}
			WAIT_MS( 250 );
		}
	}

	/* C							*/
	while ( 1 ) {

		/* {^^b`|[O			*/
		if ( tickMs10 ) {
			tickMs10 = 0;

			/* {^^b``FbN			*/
			btn = NULL;
			if ( touchGetPos( &pos.x ,&pos.y ) ) {
				btn = button_get( _pBtl ,&pos );
			}

			if ( btn == NULL ) {					/* ^b`H		*/
				if ( touchButton != NULL ) {
					button_draw( touchButton ,OFF );
					touchButton = NULL;
				}
			} else {								/* ^b`H			*/
				if ( touchButton == NULL ) {
					button_draw( btn ,ON );
					touchButton = btn;

					/* USARTփbZ[WM	*/
					usart_send_byte( 0x02 );
					usart_send_byte( (uint8_t)btn->code );
					usart_send_byte( (uint8_t)~btn->code );
				}
			}
		}

		/* ebv\						*/
		if ( telopInfo.telopEnable && !telopInfo.telopTimer ) {
			telopInfo.telopTimer = telopInfo.telopInterval;
			g_scrollNext( &telopInfo.sp );

		/* XyAi\						*/
		} else if ( spInfo.spEnable && !spInfo.spTimer ) {
			spInfo.spTimer = spInfo.spInterval;
			g_drawSpectrum( spInfo.spVal ,spInfo.spMode ,spInfo.spX ,spInfo.spY );
		}

		/* R}hs						*/
		command();
	}

	return ( 0 );
}

/*****************************************************************************
*							USART1oCgM
* Fuint8_t c
* ߒlFvoid
*****************************************************************************/
static void usart_send_byte( uint8_t c )
{
	while ( !( UCSRA & _BV(UDRE) ) );
	UDR = c;
}

/*****************************************************************************
*					USARTփ[hM(gGfBA)
* Fuint16_t w
* ߒlFvoid
*****************************************************************************/
static void usart_send_word( uint16_t w )
{
	usart_send_byte( (uint8_t)w );
	usart_send_byte( (uint8_t)( w >> 8 ) );
}

/*****************************************************************************
*							USART֕񑗐M
* Fchar *str
* ߒlFvoid
*****************************************************************************/
static void usart_send_string( char *str )
{
	do {
		usart_send_byte( *str );
	} while ( *str++ );
}

/*****************************************************************************
*							Mobt@1oCg擾
* Fvoid
* ߒlFuint8_t
*****************************************************************************/
static uint8_t rx_read_byte( void )
{
	/* M҂					*/
	TIMER_SET_TIMEOUT( 100 );
	do {
		if ( rxUsed ) break;
	} while ( !TIMER_IS_TIMEOUT() );
	TIMER_STOP();

	uint8_t c = 0;
	USART_DISABLE();
	if ( rxUsed ) {
		c = *rp++;
		if ( rp > endPoint ) rp = rxBuf;
		rxUsed--;
	} else {
		wp = rp = rxBuf;
		rxUsed = 32;
		wp += 32;
		memset( rxBuf ,0x00 ,32 );
	}
	USART_ENABLE();

	return ( c );
}

/*****************************************************************************
*					Mobt@烏[h擾(gGfBA)
* Fvoid
* ߒlFuint16_t
*****************************************************************************/
static uint16_t rx_read_word( void )
{
	uint16_t val = (uint16_t)rx_read_byte();
	val |= ( (uint16_t)rx_read_byte() << 8 );
	return ( val );
}

/*****************************************************************************
*							Mobt@當擾
* Fuint16_t size obt@TCY
*		char     *str obt@
* ߒlFvoid
*****************************************************************************/
static void rx_read_string( uint16_t size ,char *str )
{
	char c;
	do {
		c = rx_read_byte();
		if ( size > 1 ) {
			*str++ = c;
			size--;
		}
	} while ( c != '\0' );
	*str = '\0';
}

#if ( DEMO == 0 )
/*****************************************************************************
*							zXg̏R}h҂
* Fvoid
* ߒlFuint8_t 0:OK !0:Timeout(3b)
*****************************************************************************/
static uint8_t wait_init( void )
{
	uint32_t baud = 0L;
	char txt[8];

	UCSRB = 0;

	/* Mobt@					*/
	wp = rp = rxBuf;
	rxUsed = 0;
	endPoint = rxBuf + RX_BUFFER_SIZE - 1;

	/* USARTݒ(1200bps)					*/
	UBRR = (uint16_t)( F_CPU / ( 16UL * 1200 ) ) - 1;
	UCSRB = _BV(RXEN) | _BV(TXEN);
	USART_ENABLE();

	/* zXg̏R}h 'U' ҂	*/
	TIMER_SET_TIMEOUT( 3000 );
	while ( !TIMER_IS_TIMEOUT() ) {
		if ( ( rxUsed == 0 ) || ( rx_read_byte() != 'U' ) ) continue;
		rx_read_string( sizeof(txt) ,txt );
		baud = atol( txt );
		if ( ( baud >= 1200L ) && ( baud <= 1000000L ) ) {
			usart_send_byte( 0x03 );
			usart_send_byte( 0x06 );
			usart_send_byte( 0xf3 );
			break;
		}
	}
	TIMER_STOP();

	/* USARTݒ							*/
	if ( baud ) {
		WAIT_MS( 50 );
		UBRR = (uint16_t)( ( F_CPU / ( 16UL * (uint32_t)baud ) ) ) - 1;
		UCSRB = _BV(RXCIE) | _BV(RXEN) | _BV(TXEN);
		return ( 0 );
	}

	UCSRB = 0;
	return ( 1 );
}
#endif // if ( DEMO == 0 )

/*****************************************************************************
*								R}h
* Fvoid
* ߒlFvoid
*****************************************************************************/
void command( void )
{
	if ( rxUsed == 0 ) return;					/* Mf[^H			*/
	uint8_t cmd = rx_read_byte();				/* R}h擾				*/

	/* R}h 'A'F`					*/
	if ( cmd == 'A' ) {
		uint8_t mode = rx_read_byte();
		uint8_t fontNum = rx_read_byte();
		uint16_t x = rx_read_word();
		uint16_t y = rx_read_word();
		uint16_t fc = rx_read_word();
		uint16_t bc = rx_read_word();
		char txt[TEXT_BUFFER_SIZE];
		rx_read_string( sizeof(txt) ,txt );
		g_puts( mode ,fontNum ,x ,y ,txt ,fc ,bc );

	/* R}h 'B'FʋPxݒ				*/
	} else if ( cmd == 'B' ) {
		uint8_t lv = rx_read_byte();
		g_setBrightness( lv );

	/* R}h 'C'FʃNA					*/
	} else if ( cmd == 'C' ) {
		touchButton = NULL;
		g_cls();

	/* R}h 'D'Febv񏉊\		*/
	} else if ( cmd == 'D' ) {
		uint8_t mode = rx_read_byte();
		uint8_t fontNum = rx_read_byte();
		uint8_t interval = rx_read_byte();
		uint16_t x = rx_read_word();
		uint16_t y = rx_read_word();
		uint16_t clip = rx_read_word();
		uint16_t fc = rx_read_word();
		uint16_t bc = rx_read_word();
		rx_read_string( sizeof(telopInfo.telopBuf) ,telopInfo.telopBuf );
		FONT *fnt = font_getImage( fontNum ,' ' ,NULL );
		g_boxF( mode ,x ,y ,clip ,y + fnt->ysize + 3 ,bc );
		g_scrollFirst( mode ,fontNum ,&telopInfo.sp ,x ,y + 2 ,clip ,telopInfo.telopBuf ,fc ,bc );
		telopInfo.telopInterval = interval;
		telopInfo.telopEnable = 0;

	/* R}h 'E'FebvJn / ~		*/
	} else if ( cmd == 'E' ) {
		telopInfo.telopEnable = rx_read_byte();
		telopInfo.telopTimer = telopInfo.telopInterval;

	/* R}h 'F'FON						*/
	} else if ( cmd == 'F' ) {
		touchButton = NULL;
		g_on();

	/* R}h 'G'FOFF					*/
	} else if ( cmd == 'G' ) {
		touchButton = NULL;
		g_off();

	/* R}h 'H'F{^o^					*/
	} else if ( cmd == 'H' ) {
		touchButton = NULL;
		BUTTON bt ,*pb;
		char buf[48];
		bt.code = rx_read_byte();				/* 1`						*/
		bt.mode = rx_read_byte();
		bt.fontNum = rx_read_byte();
		bt.rect.x1 = rx_read_word();
		bt.rect.y1 = rx_read_word();
		bt.rect.x2 = rx_read_word();
		bt.rect.y2 = rx_read_word();
		bt.fcColor = rx_read_word();
		bt.bgColor = rx_read_word();
		bt.txt = NULL;
		rx_read_string( sizeof(buf) ,buf );

		uint16_t len = strlen( buf );
		if ( len && ( ( len + 1 ) <= freeButtonTextSize ) ) {
			bt.txt = pButtonText;
			strcpy( pButtonText ,buf );
			pButtonText += ( len + 1);
			freeButtonTextSize -= ( len + 1 );
		}

		if ( _pBtl->count < BUTTON_MAX ) {
			pb = &_pBtl->keys[_pBtl->count++];
			memcpy( pb ,&bt ,sizeof(BUTTON) );
		}

	/* R}h 'I'FtbVC[W`	*/
	} else if ( cmd == 'I' ) {
		uint16_t index = rx_read_word();
		uint8_t mode = rx_read_byte();
		uint16_t keyColor = rx_read_word();
		uint16_t x1 = rx_read_word();
		uint16_t y1 = rx_read_word();
		uint16_t x2 = rx_read_word();
		uint16_t y2 = rx_read_word();
		g_image( index ,mode ,keyColor ,x1 ,y1 ,x2 ,y2 );

	/* R}h 'J'Fw{^\				*/
	} else if ( cmd == 'J' ) {
		touchButton = NULL;
		uint8_t index = rx_read_byte();				/* 1`						*/
		uint8_t sw = rx_read_byte();
		if ( index && ( index <= _pBtl->count ) ) {
			button_draw( &_pBtl->keys[ index - 1 ] ,sw );
		}

	/* R}h 'K'F{^S\				*/
	} else if ( cmd == 'K' ) {
		touchButton = NULL;
		for ( uint8_t i = 0 ;i < _pBtl->count ;i++ ) {
			button_draw( &_pBtl->keys[ i ] ,OFF );
		}

	/* R}h 'L'F`					*/
	} else if ( cmd == 'L' ) {
		uint8_t mode = rx_read_byte();
		uint16_t x1 = rx_read_word();
		uint16_t y1 = rx_read_word();
		uint16_t x2 = rx_read_word();
		uint16_t y2 = rx_read_word();
		uint16_t color = rx_read_word();
		g_line( mode ,x1 ,y1 ,x2 ,y2 ,color );

	/* R}h 'M'F{^o^NA			*/
	} else if ( cmd == 'M' ) {
		touchButton = NULL;
		_pBtl->count = 0;
		pButtonText = buttonTextBuffer;
		freeButtonTextSize = sizeof( buttonTextBuffer );

	/* R}h 'N'F^b`pl擾		*/
	} else if ( cmd == 'N' ) {
		uint16_t x ,y;
		uint8_t touch = touchGetPos( &x ,&y );
		usart_send_byte( touch );
		usart_send_word( x );
		usart_send_word( y );

	/* R}h 'O'FbZ[W{bNX		*/
	} else if ( cmd == 'O' ) {
		char txt[TEXT_BUFFER_SIZE];
		if ( touchButton != NULL ) {
			button_draw( touchButton ,OFF );
			touchButton = NULL;
		}
		uint8_t mode = rx_read_byte();
		uint8_t fontNum = rx_read_byte();
		uint8_t option = rx_read_byte();
		rx_read_string( sizeof(txt) ,txt );
		uint8_t ret = msgBox( mode ,fontNum ,txt ,option );
		usart_send_byte( ret );

	/* R}h 'P'FʃTCY擾				*/
	} else if ( cmd == 'P' ) {
		usart_send_word( DISPLAY_WIDTH );
		usart_send_word( DISPLAY_WIDTH );

	/* R}h 'Q'F{bNX`				*/
	} else if ( cmd == 'Q' ) {
		uint8_t mode = rx_read_byte();
		uint16_t x1 = rx_read_word();
		uint16_t y1 = rx_read_word();
		uint16_t x2 = rx_read_word();
		uint16_t y2 = rx_read_word();
		uint16_t color = rx_read_word();
		g_box( mode ,x1 ,y1 ,x2 ,y2 ,color );

	/* R}h 'R'F~`						*/
	} else if ( cmd == 'R' ) {
		uint8_t mode = rx_read_byte();
		uint16_t x = rx_read_word();
		uint16_t y = rx_read_word();
		uint16_t r = rx_read_word();
		uint16_t color = rx_read_word();
		g_circle( mode ,x ,y ,r ,color );

	/* R}h 'S'FXyAi`񏉊		*/
	} else if ( cmd == 'S' ) {
		spInfo.spMode = rx_read_byte();
		spInfo.spInterval = rx_read_byte();
		uint16_t x1 = rx_read_word();
		uint16_t y1 = rx_read_word();
		spInfo.spX = x1 + 2;
		spInfo.spY = y1 + 2;
		spInfo.spEnable = 0;
		memset( spInfo.spVal ,0x00 ,sizeof(spInfo.spVal) );

		uint16_t x2 = x1 + ( ( SP_WIDTH + 1 ) * SP_COUNT ) + 2;
		uint16_t y2 = y1 + SP_HEIGHT + 3;
		if ( ( spInfo.spMode & 0x07 ) == 0 ) {	/* \̈NA			*/
			g_boxF( G_OPAQUE ,x1 ,y1 ,x2 ,y2 ,SP_BG_COLOR );
		} else {
			g_boxF( G_HALF_ALL ,x1 ,y1 ,x2 ,y2 ,SP_BG_COLOR );
		}

	/* R}h 'T'FXyAif[^XV			*/
	} else if ( cmd == 'T' ) {
		for ( uint8_t i = 0 ;i < SP_COUNT ;i++ ) {
			spInfo.spVal[ i ] = rx_read_word();
		}

	/* R}h 'V'F^b`plLu[g	*/
	} else if ( cmd == 'V' ) {
		touchButton = NULL;
		touch_calibration();

	/* R}h 'W'FXyAiXVJn^~		*/
	} else if ( cmd == 'W' ) {
		spInfo.spEnable = rx_read_byte();
		spInfo.spTimer = spInfo.spInterval;

	/* R}h 'X'FhԂ{bNX			*/
	} else if ( cmd == 'X' ) {
		uint8_t mode = rx_read_byte();
		uint16_t x1 = rx_read_word();
		uint16_t y1 = rx_read_word();
		uint16_t x2 = rx_read_word();
		uint16_t y2 = rx_read_word();
		uint16_t color = rx_read_word();
		g_boxF( mode ,x1 ,y1 ,x2 ,y2 ,color );

	/* R}h 'Y'FwiύX					*/
	} else if ( cmd == 'Y' ) {
		uint8_t mode = rx_read_byte();
		uint16_t color = rx_read_word();
		g_setBgColor( mode ,color );

	/* R}h 'Z'F\tgL[{[g(p)		*/
	} else if ( cmd == 'Z' ) {
		char msg[64];
		char val[26];
		if ( touchButton != NULL ) {
			button_draw( touchButton ,OFF );
			touchButton = NULL;
		}
		uint8_t mode = rx_read_byte();
		rx_read_string( 64 ,msg );
		rx_read_string( 26 ,val );
		uint8_t ret = inputBox( mode ,msg ,val );

		usart_send_byte( ret );
		usart_send_string( val );

	/* R}h 'a'FS-JISϊ			*/
	} else if ( cmd == 'a' ) {
		char buf[TEXT_BUFFER_SIZE] ,*p = buf;
		uint16_t len = 0;
		uint8_t zero = 0;
		uint16_t pr = rx_read_word();
		while ( zero < 3 ) {
			uint8_t c = rx_read_byte();
			if ( c ) {
				zero = 0;
			} else {
				zero++;
			}

			if ( len < TEXT_BUFFER_SIZE - 3 ) {
				*p++ = c;
				len++;
			}
		}
		memset( p ,0x00 ,3 );

		uint8_t ret = unicode_ConvSJIS( buf ,pr );
		usart_send_byte( ret );
		if ( ret != CODE_NONE ) {
			usart_send_string( buf );
		}

	/* sȃR}hFobt@NA			*/
	} else {
		USART_DISABLE();
		wp = rp = rxBuf;
		rxUsed = 0;
		USART_ENABLE();
		return;
	}

	/* ACK									*/
	usart_send_byte( 0x03 );
	usart_send_byte( 0x06 );
	usart_send_byte( 0xf3 );
}
