/*###########################################################################
#																			#
#     		4^b`pl䃂W[						            #
#                       LCDW[uEGO028Q02vp				        #
#                                                                           #
#  PF0 : Y- / PF1 : X- / PF2 : Y+ / PF3 : X+			 					#
#  e|[gɂ10K̃v_ERڑ̂                              #
#  PF0PF10.01F̃RfTGNDƐڑƃmCYϐシ		#
#                                                                           #
#  AiO|[gFׂ͂ăAiO̓|[gƂ                        #
#                                                                           #
#  QljOp`Ap`ɂܔ聙                                   #
#        http://www5d.biglobe.ne.jp/~tomoya03/shtml/algorithm/Hougan.htm    #
###########################################################################*/
#define __TOUCH_C__
#include <math.h>
#include "project.h"

#define DEBUG 0

/* Timer3 EGCgpɎgp		*/
#define TIMER_NUM 3
#include "myutil/timer.h"

#define TOUCH_WAIT_TIME 25				/* ^b`AbvE_Eo(ms)	*/
#define OFFSET 4						/* ^b`LWItZbg			*/

/* ^b`pl␳l\̕ۑEEPAhX	*/
#define CALIBRATION_ADDR 0x0000

/* ^b`pl␳l\		*/
typedef struct TOUCH_CALIBRATION_t {
	uint16_t lcdScreenMode;
	struct {
		POINT pos[4];
	} rect[16];
} TOUCH_CALIBRATION;

/* X,Y̎擾p|[gݒ}N	*/
#if ( LCD_ZERO_POSITION == __LCD_POSITION_UP__ )
#define SET_AD_X() { DDRF = 0b00001010; PORTF = 0b11110010; ADMUX = _BV(REFS0) | _BV(REFS1) | 0x00; }
#define SET_AD_Y() { DDRF = 0b00000101; PORTF = 0b11110001; ADMUX = _BV(REFS0) | _BV(REFS1) | 0x01; }

#elif( LCD_ZERO_POSITION == __LCD_POSITION_DOWN__ )
#define SET_AD_X() { DDRF = 0b00001010;	PORTF = 0b11111000; ADMUX = _BV(REFS0) | _BV(REFS1) | 0x00; }
#define SET_AD_Y() { DDRF = 0b00000101; PORTF = 0b11110100; ADMUX = _BV(REFS0) | _BV(REFS1) | 0x01; }

#elif( LCD_ZERO_POSITION == __LCD_POSITION_LEFT__ )
#define SET_AD_X() { DDRF = 0b00000101;	PORTF = 0b11110001; ADMUX = _BV(REFS0) | _BV(REFS1) | 0x01; }
#define SET_AD_Y() { DDRF = 0b00001010; PORTF = 0b11111000; ADMUX = _BV(REFS0) | _BV(REFS1) | 0x00; }

#elif( LCD_ZERO_POSITION == __LCD_POSITION_RIGHT__ )
#define SET_AD_X() { DDRF = 0b00000101; PORTF = 0b11110100; ADMUX = _BV(REFS0) | _BV(REFS1) | 0x01; }
#define SET_AD_Y() { DDRF = 0b00001010; PORTF = 0b11110010; ADMUX = _BV(REFS0) | _BV(REFS1) | 0x00; }

#else
	#error "unknown LCD_ZERO_POSITION"
#endif

/* [Jϐ錾				*/
static volatile uint8_t flagTouch = 0;			/* ^b`tO				*/
static volatile uint16_t ad_x = 0;				/* X A/Dl					*/
static volatile uint16_t ad_y = 0;				/* Y A/Dl					*/
static TOUCH_CALIBRATION touchCAL;				/* Lu[V		*/

/* [J֐vg^Cv錾	*/
static void get_calibration_posion( uint8_t index ,POINT *pos );
static void drawPoint25( uint8_t *t ,uint8_t n );
static void drawCursor( uint16_t x ,uint16_t y ,uint16_t c );
static uint8_t cnv_screenPos( POINT *ad ,POINT *spos );
static uint8_t intersectM( POINT *p1 ,POINT *p2 ,POINT *p3 ,POINT *p4 );
static uint8_t PosIncludeTriEx( POINT *tp1 ,POINT *tp2 ,POINT *tp3 ,POINT *xp );
static uint16_t yPosLineH( POINT *p1 ,POINT *p2 ,uint16_t x );
static uint16_t xPosLineV( POINT *p1 ,POINT *p2 ,uint16_t y );
static void dispCAL( uint16_t color );

/*****************************************************************************
*						^b`plW[
* Fvoid
* ߒlFvoid
*****************************************************************************/
void touch_init( void )
{
	/* |[gFݒ							*/
	DDRF  = 0b00000000;								/* PORTF ̓[h				*/
	PORTF = 0b11111111;								/* PORTF vAbv				*/
	DIDR0 = 0b11111111;								/* PORTF fW^͋֎~		*/

	/* A/Dϊ						*/
	ADMUX = _BV(REFS0) | _BV(REFS1);				/* VREF = AVCC					*/
	ADCSRA  = 0x03;									/* A/DϊNbN F_CPU / 64	*/
	ADCSRA |= _BV(ADEN) | _BV(ADSC);				/* A/DϊL & ϊ		*/
	while ( ADCSRA & _BV(ADSC) );					/* ϊI܂ő҂		*/

	/* Lu[Vf[^擾			*/
	eeprom_busy_wait();
	eeprom_read_block( &touchCAL ,(void *)CALIBRATION_ADDR + 2 ,sizeof(TOUCH_CALIBRATION) );


	/* Lu[V				*/
#if TOUCH
	touch_calibration();
#else
	/* Lu[Vf[^`FbN		*/
	eeprom_busy_wait();
	uint16_t crc1 = eeprom_read_word( (uint16_t *)CALIBRATION_ADDR );
	uint16_t crc2 = crc16_CalcRAM( &touchCAL ,sizeof(TOUCH_CALIBRATION) );
	if ( ( crc1 != crc2 ) || ( touchCAL.lcdScreenMode != LCD_ZERO_POSITION ) ) {
		touch_calibration();
	}
#endif
}

/*****************************************************************************
*					^b`pl|[Oi1msecɌĂяoj
* Fvoid
* ߒlFvoid
*****************************************************************************/
void touct_poll( void )
{
	static uint8_t step_ad = 0;
	static uint8_t step_touching = 0;
	static uint8_t countDown = TOUCH_WAIT_TIME;
	static uint16_t bak_ax = 0x1fff;
	static uint16_t bak_ay = 0x1fff;
	static uint16_t ax ,ay;

	/* 1msec^C}[					*/
	if ( countDown ) {
		countDown--;
	}

	/* X A/Dϊ |[gݒ			*/
	if ( step_ad == 0 ) {
		SET_AD_X();
		step_ad = 1;

	/* X A/Dϊ Jn					*/
	} else if ( step_ad == 1 ) {
		ADCSRA |= _BV(ADSC);
		step_ad = 2;

	/* X A/Dϊ I҂				*/
	} else if ( step_ad == 2 ) {
		if ( ( ADCSRA & _BV(ADSC) ) == 0 ) {
			ax = ADC;
			step_ad = 3;
		}

	/* Y A/Dϊ |[gݒ			*/
	} else if ( step_ad == 3 ) {
		SET_AD_Y();
		step_ad = 4;

	/* Y A/Dϊ Jn					*/
	} else if ( step_ad == 4 ) {
		ADCSRA |= _BV(ADSC);
		step_ad = 5;

	/* Y A/Dϊ I҂				*/
	} else if ( step_ad == 5 ) {
		if ( ( ADCSRA & _BV(ADSC) ) == 0 ) {
			step_ad = 0;
			ay = ADC;
		}
	}

	/* ^b`Ԍo					*/
	if ( !step_ad ) {
		if ( ( ax > 15 ) && ( ay > 15 ) ) {					/* ^b`ԁH					*/
			if ( step_touching == 0 ) {						/* ^b`->^b`@ωH		*/
				countDown = TOUCH_WAIT_TIME;				/* ^C}[Zbg				*/
				step_touching = 1;

			} else if ( step_touching == 1 ) {
				if ( ( abs( (int)ax - (int)bak_ax ) >= 3 ) && ( abs( (int)ay - (int)bak_ay ) >= 3 ) ) {
					countDown = TOUCH_WAIT_TIME;

				} else if ( countDown == 0 ) {
					ad_x = ax;
					ad_y = ay;
					step_touching = 0;
					flagTouch = 1;							/* K莞ԁAW̏ꍇA߂ă^b`tO𗧂Ă	*/
				}

				bak_ax = ax;
				bak_ay = ay;
			}

		} else {											/* ^b`̏ꍇAɃ^b`tOZbg		*/
			flagTouch = 0;
			step_touching = 0;
		}
	}
}

/*****************************************************************************
*							^b`plԂ擾
* Fuint16_t *screen_x XW
*		uint16_t *screen_y YW
* ߒlFuint8_t            0:^b` !0:^b`
*****************************************************************************/
uint8_t touchGetPos( uint16_t *sx ,uint16_t *sy )
{
	POINT ad;
	POINT pos;
	uint8_t ret;

	ret = 0;
	if ( flagTouch ) {
		ad.x = ad_x;
		ad.y = ad_y;
		if ( !cnv_screenPos( &ad ,&pos ) ) {
			*sx = pos.x;
			*sy = pos.y;
			ret = 1;
		}
	}

	return ( ret );
}

/*****************************************************************************
*							^b`plW
* Fvoid
* ߒlFvoid
*****************************************************************************/
void touch_calibration( void )
{
	uint8_t sw[25];						/* ͍σtO						*/
	POINT adj[25];
	uint8_t i ,j;
	uint8_t brightness = lcdGetBrightness();
	uint16_t color = lcdGetBgColor();
	uint16_t crc;
	char buf[64];

	memset( sw ,0 ,sizeof(sw) );

	/* \						*/
	lcdSetBrightness( 0 );
	lcdSetBgColor( 0xffff );
	lcdPuts_P( DISPLAY_WIDTH / 2 - 69 ,DISPLAY_HEIGHT / 2 - 36 ,PSTR("screen calibration mode") ,RGB(0,0,0) );
	lcdPuts_P( DISPLAY_WIDTH / 2 - 126 ,DISPLAY_HEIGHT / 2 - 26 ,PSTR("touch the center of the circle is blinking") ,RGB(0,0,0) );
	drawPoint25( sw ,0 );
	lcdSetBrightness( 255 );

	/* ^b`܂ő҂				*/
	while ( flagTouch ) {
		drawPoint25( sw ,0 );
	}

	/* 25|Cg␳Jn			*/
	for ( i = 0 ;i < 25 ;i++ ) {
		TIMER_SET_TIMEOUT( 250 );

		/* ^b`܂ő҂			*/
		while ( !flagTouch ) {
			drawPoint25( sw ,i );
		}

		/* ^b`܂ő҂			*/
		while ( flagTouch ) {
			drawPoint25( sw ,i );
		}

		/* A/Dϊl擾			*/
		adj[ i ].x = ad_x;
		adj[ i ].y = ad_y;
		sw[ i ] = 1;
	}
	TIMER_STOP();

	/* ^b`܂ő҂				*/
	while ( flagTouch ) {
		drawPoint25( sw ,i );
	}
	drawPoint25( sw ,i );

	/* LCD_[hޔ			*/
	touchCAL.lcdScreenMode = LCD_ZERO_POSITION;

	/* ʂPŮelp`A/Dϊle[u쐬	*/
	i = 0;
	for ( uint8_t y = 0 ;y < 4 ;y++ ) {
		for ( uint8_t x = 0 ;x < 4 ;x++ ) {
			j = ( y * 5 ) + x;
			touchCAL.rect[i].pos[0].x = adj[ j + 0 ].x    ; touchCAL.rect[i].pos[0].y = adj[ j + 0 ].y;
			touchCAL.rect[i].pos[1].x = adj[ j + 1 ].x    ; touchCAL.rect[i].pos[1].y = adj[ j + 1 ].y;
			touchCAL.rect[i].pos[2].x = adj[ j + 5 ].x - 1; touchCAL.rect[i].pos[2].y = adj[ j + 5 ].y - 1;
			touchCAL.rect[i].pos[3].x = adj[ j + 6 ].x - 1; touchCAL.rect[i].pos[3].y = adj[ j + 6 ].y - 1;

			if ( ( touchCAL.rect[i].pos[0].x > touchCAL.rect[i].pos[1].x ) ||
			     ( touchCAL.rect[i].pos[0].x > touchCAL.rect[i].pos[3].x ) ||
			     ( touchCAL.rect[i].pos[2].x > touchCAL.rect[i].pos[1].x ) ||
			     ( touchCAL.rect[i].pos[2].x > touchCAL.rect[i].pos[3].x ) ) {
				sprintf_P( buf ,PSTR("xpos error Row %d ,Col %d\n") ,y ,x );
				lcdPuts( 0 ,16 ,buf ,RGB( 255 ,0 ,0 ) );
				while ( 1 );
			}

			if ( ( touchCAL.rect[i].pos[0].y > touchCAL.rect[i].pos[2].y ) ||
			     ( touchCAL.rect[i].pos[0].y > touchCAL.rect[i].pos[3].y ) ||
			     ( touchCAL.rect[i].pos[1].y > touchCAL.rect[i].pos[2].y ) ||
			     ( touchCAL.rect[i].pos[1].y > touchCAL.rect[i].pos[3].y ) ) {
				sprintf_P( buf ,PSTR("ypos error Row %d ,Col %d\n") ,y ,x );
				lcdPuts( 0 ,16 ,buf ,RGB( 255 ,0 ,0 ) );
				while ( 1 );
			}
			i++;
		}
	}

	/* Lu[Vf[^ۑ	*/
	eeprom_busy_wait();
	eeprom_write_block( &touchCAL ,(void *)CALIBRATION_ADDR + 2 ,sizeof(TOUCH_CALIBRATION) );

	/* CRCl					*/
	crc = crc16_CalcRAM( &touchCAL ,sizeof(TOUCH_CALIBRATION) );
	eeprom_busy_wait();
	eeprom_write_word( (uint16_t *)CALIBRATION_ADDR ,crc );

	/* Lu[VC[W\	*/
	dispCAL( RGB( 0 ,0 ,255 ) );
	WAIT_MS( 10000 );

	/* ʂ̔wiFEPxɖ߂	*/
	lcdSetBrightness( 0 );
	lcdSetBgColor( color );
	lcdSetBrightness( brightness );
}

/*****************************************************************************
*						^b`pl␳pWvZ
* Fuint8_t index |CgCfbNX ( 0 ` 24 )
*       POINT   *pos  W
* ߒlFvoid
*****************************************************************************/
static void get_calibration_posion( uint8_t index ,POINT *pos )
{
	uint16_t xi ,yi;
	yi = index / 5;
	xi = index % 5;
	pos->y = OFFSET + ( yi * ( ( DISPLAY_HEIGHT - ( OFFSET * 2 ) ) / 4 ) );
	pos->x = OFFSET + ( xi * ( ( DISPLAY_WIDTH  - ( OFFSET * 2 ) ) / 4 ) );
	if ( yi == 4 ) pos->y--;
	if ( xi == 4 ) pos->x--;
}

/*****************************************************************************
*					^b`pl␳pJ[\Aj[V
* Fuint8_t *t ^b`σtO(25|Cg)
*		uint8_t n  ͂߂ĂJ[\
* ߒlFvoid
*****************************************************************************/
static void drawPoint25( uint8_t *t ,uint8_t n )
{
	POINT pos;
	static uint16_t color = RGB( 0 ,0 ,255 );
	for ( uint8_t i = 0 ;i < 25 ;i++ ) {
		get_calibration_posion( i ,&pos );
		if ( t[i] ) {
			drawCursor( pos.x ,pos.y ,RGB(255,0,0) );
		} else if ( i == n ) {
			if ( TIMER_IS_TIMEOUT() ) {
				TIMER_SET_TIMEOUT( 250 );
				if ( color == RGB( 0 ,0 ,255 ) ) {
					color = RGB( 255 ,255 ,255 );
				} else {
					color = RGB( 0 ,0 ,255 );
				}
			}
			drawCursor( pos.x ,pos.y ,color );
		} else {
			drawCursor( pos.x ,pos.y ,RGB(0,0,255) );
		}
	}
}

/*****************************************************************************
*						^b`pl␳̃J[\\
* Fuint16_t x
*		uint16_t y
*       uint16_t c
* ߒlFvoid
*****************************************************************************/
static void drawCursor( uint16_t x ,uint16_t y ,uint16_t c )
{
	g_circle( G_OPAQUE ,x ,y ,6 ,c );
	g_line( G_OPAQUE ,x - 8 ,y ,x + 8 ,y ,c );
	g_line( G_OPAQUE ,x ,y - 8 ,x ,y + 8 ,c );
}

/*****************************************************************************
*							A/Dϊl->LCDW
* FPOINT ad   A/Dϊl
*       POINT spos XN[W
* ߒlFuint8_t    0:OK !0:NG
******************************************************************************/
static uint8_t cnv_screenPos( POINT *ad ,POINT *spos )
{
	uint8_t ret;
	uint8_t idx;
	POINT d1 ,d2;
	POINT z1 ,z2;

	#if DEBUG
	lcdClear();
	for ( uint8_t i = 0 ;i < 16 ;i++ ) {
		lcdLine( touchCAL.rect[i].pos[0].x / 3 - 20 ,touchCAL.rect[i].pos[0].y / 3 - 20 ,touchCAL.rect[i].pos[1].x / 3 - 20 ,touchCAL.rect[i].pos[1].y / 3 - 20 ,0xffff );
		lcdLine( touchCAL.rect[i].pos[1].x / 3 - 20 ,touchCAL.rect[i].pos[1].y / 3 - 20 ,touchCAL.rect[i].pos[3].x / 3 - 20 ,touchCAL.rect[i].pos[3].y / 3 - 20 ,0xffff );
		lcdLine( touchCAL.rect[i].pos[3].x / 3 - 20 ,touchCAL.rect[i].pos[3].y / 3 - 20 ,touchCAL.rect[i].pos[2].x / 3 - 20 ,touchCAL.rect[i].pos[2].y / 3 - 20 ,0xffff );
		lcdLine( touchCAL.rect[i].pos[2].x / 3 - 20 ,touchCAL.rect[i].pos[2].y / 3 - 20 ,touchCAL.rect[i].pos[0].x / 3 - 20 ,touchCAL.rect[i].pos[0].y / 3 - 20 ,0xffff );
	}
	lcdCircle( ad->x / 3 - 20 ,ad->y / 3 - 20 ,4 ,RGB(0,255,0) );
	#endif

	/* ʂ16̈斈Ƀ`FbN	*/
	for ( uint8_t i = 0 ;i < 16 ;i++ ) {

		/* ̈Op`2ă|CgꂽẄɂ邩`FbN	*/
		ret = PosIncludeTriEx( &touchCAL.rect[i].pos[0] ,&touchCAL.rect[i].pos[1] ,&touchCAL.rect[i].pos[3] ,ad );
		if ( !ret ) {
			ret = PosIncludeTriEx( &touchCAL.rect[i].pos[0] ,&touchCAL.rect[i].pos[3] ,&touchCAL.rect[i].pos[2] ,ad );
		}

		if ( ret ) {
			#if DEBUG
			lcdLine( touchCAL.rect[i].pos[0].x / 3 - 20 ,touchCAL.rect[i].pos[0].y / 3 - 20 ,touchCAL.rect[i].pos[1].x / 3 - 20 ,touchCAL.rect[i].pos[1].y / 3 - 20 ,RGB(255,0,0) );
			lcdLine( touchCAL.rect[i].pos[1].x / 3 - 20 ,touchCAL.rect[i].pos[1].y / 3 - 20 ,touchCAL.rect[i].pos[3].x / 3 - 20 ,touchCAL.rect[i].pos[3].y / 3 - 20 ,RGB(255,0,0) );
			lcdLine( touchCAL.rect[i].pos[3].x / 3 - 20 ,touchCAL.rect[i].pos[3].y / 3 - 20 ,touchCAL.rect[i].pos[2].x / 3 - 20 ,touchCAL.rect[i].pos[2].y / 3 - 20 ,RGB(255,0,0) );
			lcdLine( touchCAL.rect[i].pos[2].x / 3 - 20 ,touchCAL.rect[i].pos[2].y / 3 - 20 ,touchCAL.rect[i].pos[0].x / 3 - 20 ,touchCAL.rect[i].pos[0].y / 3 - 20 ,RGB(255,0,0) );
			#endif

			/* LCD̗̈WiΊpj擾	*/
			idx = ( ( i / 4 ) * 5 ) + ( i % 4 );
			get_calibration_posion( idx     ,&d1 );
			get_calibration_posion( idx + 6 ,&d2 );

			/* A/Dϊl̍WvZ			*/
			/* ̘̈c݂␳Ă	*/
			z1.x = xPosLineV( &touchCAL.rect[i].pos[0] ,&touchCAL.rect[i].pos[2] ,ad->y );
			z2.x = xPosLineV( &touchCAL.rect[i].pos[1] ,&touchCAL.rect[i].pos[3] ,ad->y );

			z1.y = yPosLineH( &touchCAL.rect[i].pos[0] ,&touchCAL.rect[i].pos[1] ,ad->x );
			z2.y = yPosLineH( &touchCAL.rect[i].pos[2] ,&touchCAL.rect[i].pos[3] ,ad->x );

			/* XP[ϊ						*/
			spos->x = (uint16_t)( ( (long)( ad->x - z1.x ) * (long)( d2.x - d1.x + 1 ) ) / (long)( z2.x - z1.x + 1 ) ) + d1.x;
			spos->y = (uint16_t)( ( (long)( ad->y - z1.y ) * (long)( d2.y - d1.y + 1 ) ) / (long)( z2.y - z1.y + 1 ) ) + d1.y;

			/* LW̏ꍇ͂ŏI		*/
			if ( ( spos->x >= OFFSET ) && ( spos->x < DISPLAY_WIDTH - OFFSET ) && ( spos->y >= OFFSET ) && ( spos->y < DISPLAY_HEIGHT - OFFSET ) ) {
				return ( 0 );
			}
		}
	}

	return ( 1 );
}

/*****************************************************************************
*						1Ɛ2Ă邩mF
* FPOINT *line1 2_̃|Cgz
* 		POINT *line2 2_̃|Cgz
* ߒlFuint8_t      0 : Ɛ͌Ȃ
*					!0 : Ɛ͌
*****************************************************************************/
static uint8_t intersectM( POINT *p1 ,POINT *p2 ,POINT *p3 ,POINT *p4 )
{
	int16_t x12 = p1->x - p2->x;
	int16_t x13 = p1->x - p3->x;
	int16_t x14 = p1->x - p4->x;

	int16_t y12 = p1->y - p2->y;
	int16_t y31 = p3->y - p1->y;
	int16_t y41 = p4->y - p1->y;

	int32_t a1 = ( (int32_t)x12 * (int32_t)y31 ) + ( (int32_t)y12 * (int32_t)x13 );
	int32_t a2 = ( (int32_t)x12 * (int32_t)y41 ) + ( (int32_t)y12 * (int32_t)x14 );
	if ( ( a1 == 0 ) || ( a2 == 0 ) || ( ( a1 < 0 ) && ( a2 < 0 ) ) || ( ( a1 > 0 ) && ( a2 > 0 ) ) ) {
		return ( 0 );
	}
	return ( 1 );
}

/*****************************************************************************
*				w̓_(xp)Rp`( tp1,tp2,tp3 )̒ɗL邩
* FPOINT   *tp1
*       POINT   *tp2
* 		POINT   *tp3
* 		POINT   *xp
* ߒlFuint8_t 0:Oɂ !0:ɂ
*****************************************************************************/
static uint8_t PosIncludeTriEx( POINT *tp1 ,POINT *tp2 ,POINT *tp3 ,POINT *xp )
{
#if 0		// KRp`w肷ꍇ͕sv
	/* 3_꒼ɂ(Op`ł͂Ȃ)ƂAu܂ȂvƔ		*/
	int16_t x12 = tp1->x - tp2->x;
	int16_t x13 = tp1->x - tp3->x;
	int16_t y12 = tp1->y - tp2->y;
	int16_t y13 = tp1->y - tp3->y;
	int32_t a = (int32_t)x13 * (int32_t)y12;
	int32_t b = (int32_t)x12 * (int32_t)y13;
	if ( a == b ) {
		return ( 0 );
	}
#endif

	/* eӂEł钼ƂāAɑ΂钸_Ƃ_				*/
	/* Ԑ̒ƌȂ΁A_͎Op`ɕ܂ĂȂ	*/
	if ( ( intersectM( tp1 ,tp2 ,xp ,tp3 ) ) || ( intersectM( tp1 ,tp3 ,xp ,tp2 ) ) || ( intersectM( tp2 ,tp3 ,xp ,tp1 ) ) ) {
		return ( 0 );
	}
	return ( 1 );
}

/*****************************************************************************
*					ijp1,p2ɉYW߂
* FPOINT    *p1@n_
*       POINT    *p2@I_
*		uint16_t x    XW
* ߒlFuint16_t      YW
*****************************************************************************/
static uint16_t yPosLineH( POINT *p1 ,POINT *p2 ,uint16_t x )
{
	int16_t dx = (int16_t)p2->x - (int16_t)p1->x;
	int16_t dy = (int16_t)p2->y - (int16_t)p1->y;
	int32_t y = ( ( (int32_t)dy * (int32_t)( (int16_t)x - (int16_t)p1->x ) ) / (int32_t)dx ) + (int32_t)p1->y;
	return ( (uint16_t)y );
}

/*****************************************************************************
*					icjp1,p2ɉXW߂
* FPOINT    *p1@n_
*       POINT    *p2@I_
*		uint16_t y    YW
* ߒlFuint16_t      XW
*****************************************************************************/
static uint16_t xPosLineV( POINT *p1 ,POINT *p2 ,uint16_t y )
{
	int16_t dx = (int16_t)p2->x - (int16_t)p1->x;
	int16_t dy = (int16_t)p2->y - (int16_t)p1->y;
	int32_t x = ( ( (int32_t)dx * (int32_t)( (int16_t)y - (int16_t)p1->y ) ) / (int32_t)dy ) + (int32_t)p1->x;
	return ( (uint16_t)x );
}

/*****************************************************************************
*						Lu[VC[W\
* Fuint16_t color \F
* ߒlFvoid
*****************************************************************************/
static void dispCAL( uint16_t color )
{
	uint16_t min_x = 0xffff ,max_x = 0;
	uint16_t min_y = 0xffff ,max_y = 0;
	uint16_t width = 0;
	uint16_t height = 0;

	/* őEŏl擾					*/
	for ( uint8_t i = 0 ;i < 16 ;i++ ) {
		for ( uint8_t j = 0 ;j < 4 ;j++ ) {
			if ( touchCAL.rect[i].pos[j].x > max_x ) max_x = touchCAL.rect[i].pos[j].x;
			if ( touchCAL.rect[i].pos[j].y > max_y ) max_y = touchCAL.rect[i].pos[j].y;
			if ( touchCAL.rect[i].pos[j].x < min_x ) min_x = touchCAL.rect[i].pos[j].x;
			if ( touchCAL.rect[i].pos[j].y < min_y ) min_y = touchCAL.rect[i].pos[j].y;
		}
	}
	width = max_x - min_x + 1;
	height = max_y - min_y + 1;

	for ( uint8_t i = 0 ;i < 16 ;i++ ) {
		uint16_t x1 = touchCAL.rect[i].pos[0].x - min_x ,y1 = touchCAL.rect[i].pos[0].y - min_y;
		uint16_t x2 = touchCAL.rect[i].pos[1].x - min_x ,y2 = touchCAL.rect[i].pos[1].y - min_y;
		uint16_t x3 = touchCAL.rect[i].pos[2].x - min_x ,y3 = touchCAL.rect[i].pos[2].y - min_y;
		uint16_t x4 = touchCAL.rect[i].pos[3].x - min_x ,y4 = touchCAL.rect[i].pos[3].y - min_y;

		/* XP[ϊ						*/
		x1 = (uint16_t)( ( (long)x1 * (long)( DISPLAY_WIDTH - OFFSET * 2 ) ) / (long)width );
		y1 = (uint16_t)( ( (long)y1 * (long)( DISPLAY_HEIGHT - OFFSET * 2 ) ) / (long)height );

		x2 = (uint16_t)( ( (long)x2 * (long)( DISPLAY_WIDTH - OFFSET * 2 ) ) / (long)width );
		y2 = (uint16_t)( ( (long)y2 * (long)( DISPLAY_HEIGHT - OFFSET * 2 ) ) / (long)height );

		x3 = (uint16_t)( ( (long)x3 * (long)( DISPLAY_WIDTH - OFFSET * 2 ) ) / (long)width );
		y3 = (uint16_t)( ( (long)y3 * (long)( DISPLAY_HEIGHT - OFFSET * 2 ) ) / (long)height );

		x4 = (uint16_t)( ( (long)x4 * (long)( DISPLAY_WIDTH - OFFSET * 2 ) ) / (long)width );
		y4 = (uint16_t)( ( (long)y4 * (long)( DISPLAY_HEIGHT - OFFSET * 2 ) ) / (long)height );

		g_line( G_OPAQUE ,OFFSET + x1 ,OFFSET + y1 ,OFFSET + x2 ,OFFSET + y2 ,color );
		g_line( G_OPAQUE ,OFFSET + x2 ,OFFSET + y2 ,OFFSET + x4 ,OFFSET + y4 ,color );
		g_line( G_OPAQUE ,OFFSET + x4 ,OFFSET + y4 ,OFFSET + x3 ,OFFSET + y3 ,color );
		g_line( G_OPAQUE ,OFFSET + x3 ,OFFSET + y3 ,OFFSET + x1 ,OFFSET + y1 ,color );
	}
}
