/*###########################################################################
#                                                                           #
#						UNICODE -> SJIS ϊ֐Q							#
#                                                                           #
###########################################################################*/
#define __UNICODE_C__
#include "project.h"

/* [Jϐ`					*/
static uint32_t uniTopAddress = 0L;
static uint32_t sjisTopAddress = 0L;

static uint8_t check_sjis( char *s );
static uint8_t unicode_UTF8toSJIS( char *s ,char *d ,uint16_t bufferMax );
static uint8_t unicode_UTF16toSJIS( char *s ,char *d ,uint16_t bufferMax ,uint8_t mode );

/*****************************************************************************
*						jR[hVXe
* Fvoid
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
uint8_t unicode_init( void )
{
	FLASH_FS_INFO inf;

	/* UNI2SJIS.BIN `FbN擪y[Wԍ擾	*/
	flashFs_readIndex( FL_UNI2SJIS ,&inf );
	if ( ( inf.ftype != FLASH_FS_FILE ) || ( inf.fsize != 131072L ) ) {
		return ( 1 );
	}
	uniTopAddress = (uint32_t)inf.topPage * 512L;

	/* SJIS2UNI.BIN `FbN擪y[Wԍ擾	*/
	flashFs_readIndex( FL_SJIS2UNI ,&inf );
	if ( ( inf.ftype != FLASH_FS_FILE ) || ( inf.fsize != 131072L ) ) {
		uniTopAddress = 0L;
		return ( 2 );
	}
	sjisTopAddress = (uint32_t)inf.topPage * 512L;

	/* UNICODEe[ű@\`FbN				*/
	if ( ff_convert( ff_convert( 0x3042 ,0 ) ,1 ) != 0x3042 ) {	/* "" */
		uniTopAddress = 0L;
		sjisTopAddress = 0L;
		return ( 3 );
	}

	if ( ff_convert( ff_convert( 0xfa19 ,0 ) ,1 ) != 0xfa19 ) {	/* "~" */
		uniTopAddress = 0L;
		sjisTopAddress = 0L;
		return ( 4 );
	}

	return ( 0 );
}

/*****************************************************************************
*						FatFs0.07݊R[hϊ
* FWCHAR src Character code to be converted
*		UINT  dir 0: Unicode to OEMCP, 1: OEMCP to Unicode
* ߒlFWCHAR Converted code, 0 means conversion error
*****************************************************************************/
WCHAR ff_convert( WCHAR src ,UINT dir )
{
	WCHAR c;
	if (src <= 0x80) {		/* ASCII 			*/
		c = src;
	} else {
		if ( dir ) {		/* OEMCP to unicode */
			flashRead( sjisTopAddress + ( (uint32_t)src * 2L ) ,&c ,2 );
		} else {			/* Unicode to OEMCP */
			flashRead( uniTopAddress + ( (uint32_t)src * 2L ) ,&c ,2 );
		}
	}
	return ( c );
}

/*****************************************************************************
*						FatFs0.07݊R[hϊ
* FWCHAR chr Input character
* ߒlFWCHAR Upper converted character
*****************************************************************************/
WCHAR ff_wtoupper( WCHAR chr )
{
	static const prog_uint16_t tbl_lower[] = { 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0xA1, 0x00A2, 0x00A3, 0x00A5, 0x00AC, 0x00AF, 0xE0, 0xE1, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6, 0xE7, 0xE8, 0xE9, 0xEA, 0xEB, 0xEC, 0xED, 0xEE, 0xEF, 0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF8, 0xF9, 0xFA, 0xFB, 0xFC, 0xFD, 0xFE, 0x0FF, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x137, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x148, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x17E, 0x192, 0x3B1, 0x3B2, 0x3B3, 0x3B4, 0x3B5, 0x3B6, 0x3B7, 0x3B8, 0x3B9, 0x3BA, 0x3BB, 0x3BC, 0x3BD, 0x3BE, 0x3BF, 0x3C0, 0x3C1, 0x3C3, 0x3C4, 0x3C5, 0x3C6, 0x3C7, 0x3C8, 0x3C9, 0x3CA, 0x430, 0x431, 0x432, 0x433, 0x434, 0x435, 0x436, 0x437, 0x438, 0x439, 0x43A, 0x43B, 0x43C, 0x43D, 0x43E, 0x43F, 0x440, 0x441, 0x442, 0x443, 0x444, 0x445, 0x446, 0x447, 0x448, 0x449, 0x44A, 0x44B, 0x44C, 0x44D, 0x44E, 0x44F, 0x451, 0x452, 0x453, 0x454, 0x455, 0x456, 0x457, 0x458, 0x459, 0x45A, 0x45B, 0x45C, 0x45E, 0x45F, 0x2170, 0x2171, 0x2172, 0x2173, 0x2174, 0x2175, 0x2176, 0x2177, 0x2178, 0x2179, 0x217A, 0x217B, 0x217C, 0x217D, 0x217E, 0x217F, 0xFF41, 0xFF42, 0xFF43, 0xFF44, 0xFF45, 0xFF46, 0xFF47, 0xFF48, 0xFF49, 0xFF4A, 0xFF4B, 0xFF4C, 0xFF4D, 0xFF4E, 0xFF4F, 0xFF50, 0xFF51, 0xFF52, 0xFF53, 0xFF54, 0xFF55, 0xFF56, 0xFF57, 0xFF58, 0xFF59, 0xFF5A, 0 };
	static const prog_uint16_t tbl_upper[] = { 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, 0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x21, 0xFFE0, 0xFFE1, 0xFFE5, 0xFFE2, 0xFFE3, 0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0x178, 0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14A, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x179, 0x17B, 0x17D, 0x191, 0x391, 0x392, 0x393, 0x394, 0x395, 0x396, 0x397, 0x398, 0x399, 0x39A, 0x39B, 0x39C, 0x39D, 0x39E, 0x39F, 0x3A0, 0x3A1, 0x3A3, 0x3A4, 0x3A5, 0x3A6, 0x3A7, 0x3A8, 0x3A9, 0x3AA, 0x410, 0x411, 0x412, 0x413, 0x414, 0x415, 0x416, 0x417, 0x418, 0x419, 0x41A, 0x41B, 0x41C, 0x41D, 0x41E, 0x41F, 0x420, 0x421, 0x422, 0x423, 0x424, 0x425, 0x426, 0x427, 0x428, 0x429, 0x42A, 0x42B, 0x42C, 0x42D, 0x42E, 0x42F, 0x401, 0x402, 0x403, 0x404, 0x405, 0x406, 0x407, 0x408, 0x409, 0x40A, 0x40B, 0x40C, 0x40E, 0x40F, 0x2160, 0x2161, 0x2162, 0x2163, 0x2164, 0x2165, 0x2166, 0x2167, 0x2168, 0x2169, 0x216A, 0x216B, 0x216C, 0x216D, 0x216E, 0x216F, 0xFF21, 0xFF22, 0xFF23, 0xFF24, 0xFF25, 0xFF26, 0xFF27, 0xFF28, 0xFF29, 0xFF2A, 0xFF2B, 0xFF2C, 0xFF2D, 0xFF2E, 0xFF2F, 0xFF30, 0xFF31, 0xFF32, 0xFF33, 0xFF34, 0xFF35, 0xFF36, 0xFF37, 0xFF38, 0xFF39, 0xFF3A, 0 };
	uint16_t i;

	for ( i = 0 ;( pgm_read_word( &tbl_lower[i] ) && chr != pgm_read_word( &tbl_lower[i] ) ) ;i++ );
	return ( pgm_read_word( &tbl_lower[i] ) ? pgm_read_word( &tbl_upper[ i ] ) : chr );
}

/*****************************************************************************
*						eS-JISɕϊ
* Fchar    *s  ϊf[^(ŌɕK'\0'3ȏ㑱Ă邱)
*		uint16_t pr vCIeB
*						PR_UTF16_UTF8_SJIS
*						PR_UTF8_UTF16_SJIS
*						PR_SJIS_UTF8_UTF16
*						PR_UTF8_SJIS_UTF16
*
* ߒlFuint8_t ϊ̕R[h
*						CODE_NONE    : R[hʂł
*						CODE_SJIS    : S-JIS
*						CODE_UTF16LE : UTF-16LE
*						CODE_UTF16BE : UTF-16BE
*						CODE_UTF8    : UTF-8
*****************************************************************************/
uint8_t unicode_ConvSJIS( char *s ,uint16_t pr )
{
	char buf[258];
	uint8_t ret;
	uint8_t i;
	uint8_t typ;

	for ( i = 0 ;i < 4 ;i++ ) {
		typ = ( pr & 0x07 );

		/* UTF-8 -> S-JIS					*/
		if ( typ == CODE_UTF8 ) {
			ret = unicode_UTF8toSJIS( s ,buf ,sizeof(buf) );
			if ( ret == 0 ) {
				strcpy( s ,buf );
				return ( CODE_UTF8 );
			}
		
		/* UTF-16LE -> S-JIS				*/
		} else if ( typ == CODE_UTF16LE ) {
			ret = unicode_UTF16toSJIS( s ,buf ,sizeof(buf) ,0 );
			if ( ret == 0 ) {
				strcpy( s ,buf );
				return ( CODE_UTF16LE );
			}

		/* UTF-16BE -> S-JIS				*/
		} else if ( typ == CODE_UTF16BE ) {
			ret = unicode_UTF16toSJIS( s ,buf ,sizeof(buf) ,1 );
			if ( ret == 0 ) {
				strcpy( s ,buf );
				return ( CODE_UTF16BE );
			}

		/* S-JISȂ̂`FbN		*/
		} else {
			ret = check_sjis( s );
			if ( ret == 0 ) {
				return ( CODE_SJIS );
			}
		}

		pr >>= 3;
	}

	return ( CODE_NONE );
}

/*****************************************************************************
*							S-JIS`FbN
* Fchar     *s        ͕
* ߒlFuint8_t            0:S-JIS 1:S-JISȊO
*****************************************************************************/
static uint8_t check_sjis( char *s )
{
	uint8_t c;
	while ( 1 ) {
		c = *s++;

		/* I[R[h`FbN		*/
		if ( c == '\0' ) {
			if ( *s == '\0' ) {
				break;
			} else {
				return ( 1 );
			}
		}

		if ( IS_SJIS1(c) ) {					/* SpJnR[hH			*/
			c = *s++;
			if ( !IS_SJIS2(c) ) {				/* 2oCgڂG[H		*/
				return ( 2 );
			}
		}
	}

	return ( 0 );
}

/*****************************************************************************
*						UTF-8 -> S-JIS ϊ
* Fchar     *s        ͕
*		char     *d        ö͕
*		uint16_t bufferMax ö͕TCY
* ߒlFuint8_t            0: / !0:s
*****************************************************************************/
static uint8_t unicode_UTF8toSJIS( char *s ,char *d ,uint16_t bufferMax )
{
	uint16_t code;
	uint16_t sjis;
	uint8_t b;
	uint8_t n;

	/* ϊC						*/
	while ( 1 ) {
		b = (uint8_t)*s++;

		/* I[R[h`FbN			*/
		if ( b == '\0' ) {
			if ( *s == '\0' ) {
				break;
			} else {
				return ( 1 );
			}
		}

		/* LN^擪oCgmF	*/
		if ( ( b & 0x80 ) == 0x00 ) {				/* U+0x0000...U+0x007F ?		*/
			b &= 0x7f;
			n = 0;

		} else if ( ( b & 0xe0 ) == 0xc0 ) {		/* U+0x0080...U+0x07FF ?		*/
			b &= 0x1f;
			n = 1;

		} else if ( ( b & 0xf0 ) == 0xe0 ) {		/* U+0x0800...U+0xFFFF ?		*/
			b &= 0x0f;
			n = 2;

		} else {									/* ̑̃rbgzu	?		*/
			return ( 1 );
		}

		/* R[h擾					*/
		code = (uint16_t)b;
		while ( n-- ) {
			b = (uint8_t)*s++;
			if ( ( b & 0xc0 ) != 0x80 ) {			/* rbgzuG[?			*/
				return ( 2 );
			}
			code <<= 6;
			code |= (uint16_t)( b & 0x3f );
		}

		/* UNICODE->S-JISϊ			*/
		flashRead( uniTopAddress + ( (uint32_t)code * 2L ) ,&sjis ,2 );
		if ( sjis == 0 ) {
			return ( 2 );
		}

		/* SJISR[hi[					*/
		if ( sjis & 0xff00 ) {
			if ( bufferMax >= 2 ) {
				*d++ = (uint8_t)( ( sjis & 0xff00 ) >> 8 );
				*d++ = (uint8_t)sjis;
				bufferMax -= 2;
			} else {
				return ( 4 );
			}
		} else {
			if ( bufferMax >= 1 ) {
				*d++ = (uint8_t)sjis;
				bufferMax--;
			} else {
				return ( 5 );
			}
		}
	}

	/* NULLZbg		*/
	if ( bufferMax ) {
		*d++ = '\0';
	} else {
		return ( 7 );
	}

	return ( 0 );
}

/*****************************************************************************
*					UTF-16 -> S-JISϊ
* Fchar    *s         ͕
*		char    *d         ϊf[^̈
*		uint16_t bufferMax ϊf[^̈̃oCgTCY
*		uint8_t  mode      0:gGfBA !0:rbNGfBA
* ߒlFuint8_t            0: / !0:s
* R[h16rbgŒŏ
*****************************************************************************/
static uint8_t unicode_UTF16toSJIS( char *s ,char *d ,uint16_t bufferMax ,uint8_t mode )
{
	uint16_t code;
	uint16_t sjis;
	uint8_t c1 ,c2;

	while ( 1 ) {
	
		/* 16rbgR[h擾				*/
		c1 = *s++;
		c2 = *s++;

		/* 16rbgR[h擾				*/
		if ( mode ) {								/* rbNGfBA	*/
			code = (uint16_t)c1 << 8;
			code |= (uint16_t)c1;
		} else {									/* gGfBA	*/
			code = (uint16_t)c2 << 8;
			code |= (uint16_t)c1;
		}

		if ( code == 0x0000 ) {
			break;
		}

		/* UNICODE->S-JISϊ			*/
		flashRead( uniTopAddress + ( (uint32_t)code * 2L ) ,&sjis ,2 );
		if ( sjis == 0 ) {
			return ( 1 );
		}

		/* SJISR[hi[					*/
		if ( sjis & 0xff00 ) {
			if ( bufferMax >= 2 ) {
				*d++ = (uint8_t)( ( sjis & 0xff00 ) >> 8 );
				*d++ = (uint8_t)sjis;
				bufferMax -= 2;
			} else {
				return ( 2 );
			}
		} else {
			if ( bufferMax >= 1 ) {
				*d++ = (uint8_t)sjis;
				bufferMax--;
			} else {
				return ( 3 );
			}
		}
	}

	/* NULLZbg		*/
	if ( bufferMax ) {
		*d++ = '\0';
	} else {
		return ( 4 );
	}

	return ( 0 );
}

