/*###########################################################################
#                                                                           #
#                       SPIڑSRAM u23K256v䃂W[                #
#																			#
# VO`bvpɂ͖Lxȃ֐QpӂĂ              #
# }``bvpɂ̓Oobt@P񋟂(Xg[~Op) 	    #
#                                                                           #
# ڃ`bv̂PVO[hpɊ蓖ĂāAc̓}``bv#
# pɊ蓖Ă														#
#                                                                           #
###########################################################################*/
#define __23K256_C__

#include <stdio.h>
#include <ctype.h>
#include <string.h> 
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "23k256.h"

#if USE_RING_BUFFER
#include "../vs1053b/vs1053b.h"
#endif

/* Timer3 EGCgpɎgp	*/
#define TIMER_NUM 3
#include "../myutil/timer.h"

/* CgE[h|C^ݒ			*/
#define SRAM_SET_WRITE_POINT(p) { spiTransfer( 0x02 ); spiTransfer( (uint8_t)( p >> 8 ) ); spiTransfer( (uint8_t)p ); }
#define SRAM_SET_READ_POINT(p) { spiTransfer( 0x03 ); spiTransfer( (uint8_t)( p >> 8 ) ); spiTransfer( (uint8_t)p ); }

/* [Jϐ錾				*/
static SSMP ringRp = 0;					/* Oobt@[h|C^		*/
static SSMP ringWp = 0;					/* Oobt@Cg|C^		*/
static uint8_t ringRpCS = 0;			/* Oobt@[hI`bv	*/
static uint8_t ringWpCS = 0;			/* Oobt@CgI`bv	*/
static uint32_t ringDataCount = 0L;		/* Oobt@f[^i[TCY	*/

/*****************************************************************************
*								SPI-SRAMڑ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void sram_init( void )
{
	/* SPIC^[tF[X			*/
	SRAM_DISABLE();
	spiInit();
	SPI_HI_SPEED();

	/* e`bvV[PV[hɐݒ	*/
	for ( uint8_t i = 0 ;i < SRAM_CHIP_COUNT ;i++ ) {
		SRAM_ENABLE( i );
		spiTransfer( 0x01 );
		spiTransfer( 0x40 );
		SRAM_DISABLE();
	}
}

/*****************************************************************************
*							oCgCg
* FSSMP    addr  SPI-SRAMAhX
*       uint8_t data  f[^
* ߒlFvoid
*****************************************************************************/
void ss_write_byte( SSMP addr ,uint8_t data )
{
	ss_memcpy( addr ,&data ,1 );
}

/*****************************************************************************
*							[hCg
* FSSMP    addr  SPI-SRAMAhX
*       uint16_t data f[^
* ߒlFvoid
*****************************************************************************/
void ss_write_word( SSMP addr ,uint16_t data )
{
	ss_memcpy( addr ,&data ,2 );
}

/*****************************************************************************
*						_u[hCg
* FSSMP    addr  SPI-SRAMAhX
*       uint32_t data f[^
* ߒlFvoid
*****************************************************************************/
void ss_write_dword( SSMP addr ,uint32_t data )
{
	ss_memcpy( addr ,&data ,4 );
}

/*****************************************************************************
*							oCg[h
* FSSMP    addr  SPI-SRAMAhX
* ߒlFuint8_t       f[^
*****************************************************************************/
uint8_t ss_read_byte( SSMP addr )
{
	uint8_t data;
	memcpy_SS( &data ,addr ,1 );
	return ( data );
}

/*****************************************************************************
*							[h[h
* FSSMP    addr  SPI-SRAMAhX
* ߒlFuint16_t      f[^
*****************************************************************************/
uint16_t ss_read_word( SSMP addr )
{
	uint16_t data;
	memcpy_SS( &data ,addr ,2 );
	return ( data );
}

/*****************************************************************************
*							_u[h[h
* FSSMP     addr  SPI-SRAMAhX
* ߒlFuint32_t       f[^
*****************************************************************************/
uint32_t ss_read_dword( SSMP addr )
{
	uint32_t data;
	memcpy_SS( &data ,addr ,4 );
	return ( data );
}

/*****************************************************************************
*									t
* FSSMP addr     ̈SPI-SRAM擪AhX
*       uint8_t  val  Zbgl
*       uint16_t len  TCY
* ߒlFSSMP          ̃AhX
*****************************************************************************/
SSMP ss_memset( SSMP addr ,uint8_t val ,uint16_t len )
{
	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_WRITE_POINT( addr );
	addr += len;
	while ( len-- ) {
		spiTransfer( val );
	}
	SRAM_DISABLE();
	return ( addr );
}

/*****************************************************************************
*								Rs[
* FSSMP     dst  ]SPI-SRAM擪AhX
*       void     *src ]AVR-SRAM擪AhX
*       uint16_t len  ]f[^
* ߒlFSSMP          ̃AhX
*****************************************************************************/
SSMP ss_memcpy( SSMP dst ,void *src ,uint16_t len )
{
	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_WRITE_POINT( dst );
	uint8_t *p = (uint8_t *)src;
	dst += len;
	while ( len-- ) {
		spiTransfer( *p++ );
	}
	SRAM_DISABLE();

	return ( dst );
}

/*****************************************************************************
*								Rs[
* FSSMP            dst  ]SPI-SRAM擪AhX
*       const prog_void *src ]AVR-PG擪AhX
*       uint16_t        len  ]f[^
* ߒlFSSMP            ̃AhX
*****************************************************************************/
SSMP ss_memcpy_P( SSMP dst ,const prog_void *src ,uint16_t len )
{
	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_WRITE_POINT( dst );
	dst += len;
	const prog_uint8_t *p = (const prog_uint8_t *)src;
	while ( len-- ) {
		spiTransfer( pgm_read_byte( p++ ) );
	}
	SRAM_DISABLE();

	return ( dst );
}

/*****************************************************************************
*								Rs[
* FSSMP     dst ]SPI-SRAM擪AhX
*       SSMP     src ]SPI-SRAM擪AhX
*       uint16_t len ]f[^
* ߒlFSSMP         ̃AhX
*****************************************************************************/
SSMP ss_memcpy_SS( SSMP dst ,SSMP src ,uint16_t len )
{
	uint8_t dat;
	while ( len-- ) {
		dat = ss_read_byte( src++ );
		ss_write_byte( dst++ ,dat );
	}
	return ( dst );
}

/*****************************************************************************
*								Rs[
* Fvoid     *dst ]AVR-SRAM擪AhX
*       SSMP     src  ]SPI-SRAM擪AhX
*       uint16_t len  ]f[^
* ߒlFvoid     *    ̃AhX
*****************************************************************************/
void *memcpy_SS( void *dst ,SSMP src ,uint16_t len )
{
	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( src );
	uint8_t *p = (uint8_t *)dst;
	while ( len-- ) {
		*p++ = spiTransfer( 0xff );
	}
	SRAM_DISABLE();
	return ( p );
}

/*****************************************************************************
*								r
* FSSMP     blk1  rubN1(SPI-SRAM擪AhX)
*       void     *blk2 rubN2(AVR-SRAM擪AhX)
*       uint16_t len   rubN
* ߒlFint8_t          : blk1 < blk2
*                         0 : blk1 = blk2
*                       : blk1 > blk2
*****************************************************************************/
int8_t ss_memcmp( SSMP blk1 ,void *blk2 ,uint16_t len )
{
	int8_t d1 = 0 ,d2 = 0;
	uint8_t *p = (uint8_t *)blk2;

	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( blk1 );
	while ( len-- && ( d1 == d2 ) ) {
		d1 = spiTransfer( 0xff );
		d2 = *p++;
	}
	SRAM_DISABLE();
	return ( d1 - d2 );
}

/*****************************************************************************
*								r
* FSSMP            blk1  rubN1(SPI-SRAM擪AhX)
*       const prog_void *blk2 rubN2(AVR-PG擪AhX)
*       uint16_t        len   rubN
* ߒlFint8_t                 : blk1 < blk2
*						         0 : blk1 = blk2
*			                   : blk1 > blk2
*****************************************************************************/
int8_t ss_memcmp_P( SSMP blk1 ,const prog_void *blk2 ,uint16_t len )
{
	int8_t d1 = 0 ,d2 = 0;
	const prog_uint8_t *p = (const prog_uint8_t *)blk2;

	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( blk1 );
	while ( len-- && ( d1 == d2 ) ) {
		d1 = spiTransfer( 0xff );
		d2 = pgm_read_byte( p++ );
	}
	SRAM_DISABLE();
	return ( d1 - d2 );
}

/*****************************************************************************
*								r
* FSSMP     blk1 rubN1(SPI-SRAM擪AhX)
*       SSMP     blk2 rubN2(SPI-SRAM擪AhX)
*       uint16_t len  rubN
* ߒlFint8_t         : blk1 < blk2
*                        0 : blk1 = blk2
*                      : blk1 > blk2
*****************************************************************************/
int8_t ss_memcmp_SS( SSMP blk1 ,SSMP blk2 ,uint16_t len )
{
	int8_t d1 = 0 ,d2 = 0;

	while ( len-- ) {
		d1 = ss_read_byte( blk1++ );
		d2 = ss_read_byte( blk2++ );
		if ( d1 != d2 ) {
			break;
		}
	}

	return ( d1 - d2 );
}

/*****************************************************************************
*							->lϊ
*@FSSMP     str  SPI-SRAM擪AhX
*		 uint16_t *val ϊꂽl
*@ߒlFuint8_t       0:OK !0:NG
*****************************************************************************/
uint8_t atou_SS( SSMP str ,uint16_t *val )
{
	uint8_t c;
	uint32_t n = 0L;

	*val = 0;

	/* 󔒕XLbv			*/
	do {
		c = ss_read_byte( str++ );
	} while ( c == ' ' );

	/* lϊ						*/
	while ( c != '\0' ) {
		if ( ( c >= '0' ) && ( c <= '9' ) ) {
			n *= 10L;
			n += (uint32_t)( c - '0' );
			if ( n > 65535L ) {
				return ( 1 );
			}
		} else if ( c == ' ' ) {
			break;

		} else {
			return ( 1 );
		}
		c = ss_read_byte( str++ );
	}

	*val = (uint16_t)n;
	return ( 0 );
}

/*****************************************************************************
*								񒷎擾
*@FSSMP     str  SPI-SRAM擪AhX
*@ߒlFuint16_t      
*****************************************************************************/
uint16_t strlen_SS( SSMP str )
{
	uint16_t len = 0;

	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( str );
	while ( spiTransfer( 0xff ) && len < 32767U ) {
		len++;
	}
	SRAM_DISABLE();

	return ( len );
}

/*****************************************************************************
*						̑Ő󔒕(0x20ȉ)폜
*@FSSMP s 
*@ߒlFvoid
*****************************************************************************/
void strtrim_SS( SSMP s )
{
	SSMP top = s;
	SSMP bottom = s + strlen_SS( s ) - 1;

	while ( top <= bottom ) {
		if ( ss_read_byte( top ) > ' ' ) {
			break;
		}
		top++;
	}

	while ( top <= bottom ) {
		if ( ss_read_byte( bottom ) > ' ' ) {
			break;
		}
		bottom--;
	}

	ss_write_byte( bottom + 1 ,'\0' );
	if ( s != top ) {
		ss_strcpy_s_SS( s ,0xffff ,top );
	}
}

/*****************************************************************************
*								Rs[
* FSSMP     dst  ]SPI-SRAM擪AhX
*       uint16_t size ]obt@TCY
*       char     *src AVR-SRAM擪AhX
* ߒlFuint16_t      Rs[( '\0' ͊܂܂Ȃ )
*****************************************************************************/
uint16_t ss_strcpy_s( SSMP dst ,uint16_t size ,char *src )
{
	uint16_t len = 0;
	if ( size ) {
		uint8_t c;
		SRAM_ENABLE( SARM_SS_CHIP );
		SRAM_SET_WRITE_POINT( dst );
		while ( size-- > 1 ) {
			c = *src++;
			if ( c == '\0' ) {
				break;
			}
			spiTransfer( c );
			len++;
		}
		spiTransfer( '\0' );
		SRAM_DISABLE();
	}
	return ( len );
}

/*****************************************************************************
*								Rs[
* FSSMP            dst  ]SPI-SRAM擪AhX
*       uint16_t        size ]obt@TCY
*       const prog_char *src AVR-PG擪AhX
* ߒlFuint16_t             Rs[( '\0' ͊܂܂Ȃ )
*****************************************************************************/
uint16_t ss_strcpy_s_P( SSMP dst ,uint16_t size ,const prog_char *src )
{
	uint16_t len = 0;
	if ( size ) {
		uint8_t c;
		SRAM_ENABLE( SARM_SS_CHIP );
		SRAM_SET_WRITE_POINT( dst );
		while ( size-- > 1 ) {
			c = pgm_read_byte( src++ );
			if ( c == '\0' ) {
				break;
			}
			spiTransfer( c );
			len++;
		}
		spiTransfer( '\0' );
		SRAM_DISABLE();
	}
	return ( len );
}

/*****************************************************************************
*								Rs[
* FSSMP     dst  ]SPI-SRAM擪AhX
*       uint16_t size ]obt@TCY
*       SSMP     src  SPI-SRAM擪AhX
* ߒlFuint16_t      Rs[( '\0' ͊܂܂Ȃ )
*****************************************************************************/
uint16_t ss_strcpy_s_SS( SSMP dst ,uint16_t size ,SSMP src )
{
	uint16_t len = 0;
	if ( size ) {
		uint8_t c;
		while ( size-- > 1 ) {
			c = ss_read_byte( src++ );
			if ( c == '\0' ) {
				break;
			}
			ss_write_byte( dst++ ,c );
			len++;
		}
		ss_write_byte( dst ,'\0' );
	}

	return ( len );
}

/*****************************************************************************
*								Rs[
* Fchar     *dst ]AVR-SRAM擪AhX
*       uint16_t size ]obt@TCY
*       SSMP     src  SPI-SRAM擪AhX
* ߒlFuint16_t      Rs[( '\0' ͊܂܂Ȃ )
*****************************************************************************/
uint16_t strcpy_s_SS( char *dst ,uint16_t size ,SSMP src )
{
	uint16_t len = 0;
	if ( size ) {
		uint8_t c;
		SRAM_ENABLE( SARM_SS_CHIP );
		SRAM_SET_READ_POINT( src );
		while ( size-- > 1 ) {
			c = spiTransfer( 0xff );
			if ( c == '\0' ) {
				break;
			}
			*dst++ = c;
			len++;
		}
		*dst = '\0';
		SRAM_DISABLE();
	}
	return ( len );
}

/*****************************************************************************
*								A
* FSSMP     dst  A敶(SPI-SRAM擪AhX)
*       uint16_t size Aobt@TCY
*       char     *src A(AVR-SRAM擪AhX)
* ߒlFvoid
*****************************************************************************/
void ss_strcat_s( SSMP dst ,uint16_t size ,char *src )
{
	if ( size ) {
		uint16_t len = strlen_SS( dst );
		if ( len < size ) {
			size -= len;
			dst += len;
			ss_strcpy_s( dst ,size ,src );
		}
	}
}

/*****************************************************************************
*								A
* FSSMP            dst  A敶(SPI-SRAM擪AhX)
*       uint16_t        size Aobt@TCY
*       const prog_char *src A(AVR-PG擪AhX)
* ߒlFvoid
*****************************************************************************/
void ss_strcat_s_P( SSMP dst ,uint16_t size ,const prog_char *src )
{
	if ( size ) {
		uint16_t len = strlen_SS( dst );
		if ( len < size ) {
			size -= len;
			dst += len;
			ss_strcpy_s_P( dst ,size ,src );
		}
	}
}

/*****************************************************************************
*								A
* FSSMP     dst  A敶(SPI-SRAM擪AhX)
*       uint16_t size Aobt@TCY
*       SSMP     src  SPI-SRAM擪AhX
* ߒlFvoid
*****************************************************************************/
void ss_strcat_s_SS( SSMP dst ,uint16_t size ,SSMP src )
{
	if ( size ) {
		uint16_t len = strlen_SS( dst );
		if ( len < size ) {
			size -= len;
			dst += len;
			ss_strcpy_s_SS( dst ,size ,src );
		}
	}
}

/*****************************************************************************
*								A
* Fchar     *dst A敶(AVR-SRAM擪AhX)
*       uint16_t size Aobt@TCY
*       SSMP     src  SPI-SRAM擪AhX
* ߒlFvoid
*****************************************************************************/
void strcat_s_SS( char *dst ,uint16_t size ,SSMP src )
{
	if ( size ) {
		uint16_t len = strlen( dst );
		if ( len < size ) {
			size -= len;
			dst += len;
			strcpy_s_SS( dst ,size ,src );
		}
	}
}

/*****************************************************************************
*								r
* FSSMP   str1    r1(SPI-SRAM擪AhX)
*       char   *str2   r2(AVR-SRAM擪AhX)
* ߒlFint8_t          : str1 < str2
*					      0 : str1 = str2
*			            : str1 > str2
*****************************************************************************/
int8_t ss_strcmp( SSMP str1 ,char *str2 )
{
	int8_t c1 ,c2;
	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( str1 );
	do {
		c1 = spiTransfer( 0xff );
		c2 = *str2++;
	} while ( ( c1 == c2 ) && ( c1 != '\0' ) );
	SRAM_DISABLE();
	return ( c1 - c2 );
}

/*****************************************************************************
*								r
* FSSMP            str1   r1(SPI-SRAM擪AhX)
*       const prog_char *str2  r2(AVR-PG擪AhX)
* ߒlFint8_t                  : str1 < str2
*					              0 : str1 = str2
*			                    : str1 > str2
*****************************************************************************/
int8_t ss_strcmp_P( SSMP str1 ,const prog_char *str2 )
{
	int8_t c1 ,c2;
	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( str1 );
	do {
		c1 = spiTransfer( 0xff );
		c2 = pgm_read_byte( str2++ );
	} while ( ( c1 == c2 ) && ( c1 != '\0' ) );
	SRAM_DISABLE();
	return ( c1 - c2 );
}

/*****************************************************************************
*								r
* FSSMP   str1  r1(SPI-SRAM擪AhX)
*       SSMP   str2  r2(SPI-SRAM擪AhX)
* ߒlFint8_t        : str1 < str2
*				        0 : str1 = str2
*			          : str1 > str2
*****************************************************************************/
int8_t ss_strcmp_SS( SSMP str1 ,SSMP str2 )
{
	int8_t c1 ,c2;
	do {
		c1 = ss_read_byte( str1++ );
		c2 = ss_read_byte( str2++ );
	} while ( ( c1 == c2 ) && ( c1 != '\0' ) );
	return ( c1 - c2 );
}

/*****************************************************************************
*								
*@FSSMP s1  Ώە(SPI-SRAM擪AhX)
*        char c   
*@ߒlFSSMP     ŏɌʒu(0:error)
*****************************************************************************/
SSMP ss_strchr( SSMP s1 ,char c )
{
	uint8_t c1;
	do {
		c1 = ss_read_byte( s1 );
		if ( c == c1 ) {
			return ( s1 );
		}
		s1++;
	} while ( c1 != '\0' );

	return ( 0 );
}

/*****************************************************************************
*								
*@FSSMP s1  Ώە(SPI-SRAM擪AhX)
*        char c   
*@ߒlFSSMP     ŏɌʒu(0:error)
*****************************************************************************/
SSMP ss_strcasechr( SSMP s1 ,char c )
{
	uint8_t c1;
	c = toupper( c );
	do {
		c1 = toupper( ss_read_byte( s1 ) );
		if ( c == c1 ) {
			return ( s1 );
		}
		s1++;
	} while ( c1 != '\0' );

	return ( 0 );
}

/*****************************************************************************
*								񕔕
*@FSSMP s1  Ώە(SPI-SRAM擪AhX)
*        char *s2 (AVR-SRAM擪AhX)
*@ߒlFSSMP     ŏɌʒu(0:error)
*****************************************************************************/
SSMP ss_strstr( SSMP s1 ,char *s2 )
{
	SSMP ss1;
	char *ss2;
	uint8_t c = *s2++;

	if ( c == '\0' ) {
		return ( s1 );
	}

	do {
		if ( ss_read_byte( s1 ) == c ) {
			for ( ss1 = s1 + 1 ,ss2 = s2 ;( *ss2 != '\0' ) && ( ss_read_byte( ss1 ) == *ss2 ) ;ss1++, ss2++ );
			if ( *ss2 == '\0' ) {
				return ( s1 );
			}
		}
	} while ( ss_read_byte( s1++ ) != '\0' );

	return ( 0 );
}

/*****************************************************************************
*								񕔕
*@FSSMP            s1  Ώە(SPI-SRAM擪AhX)
*        const prog_char *s2 (AVR-PG擪AhX)
*@ߒlFSSMP                ŏɌʒu(0:error)
*****************************************************************************/
SSMP ss_strstr_P( SSMP s1 ,const prog_char *s2 )
{
	SSMP ss1;
	const prog_char *ss2;
	uint8_t c = pgm_read_byte( s2++ );

	if ( c == '\0' ) {
		return ( s1 );
	}

	do {
		if ( ss_read_byte( s1 ) == c ) {
			for ( ss1 = s1 + 1 ,ss2 = s2 ;( pgm_read_byte( ss2 ) != '\0' ) && ( ss_read_byte( ss1 ) == pgm_read_byte( ss2 ) ) ;ss1++, ss2++ );
			if ( pgm_read_byte( ss2 ) == '\0' ) {
				return ( s1 );
			}
		}
	} while ( ss_read_byte( s1++ ) != '\0' );

	return ( 0 );
}

/*****************************************************************************
*								񕔕
*@FSSMP  s1 Ώە(SPI-SRAM擪AhX)
*        SSMP  s2 (SPI-SRAM擪AhX)
*@ߒlFSSMP     ŏɌʒu(0:error)
*****************************************************************************/
SSMP ss_strstr_SS( SSMP s1 ,SSMP s2 )
{
	SSMP ss1;
	SSMP ss2;
	uint8_t c = ss_read_byte( s2++ );

	if ( c == '\0' ) {
		return ( s1 );
	}

	do {
		if ( ss_read_byte( s1 ) == c ) {
			for ( ss1 = s1 + 1 ,ss2 = s2 ;( ss_read_byte( ss2 ) != '\0' ) && ( ss_read_byte( ss1 ) == ss_read_byte( ss2 ) ) ;ss1++, ss2++ );
			if ( ss_read_byte( ss2 ) == '\0' ) {
				return ( s1 );
			}
		}
	} while ( ss_read_byte( s1++ ) != '\0' );

	return ( 0 );
}

/*****************************************************************************
*						r(啶Ej
* FSSMP   str1    r1(SPI-SRAM擪AhX)
*       char   *str2   r2(AVR-SRAM擪AhX)
* ߒlFint8_t          : str1 < str2
*					      0 : str1 = str2
*			            : str1 > str2
*****************************************************************************/
int8_t ss_strcasecmp( SSMP str1 ,char *str2 )
{
	int8_t c1 ,c2;
	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( str1 );
	do {
		c1 = toupper( spiTransfer( 0xff ) );
		c2 = toupper( *str2++ );
	} while ( ( c1 == c2 ) && ( c1 != '\0' ) );
	SRAM_DISABLE();
	return ( c1 - c2 );
}

/*****************************************************************************
*						r(啶Ej
* FSSMP            str1   r1(SPI-SRAM擪AhX)
*       const prog_char *str2  r2(AVR-PG擪AhX)
* ߒlFint8_t                  : str1 < str2
*					              0 : str1 = str2
*			                    : str1 > str2
*****************************************************************************/
int8_t ss_strcasecmp_P( SSMP str1 ,const prog_char *str2 )
{
	int8_t c1 ,c2;
	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( str1 );
	do {
		c1 = toupper( spiTransfer( 0xff ) );
		c2 = toupper( pgm_read_byte( str2++ ) );
	} while ( ( c1 == c2 ) && ( c1 != '\0' ) );
	SRAM_DISABLE();
	return ( c1 - c2 );
}

/*****************************************************************************
*						r(啶Ej
* FSSMP   str1  r1(SPI-SRAM擪AhX)
*       SSMP   str2  r2(SPI-SRAM擪AhX)
* ߒlFint8_t        : str1 < str2
*				        0 : str1 = str2
*			          : str1 > str2
*****************************************************************************/
int8_t ss_strcasecmp_SS( SSMP str1 ,SSMP str2 )
{
	int8_t c1 ,c2;
	do {
		c1 = toupper( ss_read_byte( str1++ ) );
		c2 = toupper( ss_read_byte( str2++ ) );
	} while ( ( c1 == c2 ) && ( c1 != '\0' ) );
	return ( c1 - c2 );
}

/*****************************************************************************
*						񕔕(啶Ej
*@FSSMP s1  Ώە(SPI-SRAM擪AhX)
*        char *s2 (AVR-SRAM擪AhX)
*@ߒlFSSMP     ŏɌʒu(0:error)
*****************************************************************************/
SSMP ss_strcasestr( SSMP s1 ,char *s2 )
{
	SSMP ss1;
	char *ss2;
	uint8_t c = *s2++;

	if ( c == '\0' ) {
		return ( s1 );
	}

	do {
		if ( toupper( ss_read_byte( s1 ) ) == toupper( c ) ) {
			for ( ss1 = s1 + 1 ,ss2 = s2 ;( *ss2 != '\0' ) && ( toupper( ss_read_byte( ss1 ) ) == toupper( *ss2 ) ) ;ss1++, ss2++ );
			if ( *ss2 == '\0' ) {
				return ( s1 );
			}
		}
	} while ( ss_read_byte( s1++ ) != '\0' );

	return ( 0 );
}

/*****************************************************************************
*						񕔕(啶Ej
*@FSSMP            s1  Ώە(SPI-SRAM擪AhX)
*        const prog_char *s2 (AVR-PG擪AhX)
*@ߒlFSSMP                ŏɌʒu(0:error)
*****************************************************************************/
SSMP ss_strcasestr_P( SSMP s1 ,const prog_char *s2 )
{
	SSMP ss1;
	const prog_char *ss2;
	uint8_t c = pgm_read_byte( s2++ );

	if ( c == '\0' ) {
		return ( s1 );
	}

	do {
		if ( toupper( ss_read_byte( s1 ) ) == toupper( c ) ) {
			for ( ss1 = s1 + 1 ,ss2 = s2 ;( pgm_read_byte( ss2 ) != '\0' ) && ( toupper( ss_read_byte( ss1 ) ) == toupper( pgm_read_byte( ss2 ) ) ) ;ss1++, ss2++ );
			if ( pgm_read_byte( ss2 ) == '\0' ) {
				return ( s1 );
			}
		}
	} while ( ss_read_byte( s1++ ) != '\0' );

	return ( 0 );
}

/*****************************************************************************
*						񕔕(啶Ej
*@FSSMP  s1 Ώە(SPI-SRAM擪AhX)
*        SSMP  s2 (SPI-SRAM擪AhX)
*@ߒlFSSMP     ŏɌʒu(0:error)
*****************************************************************************/
SSMP ss_strcasestr_SS( SSMP s1 ,SSMP s2 )
{
	SSMP ss1;
	SSMP ss2;
	uint8_t c = ss_read_byte( s2++ );

	if ( c == '\0' ) {
		return ( s1 );
	}

	do {
		if ( toupper( ss_read_byte( s1 ) ) == toupper( c ) ) {
			for ( ss1 = s1 + 1 ,ss2 = s2 ;( ss_read_byte( ss2 ) != '\0' ) && ( toupper( ss_read_byte( ss1 ) ) == toupper( ss_read_byte( ss2 ) ) ) ;ss1++, ss2++ );
			if ( ss_read_byte( ss2 ) == '\0' ) {
				return ( s1 );
			}
		}
	} while ( ss_read_byte( s1++ ) != '\0' );

	return ( 0 );
}

/*****************************************************************************
* 							Wo͂ɕo(Ōɉs)
* FSSMP str (SPI-SRAMAhX)
* ߒlFvoid
*****************************************************************************/
void puts_SS( SSMP str )
{
	print_SS( str );
	puts_P( PSTR("") );
}

/*****************************************************************************
* 							Wo͂ɕo(sȂ)
* FSSMP str (SPI-SRAMAhX)
* ߒlFvoid
*****************************************************************************/
void print_SS( SSMP str )
{
	uint8_t c;

	SRAM_ENABLE( SARM_SS_CHIP );
	SRAM_SET_READ_POINT( str );
	while ( ( c = spiTransfer( 0xff ) ) != '\0' ) {
		printf_P( PSTR("%c") ,c );
	}
	SRAM_DISABLE();
}

//
// }``bvp
// jAubN]֐Q
//
#if USE_LAGE_BLOCK_COPY
/*****************************************************************************
*				SPI-SRAM̎wAhXAVR-SRAMubN
* FSLMP     addr   SPI-SRAMAhX
*       void     *data  ݃f[^
*       uint16_t len    ݃f[^
* ߒlFvoid
*****************************************************************************/
void sl_write_block( SLMP addr ,void *data ,uint16_t len )
{
	uint8_t *p = (uint8_t *)data;
	uint8_t cs = (uint8_t)( ( addr & 0x00018000 ) >> 15 ) & 0x03;
	uint16_t offset = (uint16_t)addr & 0x7fff;

	SRAM_ENABLE( cs );
	SRAM_SET_WRITE_POINT( offset );

	while ( len-- ) {
		spiTransfer( *p++ );
		if ( ++offset & 0x8000 ) {
			offset = 0;
			cs++;
			SRAM_ENABLE( cs );
			SRAM_SET_WRITE_POINT( 0 );
		}
	}

	SRAM_DISABLE();
}

/*****************************************************************************
*				SPI-SRAM -> AVRSRAM ubNǂݍ
* FSLMP     addr  SPI-SRAMAhX
*       void     *data ǂݍ݃f[^
*       uint16_t len   ǂݍ݃f[^
* ߒlFvoid
*****************************************************************************/
void sl_read_block( SLMP addr ,void *data ,uint16_t len )
{
	uint8_t *p = (uint8_t *)data;
	uint8_t cs = (uint8_t)( ( addr & 0x00018000 ) >> 15 ) & 0x03;
	uint16_t offset = (uint16_t)addr & 0x7fff;

	SRAM_ENABLE( cs );
	SRAM_SET_READ_POINT( offset );
	while ( len-- ) {
		*p++ = spiTransfer( 0xff );
		if ( ++offset & 0x8000 ) {
			offset = 0;
			cs++;
			SRAM_ENABLE( cs );
			SRAM_SET_READ_POINT( 0 );
		}
	}
	SRAM_DISABLE();
}
#endif // if USE_LAGE_BLOCK_COPY

//
// }``bvp
// Oobt@֐Q
//
#if USE_RING_BUFFER
/*****************************************************************************
*						SPI-SRAM̃Oobt@NA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void ss_ringBuffer_clear( void )
{
	ringRp = ringWp = 0;
	ringRpCS = ringWpCS = 0;
	ringDataCount = 0L;
}

/*****************************************************************************
*					SPI-SRAM̃Oobt@f[^TCY擾
* Fvoid
* ߒlFuint32_t
*****************************************************************************/
uint32_t ss_ringBuffer_getDataSize( void )
{
	return ( ringDataCount );
}

/*****************************************************************************
*				\PbgMf[^SPI-SRAM̃Oobt@
* FSOCKET   sok \Pbgԍ
*       uint16_t len Mf[^
* ߒlFuint16_t     ۂɎMf[^
*****************************************************************************/
uint16_t ss_ringBuffer_recv( SOCKET sok ,uint16_t len )
{
	uint16_t RxMASK = wiz_getIINCHIP_RxMASK( sok ); 
	uint16_t RxMAX  = wiz_getIINCHIP_RxMAX( sok );
	uint16_t RxBASE = wiz_getIINCHIP_RxBASE( sok );
	uint16_t rp = wiz_getSn_RX_RD( sok );
	uint16_t rd_mask = rp & RxMASK;
	uint16_t ptr = RxBASE + rd_mask;

	uint16_t size ,n;

	if ( len > SRAM_RING_BUFFER_SIZE - ringDataCount ) {
		len = SRAM_RING_BUFFER_SIZE - ringDataCount;
	}

	if ( len ) {

		SRAM_ENABLE( ringWpCS );
		SRAM_SET_WRITE_POINT( ringWp );

		if ( ( rd_mask + len ) > RxMAX ) {				/* ̈悪fĂH	*/
			n = size = RxMAX - rd_mask;
			while ( n-- ) {								/* OubN]			*/
				spiTransfer( wiz_read_byte( ptr++ ) );
				if ( ++ringWp & 0x8000 ) {
					ringWp = 0;
					ringWpCS++;
					ringWpCS %= SRAM_RING_BUFFER_CHIP_COUNT;
					SRAM_ENABLE( ringWpCS );
					SRAM_SET_WRITE_POINT( 0 );
				}
			}

			n = len - size;								/* 㔼ubN]			*/
			ptr = RxBASE;
			while ( n-- ) {
				spiTransfer( wiz_read_byte( ptr++ ) );
				if ( ++ringWp & 0x8000 ) {
					ringWp = 0;
					ringWpCS++;
					ringWpCS %= SRAM_RING_BUFFER_CHIP_COUNT;
					SRAM_ENABLE( ringWpCS );
					SRAM_SET_WRITE_POINT( 0 );
				}
			}

		} else {										/* AubN]			*/
			n = len;
			while ( n-- ) {
				spiTransfer( wiz_read_byte( ptr++ ) );
				if ( ++ringWp & 0x8000 ) {
					ringWp = 0;
					ringWpCS++;
					ringWpCS %= SRAM_RING_BUFFER_CHIP_COUNT;
					SRAM_ENABLE( ringWpCS );
					SRAM_SET_WRITE_POINT( 0 );
				}
			}
		}

		SRAM_DISABLE();

		rp += len;
		wiz_setSn_RX_RD( sok ,rp );
		wiz_sockCommand( sok ,Sn_CR_RECV );
		ringDataCount += len;
	}

	return ( len );
}

/*****************************************************************************
*					SPI-SRAM Oobt@f[^VS1053b֓]
* Fuint16_t len  ]f[^
* ߒlFuint16_t      ]f[^
*****************************************************************************/
uint16_t ss_ringBuffer_transfer_VS1053B( uint16_t len )
{
	uint8_t n;
	uint16_t nn = 0;

	if ( (uint32_t)len > ringDataCount ) {
		len = (uint16_t)ringDataCount;
	}

	if ( len ) {
		SRAM_ENABLE( ringRpCS );
		SRAM_SET_READ_POINT( ringRp );

		VS_ENABLE_XDCS();
		while ( len && VS_GET_DREQ() ) {

			n = 32;							/* PDREQ32byte܂ł̓]ۏႳĂ	*/
			if ( len < 32 ) {
				n = len;
			}
			nn += n;
			len -= n;

			while ( n-- ) {
				vsWriteByte( spiTransfer( 0xff ) );
				if ( ++ringRp & 0x8000 ) {
					ringRp = 0;
					ringRpCS++;
					ringRpCS %= SRAM_RING_BUFFER_CHIP_COUNT;
					SRAM_ENABLE( ringRpCS );
					SRAM_SET_READ_POINT( 0 );
				}
			}
		}

		VS_DISABLE_XDCS();
		SRAM_DISABLE();
	}

	ringDataCount -= nn;
	return ( nn );
}

/*****************************************************************************
*					SPI-SRAM Oobt@f[^擾
* Fvoid     *data obt@
*		uint16_t len   擾f[^
* ߒlFuint16_t       f[^
*****************************************************************************/
uint16_t ss_ringBuffer_read( void *data ,uint16_t len )
{
	uint16_t n = 0;
	uint8_t *p = (uint8_t *)data;

	if ( (uint32_t)len > ringDataCount ) {
		len = (uint16_t)ringDataCount;
	}

	if ( len ) {
		SRAM_ENABLE( ringRpCS );
		SRAM_SET_READ_POINT( ringRp );

		n = len;
		while ( n-- ) {
			*p++ = spiTransfer( 0xff );
			if ( ++ringRp & 0x8000 ) {
				ringRp = 0;
				ringRpCS++;
				ringRpCS %= SRAM_RING_BUFFER_CHIP_COUNT;
				SRAM_ENABLE( ringRpCS );
				SRAM_SET_READ_POINT( 0 );
			}
		}

		SRAM_DISABLE();
		ringDataCount -= len;
	}

	return ( len );
}

/*****************************************************************************
*				SPI-SRAM Oobt@f[^擾( to SPI-SRAM)
* FSSMP     data data obt@
*		uint16_t len  擾f[^
* ߒlFuint16_t      f[^
*****************************************************************************/
uint16_t ss_ringBuffer_read_SS( SSMP data ,uint16_t len )
{
	uint16_t n = 0;

	if ( (uint32_t)len > ringDataCount ) {
		len = (uint16_t)ringDataCount;
	}

	if ( len ) {
		n = len;
		while ( n-- ) {
			SRAM_ENABLE( ringRpCS );
			SRAM_SET_READ_POINT( ringRp );
			ss_write_byte( data++ ,spiTransfer( 0xff ) );
			if ( ++ringRp & 0x8000 ) {
				ringRp = 0;
				ringRpCS++;
				ringRpCS %= SRAM_RING_BUFFER_CHIP_COUNT;
			}
		}
		ringDataCount -= len;
	}

	return ( len );
}

#endif // #if USE_RING_BUFFER

