/*###########################################################################
#                                                                           #
#                       SPIڑSRAM u23K256v䃂W[                #
#																			#
# VO`bvpɂ͖Lxȃ֐QpӂĂ              #
# }``bvpɂ̓Oobt@P񋟂(Xg[~Op) 	    #
#                                                                           #
# ڃ`bv̂PVO[hpɊ蓖ĂāAc̓}``bv#
# pɊ蓖Ă														#
#                                                                           #
###########################################################################*/
#ifndef __23K256_H__
#define __23K256_H__

#include <avr/io.h>
#include <avr/pgmspace.h>

#define USE_LAGE_BLOCK_COPY 0			/* [W]gp^gp		*/
#define USE_RING_BUFFER     1			/* Oobt@gp^gp		*/

/* ڃg[^e			*/
#define SRAM_CHIP_COUNT 4				/* ڃ`bv						*/
#define SRAM_TOTAL_SIZE ( (uint32_t)SRAM_CHIP_COUNT * 32768L )

/* Oobt@\`bv		*/
#define SRAM_RING_BUFFER_CHIP_COUNT 3	/* Oobt@Ɏgp`bv	*/
#define SRAM_RING_BUFFER_SIZE (uint32_t)( SRAM_RING_BUFFER_CHIP_COUNT * 32768UL )

/* X[VXe`bvԍ	*/
#define SARM_SS_CHIP ( SRAM_CHIP_COUNT - 1 )

#ifdef __23K256_C__

/* CSiˑj			*/
static const prog_uint8_t MSK[] = { _BV(4) ,_BV(5) ,_BV(6) ,_BV(7) };
#define SRAM_ENABLE(cs) ( PORTB = ( PORTB | 0xf0 ) & ~pgm_read_byte( &MSK[cs] ) )
#define SRAM_DISABLE()  ( PORTB |= 0xf0 )

/* SPI|[g`					*/
#define SPI_TYPE 1					/* 0:soft 1:SPIport 2:USART0 3:USART1	*/

#define SPI_MOSI_PIN  PINB			/* MOSIɊĂ|[g(PINŎw)		*/
#define SPI_MOSI_BIT  2				/* MOSIɊĂ|[g̃rbgԍ		*/

#define SPI_MISO_PIN  PINB			/* MISOɊĂ|[g(PINŎw)		*/
#define SPI_MISO_BIT  3				/* MISOɊĂ|[g̃rbgԍ		*/

#define SPI_SCK_PIN   PINB			/* SCKɊĂ|[g(PINŎw)		*/
#define SPI_SCK_BIT   1				/* SCKɊĂ|[g̃rbgԍ		*/

#include "../myutil/spi_func.h"

#endif	// #ifdef __23K256_C__

/* f[^^`					*/
typedef uint32_t SLMP;			/* SPI-SRAM [W|C^				*/
typedef uint16_t SSMP;			/* SPI-SRAM V[g|C^			*/

/* ֐vg^Cv錾			*/
void sram_init( void );

void ss_write_byte( SSMP addr ,uint8_t data );
void ss_write_word( SSMP addr ,uint16_t data );
void ss_write_dword( SSMP addr ,uint32_t data );

uint8_t ss_read_byte( SSMP addr );
uint16_t ss_read_word( SSMP addr );
uint32_t ss_read_dword( SSMP addr );

SSMP ss_memset( SSMP addr ,uint8_t val ,uint16_t len );

SSMP ss_memcpy( SSMP dst ,void *src ,uint16_t len );
SSMP ss_memcpy_P( SSMP dst ,const prog_void *src ,uint16_t len );
SSMP ss_memcpy_SS( SSMP dst ,SSMP src ,uint16_t len );
void *memcpy_SS( void *dst ,SSMP src ,uint16_t len );

int8_t ss_memcmp( SSMP blk1 ,void *blk2 ,uint16_t len );
int8_t ss_memcmp_P( SSMP blk1 ,const prog_void *blk2 ,uint16_t len );
int8_t ss_memcmp_SS( SSMP blk1 ,SSMP blk2 ,uint16_t len );

uint8_t atou_SS( SSMP str ,uint16_t *val );
uint16_t strlen_SS( SSMP str );
void strtrim_SS( SSMP s );

uint16_t ss_strcpy_s( SSMP dst ,uint16_t size ,char *src );
uint16_t ss_strcpy_s_P( SSMP dst ,uint16_t size ,const prog_char *src );
uint16_t ss_strcpy_s_SS( SSMP dst ,uint16_t size ,SSMP src );
uint16_t strcpy_s_SS( char *dst ,uint16_t size ,SSMP src );

void ss_strcat_s( SSMP dst ,uint16_t size ,char *src );
void ss_strcat_s_P( SSMP dst ,uint16_t size ,const prog_char *src );
void ss_strcat_s_SS( SSMP dst ,uint16_t size ,SSMP src );
void strcat_s_SS( char *dst ,uint16_t size ,SSMP src );

int8_t ss_strcmp( SSMP str1 ,char *str2 );
int8_t ss_strcmp_P( SSMP str1 ,const prog_char *str2 );
int8_t ss_strcmp_SS( SSMP str1 ,SSMP str2 );

SSMP ss_strchr( SSMP s1 ,char c );
SSMP ss_strcasechr( SSMP s1 ,char c );

SSMP ss_strstr( SSMP s1 ,char *s2 );
SSMP ss_strstr_P( SSMP s1 ,const prog_char *s2 );
SSMP ss_strstr_SS( SSMP s1 ,SSMP s2 );

int8_t ss_strcasecmp( SSMP str1 ,char *str2 );
int8_t ss_strcasecmp_P( SSMP str1 ,const prog_char *str2 );
int8_t ss_strcasecmp_SS( SSMP str1 ,SSMP str2 );

SSMP ss_strcasestr( SSMP s1 ,char *s2 );
SSMP ss_strcasestr_P( SSMP s1 ,const prog_char *s2 );
SSMP ss_strcasestr_SS( SSMP s1 ,SSMP s2 );

void puts_SS( SSMP str );
void print_SS( SSMP str );

#if USE_LAGE_BLOCK_COPY
void sl_write_block( SLMP addr ,void *data ,uint16_t len );
void sl_read_block( SLMP addr ,void *data ,uint16_t len );
#endif

#if USE_RING_BUFFER
#include "../w5100/w5100.h"
void ss_ringBuffer_clear( void );
uint32_t ss_ringBuffer_getDataSize( void );
uint16_t ss_ringBuffer_recv( SOCKET sok ,uint16_t len );
uint16_t ss_ringBuffer_transfer_VS1053B( uint16_t len );
uint16_t ss_ringBuffer_read( void *data ,uint16_t len );
uint16_t ss_ringBuffer_read_SS( SSMP data ,uint16_t len );
#endif

#endif	// #ifndef __23K256_H__
