/*###########################################################################
#                                                                           #
#          	WIW[ SPK-FM-301 䃂W[(AR1000)            #
#                                                                           #
###########################################################################*/
#ifndef __AR1000_H__
#define __AR1000_H__
#include <avr/io.h>

/* Mg(ʏ3)			*/
#define FM_BAND 3							/* 1 : 87.5MHz ` 108MHz		*/
											/* 2 : 76.0MHz ` 90.0MHz		*/
											/* 3 : 76.0MHz ` 108.0MHz		*/
#ifdef __AR1000_C__

/* TWINbN`(ʏ100KHz)	*/
#define TWI_CLOCK 100000L

/* ŒEőg					*/
#if ( FM_BAND == 1 )
#define FM_MIN_FREQ 875
#define FM_MAX_FREQ 1080

#elif ( FM_BAND == 2 )
#define FM_MIN_FREQ 760
#define FM_MAX_FREQ 900

#else
#define FM_MIN_FREQ 760
#define FM_MAX_FREQ 1080
#endif

/* AR1000 WX^` 			*/
#define	AR_R0		0x00
#define	AR_R1		0x01
#define	AR_R2		0x02
#define	AR_R3		0x03
#define	AR_R4		0x04
#define	AR_R5		0x05
#define	AR_R6		0x06
#define	AR_R7		0x07
#define	AR_R8		0x08
#define	AR_R9		0x09
#define	AR_R10		0x0a
#define	AR_R11		0x0b
#define	AR_R12		0x0c
#define	AR_R13		0x0d
#define	AR_R14		0x0e
#define	AR_R15		0x0f
#define	AR_R16		0x10
#define	AR_R17		0x11
#define	AR_RSSI		0x12
#define	AR_STATUS	0x13
#define	AR_RBS		0x14
#define	AR_RDS1		0x15
#define	AR_RDS2		0x16
#define	AR_RDS3		0x17
#define	AR_RDS4		0x18
#define	AR_RDS5		0x19
#define	AR_RDS6		0x1a
#define	AR_DEVID	0x1b
#define	AR_CHIPID	0x1c

/* WX^ R0 rbg}XN */
#define	AR_R0_ENABLE		0x0001	/* Analog and digital blocks enable signals */
#define	AR_R0_XO_EN			0x0002	/* Internal oscillator enable signal. Logic r using external reference clock, logic '1' for enable the internal oscillator. */

/* WX^ R1 rbg}XN */
#define	AR_R1_HMUTE			0x0002	/* Hard mute control signal. Logic '1' for enable; logic '0' for disable  Hard mute control signal. Logic '1' for enable; logic '0' for disable */
#define	AR_R1_SSUTE			0x0004	/* Soft mute control signal. Logic '1' for enable; logic '0' for disable. Disable it when testing sensitivity. */
#define	AR_R1_MONO			0x0008	/* Forced mono control signal. Logic '1' for mono; logic '0' depends on signal strength. */
#define	AR_R1_DEEMP			0x0010	/* De-emphasis. Logic '1' for 75-us de-emphasis, logic '0' for 50-us de-emphasis.  */
#define	AR_R1_RDS_EN		0x8000  /* RDS enable signal. */

/* WX^ R2 rbg}XN */
#define	AR_R2_CHAN 			0x01ff	/* Channel setting control signals. From 9'd0 to 9'd511. The FM channel is mapped by the equation. Frequency (MHz) = 69 + 0.1 * CHAN.  */
#define	AR_R2_TUNE			0x0200	/* TUNE channel enable signals. '1' = Enable, '0' = Disable. Each tuning process must set this signal from '0' to '1' to get the enabling edge signal. The STC flag is cleared to '0' automatically if TUNE is set to '0'. */

/* WX^ R3 rbg}XN */
#define	AR_R3_SEEKTH		0x007f	/* SEEK threshold control signals. Setting too high would result in channel missing.  */
#define	AR_R3_VOLUMN		0x0780	/* EAR amplifier analog gain control signals.  */

#define	AR_R3_BAND			0x1800  /* Band control signal.  								*/
									/* 2'b0x: US/Europe band. Range from 87.5MHz to 108MHz 	*/
									/* 2'b10: JAPAN band. Range from 76MHz to 90MHz 		*/
									/* 2'b11: JAPAN wide band. Range from 76MHz to 108MHz	*/

#if ( FM_BAND == 1 )
#define	VAL_BAND			0x0000
#elif ( FM_BAND == 2 )
#define	VAL_BAND			0x1000
#else
#define	VAL_BAND			0x1800
#endif

#define	AR_R3_SPACE			0x2000	/* Channel spacing setting signal for SEEK operation. Logic '1' for 100k, logic '0' for 200k. */
									/* When the spacing is set at 200k, no matter what the band is, it just increases or decreases it by 200k */
									/* spacing.  */

#define	AR_R3_SEEK			0x4000	/* SEEK channel enable signals ('1' for enable, '0' for disable). Each seeking process must set this */
									/* signal from '0' to '1' to get the enabling edge signal.  */

#define	AR_R3_SEEKUP		0x8000	/* Seek direction control signals. Logic '1' for seek up, logic '0' for seek down. */

/* WX^ R11 rbg}XN */
#define AR_R11_HILOCTRL_B1	0x0001	/* High side control bit 1 */
#define AR_R11_HILOCTRL_B2	0x0004	/* High side control bit 2 */
#define AR_R11_HILO_SIDE	0x8000	/* AFC high side and low side injection control.  */

/* WX^ R14 rbg}XN */
#define	AR_R14_VOLUME2		0xf000	/* Volume control 2 */

/* WX^ RSSI rbg}XN */
#define AE_RSSI_RSSI		0xfe00	/* RF input signal strength */
#define AE_RSSI_IF_CNT		0x01ff	/* IF frequency counter */

/* WX^ STATUS rbg}XN */
#define	AR_STATUS_ST		0x0008	/* Stereo flag, '1'=Stereo, '0'=Mono */
#define	AR_STATUS_SF		0x0010	/* Seek fail flag, '1'=Seek Fail, '0'=Successful */
#define	AR_STATUS_STC		0x0020	/* Seek/Tune complete flag, '1'=Complete, '0'=Incomplete */
#define	AR_STATUS_READCHAN	0xff80	/* Current Channel number */

#endif

/* ֐vg^Cv錾				*/
uint8_t fmReset( void );
uint8_t fmEnable( void );
uint8_t fmSetVolume( uint8_t vol );
uint8_t fmGetVolume( void );
uint16_t fmGetRssi( void );
uint8_t fmStartSeek( uint16_t freq ,uint8_t seekup ,uint8_t seekth );
uint8_t fmCheckSeek( uint16_t *freq );
uint8_t fmTune( uint16_t freq );

#endif
