/*###########################################################################
#                                                                           #
#                       vs1053b 䃂W[                              #
#                                                                           #
###########################################################################*/
#define __VS1053B_C__

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "vs1053b.h"
#include "../myutil/spi_func.h"
#include "../myutil/timer.h"

/* [Jϐ錾					*/
static uint8_t initFlag = 0;		/* ς݃tO				*/
static uint8_t volumeValue = 0;		/* ݂̃{[l			*/
static uint8_t vsMode = 0;			/* 0:ʏ탂[h  !0:^[h	*/

/* [J֐vg^Cv錾		*/
#if VS_IMAFIX
static void vsImaFix( void );
#endif

#if VS_VORBISPATCH
static void vsVorbisPatch( void );
#endif

#if VS_SPECTRUM_ANALYZER
static void vsSpectrumAnalyzerPatch( void );
#endif

/*****************************************************************************
*								DSP
* Fvoid
* ߒlFvoid
*****************************************************************************/
void vsInit( void )
{
	/* eϐ					*/
	vsMode = 0;								/* [h						*/
	volumeValue = 0;						/* ݂̃{[l			*/
	initFlag = 0;

	/* SPI						*/
	spiInit();

	/* DSPn[hEGAZbg			*/
	VS_ENABLE_XRESET();
	WAIT_MS( 5 );
	VS_DISABLE_XRESET();
	WAIT_MS( 5 );

	/* NbNݒ						*/
	vsSetClockMultiple( VS_MULTIPLE50 ,VS_ADD_MULTIPLE00 );
	WAIT_MS( 5 );

	/* \tgEGAZbg				*/
	vsResetPlayMode();

	/* SPINbNݒ					*/
	SPI_HI_SPEED();
	initFlag = 1;
}

/*****************************************************************************
*						DSPĐ[hŃZbg
* Fvoid
* ߒlFvoid
*****************************************************************************/
void vsResetPlayMode( void )
{
	/* VS1053B Đ[hŃZbg	*/
	vsRegWrite( SCI_MODE ,SM_SDINEW | SM_RESET );
	WAIT_MS( 5 );

	/* WIȃpb`Kp				*/
	#if VS_VORBISPATCH
	vsVorbisPatch();
	#endif

	#if VS_SPECTRUM_ANALYZER
	vsSpectrumAnalyzerPatch();
	#endif

	/* ʂlɐݒ				*/
	vsMode = 0;
	vsSetVolume( _VS_DEFAULT_VOLUME );
}

/*****************************************************************************
*						DSPIMA-ADPCM^[hŃZbg
* Fvoid
* ߒlFvoid
*****************************************************************************/
void vsResetRecordAdpcm( void )
{
	vsRegWrite( SCI_MODE    ,SM_SDINEW );
	vsRegWrite( SCI_BASS    ,0x0000 );
	vsRegWrite( SCI_AICTRL0 ,44100U );	/* ^TvO[g 44.1KHz	*/
	vsRegWrite( SCI_AICTRL1 ,    0U );	/* ^QC(I[g)				*/
	vsRegWrite( SCI_AICTRL2 , 4096U );	/* I[gQC̍ő呝x(x1=1024)*/
	vsRegWrite( SCI_AICTRL3 ,    0U );	/* WCgXeIEIMA-ADPCM	*/
	vsRegWrite( SCI_MODE ,SM_SDINEW | SM_RESET | SM_ADPCM | SM_LINE1 );
	WAIT_MS( 5 );

	#if VS_IMAFIX
	vsImaFix();
	#endif

	vsMode = 1;
	vsSetVolume( _VS_DEFAULT_VOLUME );
}

/*****************************************************************************
*							DSP̓NbNݒ
* Fuint16_t multiple     NbN{( VS_MULTIPLE10 ` VS_MULTIPLE50 )
*		uint16_t add_multiple WMA/AACĐ̒ǉ{( VS_ADD_MULTIPLE00
* ߒlFvoid										 	` VS_ADD_MULTIPLE20)
*****************************************************************************/
void vsSetClockMultiple( uint16_t multiple ,uint16_t add_multiple )
{
	uint16_t clock = ( (uint16_t)( ( VS_FCPU - 8000000L ) / 4000L ) & 0x07ff );
	vsRegWrite( SCI_CLOCKF ,multiple | add_multiple | clock );
	vsRegWrite( SCI_AUDATA ,0x1f40 );	/*	NbN𑦗Lɂׂ̃_~[*/
}

/*****************************************************************************
*								ݒ
* Fuint8_t f  g(1`15) KHzȏ̎g(1KHz`15KHz)
*       int8_t  lv 1.5db݂Ŏw( -8 ` 7 )  0:OFF
* ߒlFvoid
*****************************************************************************/
void vsHighPitchedSoundEmphasis( uint8_t f ,int8_t lv )
{
	uint16_t reg = vsRegRead( SCI_BASS ) & 0x00ff;
	reg |= ( ( lv & 0x0f ) << 12 ) | ( ( f & 0x0f ) << 8 );
	vsRegWrite( SCI_BASS ,reg );
}

/*****************************************************************************
*								ቹݒ
* Fuint8_t f  g(2`15) Hzȉ̎g(20Hz`150Hz)
*		uint8_t lv 1db݂Ŏw( 0 ` 15 )  0:OFF
* ߒlFvoid
*****************************************************************************/
void vsBassEmphasis( uint8_t f ,uint8_t lv )
{
	uint16_t reg = vsRegRead( SCI_BASS ) & 0xff00;
	reg |= ( ( lv & 0x0f ) << 4 ) | ( f & 0x0f );
	vsRegWrite( SCI_BASS ,reg );
}

/*****************************************************************************
*								gݒ
* Fuint8_t lv 0 ʏ
*				   1 wbhtHŕʂ̉y𒮂ꍇ()
*				   2 wbhtHŕʂ̉y𒮂ꍇ(j
*				   3 Â܂'hC'Ș^AMIDI𒮂ꍇ(ŋ)
* ߒlFvoid
*****************************************************************************/
void vsSetEarSpeaker( uint8_t lv )
{
	uint16_t reg = vsRegRead( SCI_MODE ) & ~( SM_EARSPEAKER_LO | SM_EARSPEAKER_HI );
	switch ( lv ) {
		case 1:
			reg |= SM_EARSPEAKER_LO;
			break;

		case 2:
			reg |= SM_EARSPEAKER_HI;
			break;

		case 3:
			reg |= SM_EARSPEAKER_LO;
			reg |= SM_EARSPEAKER_HI;
			break;

		default:
			break;
	}

	vsRegWrite( SCI_MODE ,reg );
}

/*****************************************************************************
*							{[ݒ
* Fuint8_t vol ʒl @0FŒቹ(-90db)
*                          180Fő剹(-0db)
* ߒlFvoid
*            DAC_VOL / SCI_VOL WX^ɑΉׂɕςȎdlƂȂ
*****************************************************************************/
void vsSetVolume( uint8_t vol )
{
	if ( vol > 180 ) {
		vol = 180;
	}
	uint8_t data = 180 - vol;

	/* ʏ탂[h̏ꍇ SCI_VOL 𑀍		*/
	if ( vsMode == 0 ) {
		if ( vol ) {
			vsRegWrite( SCI_VOL ,( (uint16_t)data << 8 ) | (uint16_t)data );
		} else {
			vsRegWrite( SCI_VOL ,0xfefe );
		}

	/* ^[h̏ꍇ DAC_VOL 𑀍		*/
	} else {
		uint16_t val = (uint16_t)data * 5;
		uint8_t l4 = (uint8_t)( ( val + 59 ) / 60 );
		uint8_t h4 = (uint8_t)( ( ( (uint16_t)l4 * 60 ) - val ) / 5 );
		val = ( ( h4 << 4 ) | l4 );
		vsRegWrite( SCI_WRAMADDR ,0xc045 );		/* DAC_VOLWX^̃AhX */
		vsRegWrite( SCI_WRAM ,( val << 8 ) | val );
	}

	volumeValue = vol;
}

/*****************************************************************************
*							{[擾
* Fvoid
* ߒlFuint8_t vol ʒl@ 0FŒቹ(-90db)
*                          180Fő剹(-0db)
*****************************************************************************/
uint8_t vsGetVolume( void )
{
	return ( volumeValue );
}

/*****************************************************************************
*									BEEP
* Fuint16_t  f      g(Hz)
*       uint8_t   n      
*		uint8_t   length 1̒(msec)
* ߒlF
*****************************************************************************/
void vsBeep( uint16_t f ,uint8_t n ,uint8_t length )
{
	/*@DSPp[^ޔ													*/
	uint16_t mode = vsRegRead( SCI_MODE );
	uint16_t bass = vsRegRead( SCI_BASS );
	uint8_t vol = volumeValue;

	/*@eXg[hJ													*/
	vsSetVolume( 0 );
	vsRegWrite( SCI_BASS ,0x0000 );
	vsRegWrite( SCI_MODE ,SM_SDINEW | SM_TESTS | SM_RESET );
	WAIT_MS( 5 );

	/* BEEPʐݒ															*/
	vsSetVolume( _VS_BEEP_VOLUME );

	/* SINgp[^ݒ													*/
	f = (uint16_t)( ( (uint32_t)f * 65536UL ) / 44101UL );
	vsRegWrite( SCI_AUDATA , 0xac45 );	/* TvO[g@44.101KHz	*/
	vsRegWrite( SCI_AICTRL0 ,f );		/* `lSINggݒ		*/
	vsRegWrite( SCI_AICTRL1 ,f );		/* E`lSINggݒ		*/

	/* ꂪȂƘȀ̉Ă܂					*/
	vsRegWrite( SCI_AIADDR  ,0x4022 );	/* SINg~						*/
	WAIT_MS( 18 );

	/* BEEP[v														*/
	while ( n-- ) {
		vsRegWrite( SCI_AIADDR  ,0x4020 );		/* SINg				*/
		WAIT_MS( length );
		vsRegWrite( SCI_AIADDR  ,0x4022 );		/* SINg~				*/
		WAIT_MS( 35 );
	}

	/* ꂪBeepɁuubv݂ȉ					*/
	WAIT_MS( 18 );

	/* DSPp[^A													*/
	vsSetVolume( 0 );
	vsRegWrite( SCI_MODE ,mode | SM_RESET );
	WAIT_MS( 5 );
	vsRegWrite( SCI_BASS ,bass );
	vsSetVolume( vol );
}

#if VS_USE_FAINARAIZ
/*****************************************************************************
*							VS1053b t@CiCY
* Fvoid
* ߒlFvoid
*****************************************************************************/
void vsFainaraiz( void )
{
	uint8_t endFillByte;
	uint16_t n;

	/* X_ENDFILLBYTE 擾											*/
	endFillByte = (uint8_t)( vsReadXmem( X_ENDFILLBYTE ) & 0x00ff );

	/* X_ENDFILLBYTEl2080o									*/
	/* VS1053b̃obt@̃f[^ׂčĐׂƎv	*/
	VS_ENABLE_XDCS();
	for ( n = 0 ;n < 2048 ;n++ ) {
		while ( !VS_GET_DREQ() );
		vsWriteByte( endFillByte );
	}
	VS_DISABLE_XDCS();

	/* SM_CANCEL s												*/
	vsRegWrite( SCI_MODE ,vsRegRead( SCI_MODE ) | SM_CANCEL );

	/* SM_CANCELI҂										*/
	for ( n = 0 ;n < 2048 ;n++ ) {
		if ( !( vsRegRead( SCI_MODE ) & SM_CANCEL ) ) {
			break;
		}

		while ( !VS_GET_DREQ() );
		VS_ENABLE_XDCS();
		vsWriteByte( endFillByte );
		VS_DISABLE_XDCS();
	}

	/* Xe[^Xُ̏ꍇ͋Zbg							*/
	if ( vsRegRead( SCI_HDAT0 ) || vsRegRead( SCI_HDAT1 ) || ( n >= 2048 ) ) {
		vsResetPlayMode();
	}
}
#endif	// #if VS_USE_FAINARAIZ


#if ( VS_LOAD_USER_CODE != 0 ) || ( VS_IMAFIX != 0 ) || ( VS_VORBISPATCH != 0 ) || ( VS_SPECTRUM_ANALYZER != 0 )
/*****************************************************************************
*							[U[R[h
* Fconst prog_uint16_t *code [U[R[he[u
* ߒlFvoid
*			[U[R[he[u0xffff,0xffffŏI邱
*****************************************************************************/
void vsLoadUserCode( const prog_uint16_t *code )
{
	uint16_t addr = 0;
	uint16_t len  = 0;
	uint16_t data = 0;

	prog_uint16_t *p = (prog_uint16_t *)code;
	while ( 1 ) {
		addr = pgm_read_word( p++ );
		len  = pgm_read_word( p++ );
		if ( ( addr == 0xffff ) && ( len == 0xffff ) ) {
			break;
		}

		if ( len & 0x8000 ) {		/* RLE run, replicate len samples		*/
			len &= 0x7fff;
			data = pgm_read_word( p++ );
			while ( len-- ) {
				vsRegWrite( (uint8_t)addr ,data );
			}
		} else {					/* Copy run, copy len samples			*/
			while ( len-- ) {
				data = pgm_read_word( p++ );
				vsRegWrite( (uint8_t)addr ,data );
			}
		}
	}
}
#endif // #if ( VS_LOAD_USER_CODE != 0 ) || ( VS_IMAFIX != 0 ) || ( VS_VORBISPATCH != 0 ) || ( VS_SPECTRUM_ANALYZER != 0 )

/*****************************************************************************
*							XDWORD擾
* Fuint16_t AhX
* ߒlFuint32_t ǂݏol
*****************************************************************************/
uint32_t vsReadXmemDword( uint16_t addr )
{
	uint32_t msbV1 ,msbV2;
	uint32_t lsb;
	uint32_t data;

	vsRegWrite( SCI_WRAMADDR ,addr + 1 );
	msbV1 = (uint32_t)vsRegRead( SCI_WRAM );
	vsRegWrite( SCI_WRAMADDR ,addr );
	lsb = (uint32_t)vsRegRead( SCI_WRAM );
	msbV2 = (uint32_t)vsRegRead( SCI_WRAM );
	if ( lsb <= 0x8000U ) {
		msbV1 = msbV2;
	}

	data = ( msbV1 << 16L ) | lsb;
	return ( data );
}

/*****************************************************************************
*							Xǂݏo
*	Fuint16_t addr  AhX
*	ߒlFuint16_t       ǂݏol
*****************************************************************************/
uint16_t vsReadXmem( uint16_t addr )
{
	vsRegWrite( SCI_WRAMADDR ,addr );
	return ( vsRegRead( SCI_WRAM ) );
}

/*****************************************************************************
*							X֏
*	Fuint16_t addr  AhX
*	ߒlFuint16_t       ǂݏol
*****************************************************************************/
void vsWriteXmem( uint16_t addr ,uint16_t data )
{
	vsRegWrite( SCI_WRAMADDR ,addr );
	vsRegWrite( SCI_WRAM ,data );
}

/*****************************************************************************
*							f[^Ao
* Fuint8_t data    o̓f[^l
*		uint16_t n      o̓f[^( 0:DREQ`FbN )
* ߒlFuint16_t        ۂɏo͂ꂽf[^
*						n = 0 ̎ 0:DREQ Busy / 1:Ready
*  KDREQ̏ԂReadyɂȂĂ̂mFĂf[^o͂邱
*****************************************************************************/
uint16_t vsOutFill( uint8_t data ,uint16_t n )
{
	/* DREQ `FbN[h̏		*/
	uint16_t cnt = 0;
	if ( n == 0 ) {
		if ( VS_GET_DREQ() != 0 ) {
			cnt = 1;
		}

	/* f[^o̓[v					*/
	} else {
		VS_ENABLE_XDCS();
		do {
			spiTransfer( data );
			cnt++;
		} while ( ( cnt < n ) && VS_GET_DREQ() );
		VS_DISABLE_XDCS();

	}

	return ( cnt );
}

/*****************************************************************************
*					Tiny-FatFs R0.06/R0.07 ΉXg[o
*@Fconst uint8_t *p Xg[f[^̈ւ̃|C^
*		 uint16_t n       o̓f[^( 0:DREQ`FbN )
*@ߒlFuint16_t         o͂f[^( n = 0 : 0:DREQ Busy / 1:Ready )
*  KDREQ̏ԂReadyɂȂĂ̂mFĂf[^o͂邱
*****************************************************************************/
uint16_t vsOutStream( const uint8_t *p ,uint16_t n )
{
	/* DREQ `FbN[h̏		*/
	uint16_t cnt = 0;
	if ( n == 0 ) {
		if ( VS_GET_DREQ() != 0 ) {
			cnt = 1;
		}

	/* f[^o̓[v					*/
	} else {
		VS_ENABLE_XDCS();
		do {
			spiTransfer( *p++ );
			cnt++;
		} while ( ( cnt < n ) && VS_GET_DREQ() );
		VS_DISABLE_XDCS();

	}

	return ( cnt );
}

/*****************************************************************************
*							VS1053b1oCgM
*@Fuint8_t data Mf[^
*@ߒlFvoid
*****************************************************************************/
void vsWriteByte( uint8_t data )
{
	spiTransfer( data );
}

/*****************************************************************************
*							DSPSCIWX^֏
*	Fuint8_t  reg  WX^ԍ
*		  uint16_t data o̓f[^
*	ߒlFvoid
*****************************************************************************/
void vsRegWrite( uint8_t reg ,uint16_t data )
{
	while ( !VS_GET_DREQ() );

#if ( F_CPU > 8000000UL )
	if ( initFlag ) {
		SPI_MID_SPEED();
	}
#endif

	VS_ENABLE_XCS();
	spiTransfer( 0x02 );
	spiTransfer( reg );
	spiTransfer( (uint8_t)( data >> 8 ) );
	spiTransfer( (uint8_t)( data & 0x00ff ) );
	VS_DISABLE_XCS();

#if ( F_CPU > 8000000UL )
	if ( initFlag ) {
		SPI_HI_SPEED();
	}
#endif
}

/*****************************************************************************
*							DSP̃WX^ǂݍ
*	Fuint8_t  reg  WX^ԍ
*	ߒlFuint16_t      ǂݏof[^
*****************************************************************************/
uint16_t vsRegRead( uint8_t reg )
{
	uint8_t h;
	uint8_t l;

	while ( !VS_GET_DREQ() );

#if ( F_CPU > 8000000UL )
	if ( initFlag ) {
		SPI_MID_SPEED();
	}
#endif

	VS_ENABLE_XCS();
	spiTransfer( 0x03 );
	spiTransfer( reg );
	h = spiTransfer( 0xff );
	l = spiTransfer( 0xff );
	VS_DISABLE_XCS();

#if ( F_CPU > 8000000UL )
	if ( initFlag ) {
		SPI_HI_SPEED();
	}
#endif

	return ( ( (uint16_t)h << 8 ) | (uint16_t)l );
}

#if VS_IMAFIX
/*****************************************************************************
*					DSP֏Cpb`uIMA Encoding FixvKp
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void vsImaFix( void )
{
	static const prog_uint16_t vsCodeImaFix[] = {
		0x0007, 0x0001, 0x8010, 0x0006, 0x001c, 0x3e12, 0xb817, 0x3e14,
		0xf812, 0x3e01, 0xb811, 0x0007, 0x9717, 0x0020, 0xffd2, 0x0030,
		0x11d1, 0x3111, 0x8024, 0x3704, 0xc024, 0x3b81, 0x8024, 0x3101,
		0x8024, 0x3b81, 0x8024, 0x3f04, 0xc024, 0x2808, 0x4800, 0x36f1,
		0x9811, 0x0007, 0x0001, 0x8028, 0x0006, 0x0002, 0x2a00, 0x040e,
		0xffff, 0xffff
	};

	vsLoadUserCode( vsCodeImaFix );
}
#endif

#if VS_VORBISPATCH
/*****************************************************************************
*					DSP֏Cpb`uVorbis PatchvKp
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void vsVorbisPatch( void )
{
	static const prog_uint16_t vsVorbisPatch[] = {
		0x0007, 0x0001, 0x8300, 0x0006, 0x00e8, 0xb080, 0x0024, 0x0007, //    0 
		0x9257, 0x3f00, 0x0024, 0x0000, 0x004d, 0x000a, 0x708f, 0x0000, //    8 
		0xc20e, 0x280f, 0xe100, 0x0006, 0x2016, 0x0000, 0x028d, 0x280a, //   10 
		0x71d5, 0x002c, 0x9d40, 0x0000, 0xfa0d, 0x0039, 0x324f, 0x0000, //   18 
		0xc58e, 0x2920, 0x41c0, 0x0000, 0x0024, 0x000a, 0x708f, 0x0000, //   20 
		0xc20e, 0x280a, 0xcac0, 0x0000, 0x028d, 0x283e, 0x2d80, 0x0fff, //   28 
		0xffc3, 0x003e, 0x2d4f, 0x2800, 0xd700, 0x0000, 0xc50e, 0x3413, //   30 
		0x0024, 0x2800, 0xc785, 0xf400, 0x4510, 0x2800, 0xcb40, 0x6894, //   38 
		0x13cc, 0x3000, 0x184c, 0x6090, 0x93cc, 0x38b0, 0x3812, 0x3004, //   40 
		0x4024, 0x0000, 0x0910, 0x3183, 0x0024, 0x3100, 0x4024, 0x6016, //   48 
		0x0024, 0x000c, 0x8012, 0x2800, 0xca91, 0xb884, 0x104c, 0x6894, //   50 
		0x3002, 0x2939, 0xb0c0, 0x3e10, 0x93cc, 0x4084, 0x9bd2, 0x4282, //   58 
		0x0024, 0x0000, 0x0041, 0x2800, 0xcd45, 0x6212, 0x0024, 0x0000, //   60 
		0x0040, 0x2800, 0xd245, 0x000c, 0x8390, 0x2a00, 0xd5c0, 0x34c3, //   68 
		0x0024, 0x3444, 0x0024, 0x3073, 0x0024, 0x3053, 0x0024, 0x3000, //   70 
		0x0024, 0x6092, 0x098c, 0x0000, 0x0241, 0x2800, 0xd5c5, 0x32a0, //   78 
		0x0024, 0x6012, 0x0024, 0x0000, 0x0024, 0x2800, 0xd5d5, 0x0000, //   80 
		0x0024, 0x3613, 0x0024, 0x3001, 0x3844, 0x2920, 0x0580, 0x3009, //   88 
		0x3852, 0xc090, 0x9bd2, 0x2800, 0xd5c0, 0x3800, 0x1bc4, 0x000c, //   90 
		0x4113, 0xb880, 0x2380, 0x3304, 0x4024, 0x3800, 0x05cc, 0xcc92, //   98 
		0x05cc, 0x3910, 0x0024, 0x3910, 0x4024, 0x000c, 0x8110, 0x3910, //   a0 
		0x0024, 0x39f0, 0x4024, 0x3810, 0x0024, 0x38d0, 0x4024, 0x3810, //   a8 
		0x0024, 0x38f0, 0x4024, 0x34c3, 0x0024, 0x3444, 0x0024, 0x3073, //   b0 
		0x0024, 0x3063, 0x0024, 0x3000, 0x0024, 0x4080, 0x0024, 0x0000, //   b8 
		0x0024, 0x2839, 0x53d5, 0x4284, 0x0024, 0x3613, 0x0024, 0x2800, //   c0 
		0xd905, 0x6898, 0xb804, 0x0000, 0x0084, 0x293b, 0x1cc0, 0x3613, //   c8 
		0x0024, 0x000c, 0x8197, 0x0000, 0x0015, 0x408a, 0x9bc4, 0x3f15, //   d0 
		0x4024, 0x2800, 0xdc05, 0x4284, 0x3c15, 0x6590, 0x0024, 0x0000, //   d8 
		0x0024, 0x2839, 0x53d5, 0x4284, 0x0024, 0x0000, 0x0024, 0x2800, //   e0 
		0xc658, 0x458a, 0x0024, 0x2a39, 0x53c0, 0x000a, 0x0001, 0x0300,
		0xffff, 0xffff
	};

	vsLoadUserCode( vsVorbisPatch );
}
#endif

#if VS_SPECTRUM_ANALYZER
/*****************************************************************************
*					DSP֋@\guSpectrumAnalyzervKp
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void vsSpectrumAnalyzerPatch( void )
{
	static const prog_uint16_t vsCodeSpectrumAnalyzer[968+2] = {
		0x0007, 0x0001, 0x8050, 0x0006, 0x0018, 0x3613, 0x0024, 0x3e00, /*    0 */
		0x3801, 0x0000, 0x16d7, 0xf400, 0x55c0, 0x0000, 0x0c17, 0xf400, /*    8 */
		0x57c0, 0x0007, 0x9257, 0xb080, 0x0024, 0x3f00, 0x0024, 0x2000, /*   10 */
		0x0000, 0x36f0, 0x1801, 0x2800, 0x31c0, 0x0007, 0x0001, 0x805c, /*   18 */
		0x0006, 0x00d6, 0x3e12, 0xb817, 0x3e12, 0x3815, 0x3e05, 0xb814, /*   20 */
		0x3615, 0x0024, 0x0000, 0x800a, 0x3e10, 0x3801, 0x0006, 0x0000, /*   28 */
		0x3e10, 0xb803, 0x0000, 0x0303, 0x3e11, 0x3805, 0x3e11, 0xb807, /*   30 */
		0x3e14, 0x3812, 0xb884, 0x130c, 0x3410, 0x4024, 0x4112, 0x10d0, /*   38 */
		0x4010, 0x008c, 0x4010, 0x0024, 0xf400, 0x4012, 0x3000, 0x3840, /*   40 */
		0x3009, 0x3801, 0x0000, 0x0041, 0xfe02, 0x0024, 0x2900, 0x8440, /*   48 */
		0x48b2, 0x0024, 0x36f3, 0x0844, 0x6306, 0x8845, 0xae3a, 0x8840, /*   50 */
		0xbf8e, 0x8b41, 0xac32, 0xa846, 0xffc8, 0xabc7, 0x3e01, 0x7800, /*   58 */
		0xf400, 0x4480, 0x6090, 0x0024, 0x6090, 0x0024, 0xf400, 0x4015, /*   60 */
		0x3009, 0x3446, 0x3009, 0x37c7, 0x3009, 0x1800, 0x3009, 0x3844, /*   68 */
		0x48b3, 0xe1e0, 0x4882, 0x4040, 0xfeca, 0x0024, 0x5ac2, 0x0024, /*   70 */
		0x5a52, 0x0024, 0x4cc2, 0x0024, 0x48ba, 0x4040, 0x4eea, 0x4801, /*   78 */
		0x4eca, 0x9800, 0xff80, 0x1bc1, 0xf1eb, 0xe3e2, 0xf1ea, 0x184c, /*   80 */
		0x4c8b, 0xe5e4, 0x48be, 0x9804, 0x488e, 0x41c6, 0xfe82, 0x0024, /*   88 */
		0x5a8e, 0x0024, 0x525e, 0x1b85, 0x4ffe, 0x0024, 0x48b6, 0x41c6, /*   90 */
		0x4dd6, 0x48c7, 0x4df6, 0x0024, 0xf1d6, 0x0024, 0xf1d6, 0x0024, /*   98 */
		0x4eda, 0x0024, 0x0000, 0x0fc3, 0x2900, 0x8440, 0x4e82, 0x0024, /*   a0 */
		0x4084, 0x130c, 0x0006, 0x0100, 0x3440, 0x4024, 0x4010, 0x0024, /*   a8 */
		0xf400, 0x4012, 0x3200, 0x4024, 0xb132, 0x0024, 0x4214, 0x0024, /*   b0 */
		0xf224, 0x0024, 0x6230, 0x0024, 0x0001, 0x0001, 0x2800, 0x2b49, /*   b8 */
		0x0000, 0x0024, 0xf400, 0x40c2, 0x3200, 0x0024, 0xff82, 0x0024, /*   c0 */
		0x48b2, 0x0024, 0xb130, 0x0024, 0x6202, 0x0024, 0x003f, 0xf001, /*   c8 */
		0x2800, 0x2e51, 0x0000, 0x1046, 0xfe64, 0x0024, 0x48be, 0x0024, /*   d0 */
		0x2800, 0x2f40, 0x3a01, 0x8024, 0x3200, 0x0024, 0xb010, 0x0024, /*   d8 */
		0xc020, 0x0024, 0x3a00, 0x0024, 0x36f4, 0x1812, 0x36f1, 0x9807, /*   e0 */
		0x36f1, 0x1805, 0x36f0, 0x9803, 0x36f0, 0x1801, 0x3405, 0x9014, /*   e8 */
		0x36f3, 0x0024, 0x36f2, 0x1815, 0x2000, 0x0000, 0x36f2, 0x9817, /*   f0 */
		0x0007, 0x0001, 0x80c7, 0x0006, 0x01c0, 0x3e12, 0xb817, 0x3e12, /*   f8 */
		0x3815, 0x3e05, 0xb814, 0x3625, 0x0024, 0x0000, 0x800a, 0x3e10, /*  100 */
		0x7802, 0x3e10, 0xf804, 0x3e11, 0x7810, 0x3e14, 0x7813, 0x0006, /*  108 */
		0x0051, 0x3e13, 0xf80e, 0x3e13, 0x4024, 0x3009, 0x3840, 0x3009, /*  110 */
		0x3852, 0x2911, 0xf140, 0x0006, 0x06d0, 0x3100, 0x5bd2, 0x0006, /*  118 */
		0xc351, 0x3009, 0x1800, 0x3009, 0x0402, 0x6126, 0x0024, 0x0006, /*  120 */
		0x00d1, 0x2800, 0x4d05, 0xb882, 0x0024, 0x0006, 0x0011, 0x3009, /*  128 */
		0x3850, 0x0006, 0x0010, 0x3009, 0x3800, 0x2914, 0xbec0, 0x0000, /*  130 */
		0x1800, 0x0006, 0x0010, 0xb882, 0x0024, 0x2915, 0x7ac0, 0x0000, /*  138 */
		0x1700, 0x0000, 0x0301, 0x3900, 0x5bc0, 0x0006, 0xc351, 0x3009, /*  140 */
		0x1bd0, 0x3009, 0x0404, 0x0006, 0x0051, 0x2800, 0x3d00, 0x3901, /*  148 */
		0x0024, 0x4448, 0x0401, 0x4192, 0x0024, 0x6498, 0x2401, 0x001f, /*  150 */
		0x4001, 0x6412, 0x0024, 0x0006, 0x0011, 0x2800, 0x3c51, 0x0000, /*  158 */
		0x058e, 0x2400, 0x4c0e, 0x0000, 0x0013, 0x0006, 0x0051, 0x0006, /*  160 */
		0x1a03, 0x3100, 0x4024, 0xf212, 0x44c4, 0x4346, 0x0024, 0xf400, /*  168 */
		0x40d5, 0x3500, 0x8024, 0x612a, 0x0024, 0x0000, 0x0024, 0x2800, /*  170 */
		0x4c51, 0x0000, 0x0024, 0x3613, 0x0024, 0x3100, 0x3800, 0x2915, /*  178 */
		0x7dc0, 0xf200, 0x0024, 0x003f, 0xfec2, 0x4082, 0x4411, 0x3113, /*  180 */
		0x1bc0, 0xa122, 0x0024, 0x0000, 0x2002, 0x6124, 0x2401, 0x0000, /*  188 */
		0x1002, 0x2800, 0x4608, 0x0000, 0x0024, 0x003f, 0xf802, 0x3100, /*  190 */
		0x4024, 0xb124, 0x0024, 0x2800, 0x4bc0, 0x3900, 0x8024, 0x6124, /*  198 */
		0x0024, 0x0000, 0x0802, 0x2800, 0x4848, 0x0000, 0x0024, 0x003f, /*  1a0 */
		0xfe02, 0x3100, 0x4024, 0xb124, 0x0024, 0x2800, 0x4bc0, 0x3900, /*  1a8 */
		0x8024, 0x6124, 0x0024, 0x0000, 0x0402, 0x2800, 0x4a88, 0x0000, /*  1b0 */
		0x0024, 0x003f, 0xff02, 0x3100, 0x4024, 0xb124, 0x0024, 0x2800, /*  1b8 */
		0x4bc0, 0x3900, 0x8024, 0x6124, 0x0401, 0x003f, 0xff82, 0x2800, /*  1c0 */
		0x4bc8, 0xb124, 0x0024, 0x3900, 0x8024, 0xb882, 0x8c4c, 0x3830, /*  1c8 */
		0x4024, 0x0006, 0x0091, 0x3904, 0xd84c, 0x0006, 0x00d1, 0x0000, /*  1d0 */
		0x0013, 0x3100, 0x904c, 0x4202, 0x9bcc, 0x39f0, 0x4024, 0x3100, /*  1d8 */
		0x4024, 0x3c00, 0x4024, 0xf400, 0x44c1, 0x34f0, 0x8024, 0x6126, /*  1e0 */
		0x0024, 0x0006, 0x06d0, 0x2800, 0x5dd8, 0x4294, 0x0024, 0x2400, /*  1e8 */
		0x5d82, 0x0000, 0x0024, 0xf400, 0x4411, 0x3123, 0x0024, 0x3100, /*  1f0 */
		0x8024, 0x4202, 0x0024, 0x4182, 0x2401, 0x0000, 0x2002, 0x2800, /*  1f8 */
		0x5d89, 0x0000, 0x0024, 0x3013, 0x184c, 0x30f0, 0x7852, 0x6124, /*  200 */
		0xb850, 0x0006, 0x0001, 0x2800, 0x5588, 0x4088, 0x44c2, 0x4224, /*  208 */
		0x0024, 0x4122, 0x0024, 0x4122, 0x0024, 0xf400, 0x4051, 0x2900, /*  210 */
		0x7440, 0x0000, 0x56c8, 0x4224, 0x0024, 0x4122, 0x0024, 0x4122, /*  218 */
		0x0024, 0x2900, 0x69c0, 0xf400, 0x4051, 0x0004, 0x0002, 0x3009, /*  220 */
		0x1bd0, 0x3023, 0x1bd2, 0x30e0, 0x4024, 0x6124, 0x0024, 0x0000, /*  228 */
		0x4002, 0x2800, 0x5988, 0x0000, 0x0024, 0x0000, 0x0001, 0x3820, /*  230 */
		0x4024, 0x30e0, 0x4024, 0x6124, 0x0001, 0x003f, 0xff42, 0x2800, /*  238 */
		0x5d88, 0x4182, 0x0024, 0x0000, 0x0024, 0x2800, 0x5d95, 0x0000, /*  240 */
		0x0024, 0x3613, 0x0024, 0x3e14, 0xc024, 0x2900, 0x1700, 0x3e14, /*  248 */
		0x0024, 0x36e3, 0x008c, 0x30e0, 0x4024, 0xfe22, 0x4411, 0x48b6, /*  250 */
		0x048c, 0x3900, 0x8024, 0x3033, 0x0c4c, 0x0006, 0x0011, 0x6892, /*  258 */
		0x04c2, 0xa122, 0x0402, 0x6126, 0x0024, 0x0006, 0x0093, 0x2800, /*  260 */
		0x6701, 0x0000, 0x0024, 0xb882, 0x184c, 0x3413, 0x3812, 0x0006, /*  268 */
		0x00d2, 0x3a00, 0x5bd2, 0x3300, 0x4024, 0x0000, 0x0013, 0x3c00, /*  270 */
		0x4024, 0xf400, 0x44c1, 0x34f0, 0x8024, 0x6126, 0x0024, 0x0006, /*  278 */
		0x0111, 0x2800, 0x6718, 0x4294, 0x0024, 0x2400, 0x66c2, 0x0000, /*  280 */
		0x0024, 0x0003, 0xf001, 0x3101, 0x0024, 0xb412, 0x0024, 0x0028, /*  288 */
		0x0001, 0x2800, 0x66c5, 0x6144, 0x0024, 0x0004, 0x0002, 0x2800, /*  290 */
		0x6681, 0x4422, 0x0024, 0x0000, 0x1002, 0x6422, 0x0024, 0x2800, /*  298 */
		0x66c0, 0x3900, 0x4024, 0x3900, 0x4024, 0x3113, 0x0c4c, 0x36f3, /*  2a0 */
		0x4024, 0x36f3, 0xd80e, 0x36f4, 0x5813, 0x36f1, 0x5810, 0x36f0, /*  2a8 */
		0xd804, 0x36f0, 0x5802, 0x3405, 0x9014, 0x36f3, 0x0024, 0x36f2, /*  2b0 */
		0x1815, 0x2000, 0x0000, 0x36f2, 0x9817, 0x0007, 0x0001, 0x1868, /*  2b8 */
		0x0006, 0x000f, 0x0032, 0x004f, 0x007e, 0x00c8, 0x013d, 0x01f8, /*  2c0 */
		0x0320, 0x04f6, 0x07e0, 0x0c80, 0x13d8, 0x1f7f, 0x3200, 0x4f5f, /*  2c8 */
		0x61a8, 0x0006, 0x8008, 0x0000, 0x0007, 0x0001, 0x81a7, 0x0006, /*  2d0 */
		0x0054, 0x3e12, 0xb814, 0x0000, 0x800a, 0x3e10, 0x3801, 0x3e10, /*  2d8 */
		0xb803, 0x3e11, 0x7806, 0x3e11, 0xf813, 0x3e13, 0xf80e, 0x3e13, /*  2e0 */
		0x4024, 0x3e04, 0x7810, 0x449a, 0x0040, 0x0001, 0x0003, 0x2800, /*  2e8 */
		0x7304, 0x4036, 0x03c1, 0x0003, 0xffc2, 0xb326, 0x0024, 0x0018, /*  2f0 */
		0x0042, 0x4326, 0x4495, 0x4024, 0x40d2, 0x0000, 0x0180, 0xa100, /*  2f8 */
		0x4090, 0x0010, 0x0fc2, 0x4204, 0x0024, 0xbc82, 0x4091, 0x459a, /*  300 */
		0x0024, 0x0000, 0x0054, 0x2800, 0x7204, 0xbd86, 0x4093, 0x2400, /*  308 */
		0x71c5, 0xfe01, 0x5e0c, 0x5c43, 0x5f2d, 0x5e46, 0x020c, 0x5c56, /*  310 */
		0x8a0c, 0x5e53, 0x5e0c, 0x5c43, 0x5f2d, 0x5e46, 0x020c, 0x5c56, /*  318 */
		0x8a0c, 0x5e52, 0x0024, 0x4cb2, 0x4405, 0x0018, 0x0044, 0x654a, /*  320 */
		0x0024, 0x2800, 0x8000, 0x36f4, 0x5810, 0x0007, 0x0001, 0x81d1, /*  328 */
		0x0006, 0x0080, 0x3e12, 0xb814, 0x0000, 0x800a, 0x3e10, 0x3801, /*  330 */
		0x3e10, 0xb803, 0x3e11, 0x7806, 0x3e11, 0xf813, 0x3e13, 0xf80e, /*  338 */
		0x3e13, 0x4024, 0x3e04, 0x7810, 0x449a, 0x0040, 0x0000, 0x0803, /*  340 */
		0x2800, 0x7ec4, 0x30f0, 0x4024, 0x0fff, 0xfec2, 0xa020, 0x0024, /*  348 */
		0x0fff, 0xff02, 0xa122, 0x0024, 0x4036, 0x0024, 0x0000, 0x1fc2, /*  350 */
		0xb326, 0x0024, 0x0010, 0x4002, 0x4326, 0x4495, 0x4024, 0x40d2, /*  358 */
		0x0000, 0x0180, 0xa100, 0x4090, 0x0010, 0x0042, 0x4204, 0x0024, /*  360 */
		0xbc82, 0x4091, 0x459a, 0x0024, 0x0000, 0x0054, 0x2800, 0x7dc4, /*  368 */
		0xbd86, 0x4093, 0x2400, 0x7d85, 0xfe01, 0x5e0c, 0x5c43, 0x5f2d, /*  370 */
		0x5e46, 0x0024, 0x5c56, 0x0024, 0x5e53, 0x5e0c, 0x5c43, 0x5f2d, /*  378 */
		0x5e46, 0x0024, 0x5c56, 0x0024, 0x5e52, 0x0024, 0x4cb2, 0x4405, /*  380 */
		0x0010, 0x4004, 0x654a, 0x9810, 0x0000, 0x0144, 0xa54a, 0x1bd1, /*  388 */
		0x0006, 0x0013, 0x3301, 0xc444, 0x687e, 0x2005, 0xad76, 0x8445, /*  390 */
		0x4ed6, 0x8784, 0x36f3, 0x64c2, 0xac72, 0x8785, 0x4ec2, 0xa443, /*  398 */
		0x3009, 0x2440, 0x3009, 0x2741, 0x36f3, 0xd80e, 0x36f1, 0xd813, /*  3a0 */
		0x36f1, 0x5806, 0x36f0, 0x9803, 0x36f0, 0x1801, 0x2000, 0x0000, /*  3a8 */
		0x36f2, 0x9814, 0x0007, 0x0001, 0x8211, 0x0006, 0x000e, 0x4c82, /*  3b0 */
		0x0024, 0x0000, 0x0024, 0x2000, 0x0005, 0xf5c2, 0x0024, 0x0000, /*  3b8 */
		0x0980, 0x2000, 0x0000, 0x6010, 0x0024, 0x000a, 0x0001, 0x0050,
		0xffff, 0xffff
	};
	
	vsLoadUserCode( vsCodeSpectrumAnalyzer );

	static const prog_uint16_t freq[14] = { 50,  79,  126,  200,  317,  504,  800,  1270,  2016,  3200, 5080,  8063,  12800,  20319 };

	uint8_t i;
	uint16_t BASE = 0x1800;

	vsRegWrite( SCI_WRAMADDR , BASE + 0x68 );
	for ( i = 0 ; i < VS_SPECTRUM_VALUES ;i++ ) {
		vsRegWrite( SCI_WRAM ,pgm_read_word( &freq[i] ) );
	}

	while ( i++ < 23 ) {
		vsRegWrite( SCI_WRAM ,25000 );
	}

	/*  activate  */
	vsRegWrite( SCI_WRAMADDR ,BASE + 1 );
	vsRegWrite( SCI_WRAM ,0 );
}
#endif
