/*###########################################################################
#                                                                           #
#        	  				HTTPNCAgx							#
#                                                                           #
###########################################################################*/
#define __HTTPC_C__

#include <stdlib.h>
#include <stdio.h> 
#include <string.h> 
#include <avr/io.h>
#include <avr/pgmspace.h>

#include "../myutil/string_func.h"
#include "../23k256/23k256.h"
#include "..\glcd.h"
#include "../myutil/timer.h"
#include "net.h"

/*****************************************************************************
*							HTTPT[o[֐ڑ
* FSOCKET       sok     \Pbgԍ
*		HTTP_CONNECT *con    ڑp[^
*		uint16_t     *stsRes T[o[X|XR[h
* ߒlFuint8_t              0:OK !0:NG
*
* R[
* HTTP_CONNECT con;
* uint16_t res;
* con.flag = Sn_MR_ND;
* con.defPort = 80;
* con.ver = 1;                                            <-- HTTP^Cv 0:HTTP1.0 1:HTTP1.1
* strcpy_s( con.url ,sizeof(con.url) ,"yahoo.co.jp" );    <-- ڑURL
* strcpy_s( con.strRes ,sizeof(con.strRes) ,"HTTP/1.1" ); <-- ҂鉞
* http_connect( sok ,&con ,&res );
*
*****************************************************************************/
uint8_t https_connect( SOCKET sok ,HTTP_CONNECT *con ,uint16_t *stsRes )
{
	uint8_t ret;
	HTTPC_INFO hp;

	uint16_t timeout = 4000;
	ret = https_connect1( &hp ,sok ,con );
	while ( ( ret == 1 ) && timeout-- ) {
		ret = https_connect2( &hp ,stsRes );
		WAIT_MS( 1 );
	}

	return ( ret );
}

/*****************************************************************************
*						HTTPT[o[֐ڑJn
* FHTTPC_INFO   *lp     Ǘ\
*		SOCKET       sok     \Pbgԍ
*		HTTP_CONNECT *con    ڑp[^
* ߒlFuint8_t              1:OK 1>:NG
*****************************************************************************/
uint8_t https_connect1( HTTPC_INFO *lp ,SOCKET sok ,HTTP_CONNECT *con )
{
	URL u;

	memset( lp ,0x00 ,sizeof(HTTPC_INFO) );
	if ( netInfo.netInit != 0xff ) {
		return ( 10 );
	}

	lp->sok = sok;

	/* p[^					*/
	memcpy( &lp->cn ,con ,sizeof(HTTP_CONNECT) );
	if ( ( lp->cn.resBufferSize >= HTTPC_INFO_SIZE ) && lp->cn.resBuffer ) {
		ss_memset( lp->cn.resBuffer ,0x00 ,HTTPC_INFO_SIZE );
		lp->spiSramBufferSize = lp->cn.resBufferSize - HTTPC_INFO_SIZE;
		lp->idx = lp->cn.resBuffer;							/* ACeXgւ̃|C^	*/
		lp->p3 = lp->cn.resBuffer + HTTPC_INFO_SIZE;		/* f[^̈ւ̃|C^		*/
	}

	/* URL񕪉				*/
	urlDismantled( lp->cn.url ,&u );
	if ( ( u.port == 0 ) || ( lp->cn.useDEFPORT != 0 ) ) {
		lp->port = lp->cn.defPort;
	} else {
		lp->port = u.port;
	}

	/* DNS₢킹				*/
	lp->ip = gethostbyname( u.domain );
	if ( !lp->ip ) {
		printSts_P( PSTR("DNS G[") );
		return ( 20 );
	}

	/* T[o[NGXg쐬	*/
	strcpy_s( lp->msg ,sizeof(lp->msg) ,lp->cn.command );		/* NGXgR}h	*/
	strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR(" ") );

	if ( u.file[0] != '/' ) {
		strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("/") );
	}
	strcat_s( lp->msg ,sizeof(lp->msg) ,u.file );				/* pX				*/

	if ( strlen( u.para ) != 0 ) {								/* p[^			*/
		strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("?") );
		strcat_s( lp->msg ,sizeof(lp->msg) ,u.para );
	}
	
	strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR(" HTTP/1.") );	/* HTTP v1.0 or v1.1*/
	if ( lp->cn.ver == 0 ) {
		strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("0") );
	} else {
		strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("1") );
	}
	strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("\r\n") );

	strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("Host: ") );		/* HOST(IPAhX)	*/
	strcat_s( lp->msg ,sizeof(lp->msg) ,inet_ntoa( lp->ip ) );
	strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("\r\n") );

	strcat_s( lp->msg ,sizeof(lp->msg) ,lp->cn.requestMessage );	/* IvV	*/

	strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("Accept: */*\r\n") );

	strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("Connection: Close\r\n") );

	strcat_s_P( lp->msg ,sizeof(lp->msg) ,PSTR("\r\n") );

	lp->flag = 1;

	return ( 1 );
}

/*****************************************************************************
*						HTTPT[o[֐ڑ҂
* FHTTPC_INFO   *lp     Ǘ\
*		uint16_t     *stsRes ڑXe[^X
* ߒlFuint8_t              0:ڑ  1:ڑ  1>:NG
*****************************************************************************/
uint8_t https_connect2( HTTPC_INFO *lp ,uint16_t *stsRes )
{
	char buf[64];
	char *p1;
	uint8_t c;
	uint8_t sts;
	uint16_t ln;
	uint8_t ret = 1;

	*stsRes = 0xffff;

	if ( netInfo.netInit != 0xff ) {
		memset( lp ,0x00 ,sizeof(HTTPC_INFO) );
		return ( 11 );
	}

	if ( !lp->flag ) {
		memset( lp ,0x00 ,sizeof(HTTPC_INFO) );
		return ( 10 );
	}

	/* T[o[֐ڑJn		*/
	if ( lp->step == 0 ) {
		sprintf_P( buf ,PSTR("httpT[o[ڑ %s:%u") ,inet_ntoa( lp->ip ) ,lp->port );
		printSts( buf );
		if ( tcp_connect_without_wait( lp->sok ,lp->ip ,lp->port ,lp->cn.flag ) == SOCK_CLOSED ) {
			printSts_P( PSTR("socket closed") );
			ret = 102;
		} else {
			lp->step = 1;
		}

	/* T[o[֐ڑ҂		*/
	} else if ( lp->step == 1 ) {
		sts = wiz_getSn_SR( lp->sok );
		if ( sts == SOCK_CLOSED ) {
			printSts_P( PSTR("socket closed") );
			ret = 103;

		} else if ( sts == SOCK_ESTABLISHED ) {
			lp->step = 2;
		}

	/* T[o[փNGXg			*/
	} else if ( lp->step == 2 ) {
		if ( tcp_send( lp->sok ,lp->msg ,strlen( lp->msg ) ) != 0 ) {
			printSts_P( PSTR("socket message send error") );
			ret = 104;

		} else {
			sprintf_P( buf ,PSTR("httpT[o[҂ %s:%u") ,inet_ntoa( lp->ip ) ,lp->port );
			printSts( buf );
			lp->step = 3;
		}

	/* T[o[҂			*/
	} else if ( lp->step == 3 ) {
		if ( tcp_isConnected( lp->sok ) == 0 ) {	/* ؒfĂH	*/
			printSts_P( PSTR("socket closed") );
			ret = 104;

		} else if ( wiz_getSn_RX_RSR( lp->sok ) != 0 ) {/* Mf[^LH	*/
			lp->resNum = 0;
			lp->getRes = 0;
			lp->line = 0;
			lp->step = 4;
		}

	/* T[o[bZ[W1s擾	*/
	} else if ( lp->step == 4 ) {
		lp->lineBufferSize = sizeof( lp->msg );
		lp->len = 0;
		lp->step = 5;

	} else if ( lp->step == 5 ) {
		tcp_getc_without_wait( lp->sok ,&c );
		if ( c == '\n' ) {
			lp->msg[lp->len] = '\0';
			lp->line++;
			lp->step = 6;

		} else if ( ( c >= 0x20 ) && ( lp->lineBufferSize > 1 ) ) {					
			lp->msg[lp->len++] = c;
			lp->lineBufferSize--;
		}

	/* MbZ[W`FbN				*/
	} else if ( lp->step == 6 ) {

		if ( lp->msg[0] == '\0' ) {					/* HTTP X|XIH		*/
			lp->step = 7;

		} else if ( lp->line == 1 ) {				/* 擪sH(X|X`FbN)	*/
			p1 = strcasestr( lp->msg ,lp->cn.strRes );
			if ( p1 == NULL ) {
				printSts_P( PSTR("httpc T[o[G[") );
				ret = 105;
			} else {
				p1 += strlen( lp->cn.strRes );
				while ( *p1++ != ' ' );				/* Xy[X܂ŃXLbv		*/
				if ( atou16( p1 ,&lp->resNum ) != 0 ) {
					printSts_P( PSTR("httpc T[o[^G[") );
					ret = 106;
				} else {
					lp->getRes = 1;
					lp->step = 4;
				}
			}

		} else {
			if ( lp->spiSramBufferSize && ( lp->line < HTTPC_INFO_MAX ) ) {		/* MeLXgޔ					*/
				ln = strlen( lp->msg );
				if ( lp->spiSramBufferSize >= ln + 1 ) {
					ss_strcpy_s( lp->p3 ,lp->spiSramBufferSize ,lp->msg );
					ss_write_word( lp->idx ,lp->p3 );
					lp->idx += 2;
					lp->p3 += ( ln + 1 );
					lp->spiSramBufferSize -= ( ln + 1 );
					lp->cn.resCount++;
				} else {
					lp->spiSramBufferSize = 0;
				}
			}
				lp->step = 4;
			}

	/* ŏI						*/
	} else if ( lp->step == 7 ) {
		*stsRes = lp->resNum;
		if ( lp->getRes && ( lp->resNum == 200 ) ) {
			ret = 0;
			lp->flag = 1;
		} else {
			ret = 107;
		}

		if ( ret ) {
			sprintf_P( buf ,PSTR("http X|XG[ %s:%u(%u)") ,inet_ntoa( lp->ip ) ,lp->port ,*stsRes );
			printSts( buf );

		} else {
			printSts_P( PSTR("") );
		}
	}

	if ( ret > 1 ) {
		https_cancel( lp );
	}

	return ( ret );
}

/*****************************************************************************
*						HTTPT[o[ւ̐ڑLZ
* FHTTPC_INFO   *lp     Ǘ\
* ߒlFvoid
*****************************************************************************/
void https_cancel( HTTPC_INFO *lp )
{
	if ( lp->flag ) {
		tcp_disconnect( lp->sok );
	}
	memset( lp ,0x00 ,sizeof(HTTPC_INFO) );
}
