/*###########################################################################
#                                                                           #
#                    	C[TlbgW[                          #
#                                                                           #
# DHCPLF                                                              #
# \Pbgobt@ Socket0:4K / Socket1:2K / Socket2:1K  Socket3:1K         #
# Socket 3 : NBNSp									                        #
# Socket 2 : NTP^DHCPp         			                                #
# Socket 1 : HTTPSp                                                        #
# Socket 0 : DNSC/HTTPC^Xg[~Op          	                        #
#                                                                           #
# DHCPF                                                              #
# \Pbgobt@ Socket0:8K / Socket1:-- / Socket2:--  Socket3:--         #
# Socket 3 : --									                            #
# Socket 2 : -- 				       		                                #
# Socket 1 : --                                                             #
# Socket 0 : DNS^HTTPC^Xg[~Op                                   #
#                                                                           #
# DHCṔASẴlbg[NT[rX~ɍőeʂ      #
# \PbgOɊ蓖Ă                                                    #
#                                                                           #
###########################################################################*/
#define __NET_C__
#include "../project.h"

#define IP_TIMEOUT 500

/* O[oϐ				*/
NET_CONFIG netInfo;
DHCP_INFO dhcpInfo;
NTPC_INFO ntpcInfo;

/*****************************************************************************
*						lbg[N^C}[(10msec)
* Fvoid
* ߒlFvoid
*****************************************************************************/
void net_timer( void )
{
	static uint8_t secCount = 0;

	/* DHCPNCAg^C}[	*/
	if ( ++secCount >= 100 ) {
		secCount = 0;
		if ( dhcpInfo.ipTimer ) {
			dhcpInfo.ipTimer--;
		}
	}

	/* NTPVXeJE^	*/
	if ( ++ntpcInfo.ms10Count >= 100 ) {
		ntpcInfo.ms10Count = 0;
		ntpcInfo.systemTime++;
		ntpcInfo.tickSec = 1;
	}

	/* DHCPNCAg^C}[		*/
	if ( dhcpInfo.timeOut && netInfo.ip ) {
		dhcpInfo.timeOut--;
	}

	/* NTPNCAg^C}[		*/
	if ( ntpcInfo.timeout ) {
		ntpcInfo.timeout--;
	}

	/* lbg[N^CAEg^C}[	*/
	if ( netInfo.timeout ) {
		netInfo.timeout--;
	}
}

/*****************************************************************************
*							lbg[N^XN
* Fvoid
* ߒlFvoid
*****************************************************************************/
void net_init( void )
{
	memset( &ntpcInfo ,0x00 ,sizeof(NTPC_INFO) );
	netInfo.netInit = 0;
	netInfo.update = 0;
}

/*****************************************************************************
*							lbg[N^XN
* Fvoid
* ߒlFvoid
*****************************************************************************/
void net_task( void )
{
	/* W5100 ^CAEgo			*/
	if ( ( netInfo.netInit == 3 ) && !netInfo.timeout ) {
		netInfo.netInit = 0;
	}

	/* W5100ZbgvZX				*/
	if ( netInfo.netInit == 0 ) {
		wiz_iinchip_init();					/* W5100n[hEGAZbg					*/
		if ( netInfo.dhcpMode == IP_STATIC ) {
			netInfo.timeout = 10;
		} else {
			netInfo.timeout = 200;
		}
		netInfo.netInit = 1;

	} else if ( netInfo.netInit == 1 ) {	/* W5100n[hEGAZbg̑҂ԏ	*/
		if ( netInfo.timeout == 0 ) {
			netInfo.netInit = 2;
		}

	} else if ( netInfo.netInit == 2 ) {
		if ( netInfo.dhcpMode == IP_DYNAMIC ) {
			wiz_sysinit( 0x06 ,0x06 );				/* W5100 \Pbgobt@	*/
													/* S0:4K S1:2K S2:1K S3:1K		*/
		} else {
			wiz_sysinit( 0x03 ,0x03 );				/* W5100 \Pbgobt@	*/
													/* S0:8K S1:-- S2:- S3:--		*/
		}

		dhcpClient_init();							/* DHCPNCAg		*/

		/* STATIC[h́ADNST[o[̉邩W5100̋NmF	*/
		if ( netInfo.dhcpMode == IP_STATIC ) {
			char url[32];
			strcpy_P( url ,SHOUTCAST_URL );
			if ( gethostbyname( url ) != 0 ) {		/* DNSփeXgM				*/
				netInfo.netInit = 0xff;
			} else {
				netInfo.netInit = 0;
			}
		} else {
			netInfo.timeout = IP_TIMEOUT;
			netInfo.netInit = 3;
		}
	}

	/* eT[rX						*/
	if ( netInfo.dhcpMode == IP_DYNAMIC ) {

		if ( netInfo.netInit >= 3 ) {
			dhcpClient_task();						/* DHCPNCAg			*/
		}

		if ( dhcpInfo.status == DHCP_STS_LEASED ) {

			/* lbg[No			*/
			if ( netInfo.netInit == 3 ) {
				ntpc_init();						/* NTPNCAg		*/
				netInfo.netInit = 0xff;
			}

			/* lbg[Ne^XN				*/
			if ( netInfo.netInit == 0xff ) {
				ntpc_task();						/* NTPNCAg			*/
				nbns_task();						/* NetBiosOT[o[		*/
				https_task();						/* HTTPT[o[				*/
			}
		}
	}
}

