/*###########################################################################
#                                                                           #
#                           NTPNCAg                                 #
#                                                                           #
# Ql) http://wiki.livedoor.jp/yamamaya_com/                               #
#       http://wiki.livedoor.jp/yamamaya_com/d/NTP%bb%fe%b7%d7ver.1         #
#                                                                           #
#                                                                           #
###########################################################################*/
#define __NTPC_C__
#include "../project.h"
#include "../myutil/timer.h"

#define ADJ 0								/* `x␳ 0:Ȃ 1:L	*/
#define TIMER_NUM 3							/* `x␳^C}[ԍ	*/

#define NTPC_RETRY_TIME ( 30UL * 100LU )	/* gCԊu(30b)			*/

/* `xp^C}[`	*/
#if ADJ

/* ^C}[`					*/
#if TIMER_NUM == 1
#define TCCRB TCCR1B
#define TCNT  TCNT1
#elif TIMER_NUM == 3
#define TCCRB TCCR3B
#define TCNT  TCNT3
#elif TIMER_NUM == 4
#define TCCRB TCCR4B
#define TCNT  TCNT4
#elif TIMER_NUM == 5
#define TCCRB TCCR5B
#define TCNT  TCNT5
#else
#error timer number error
#endif
#endif	// #if ADJ

/* gp|[gԍ				*/
#define NTPC_PORT 123

/* EWƓ{Ԃ̎	*/
#define LOCAL_TIME	( 9L * 60L * 60L )	/* GMT +09:00:00					*/

/* [N`FbN}N			*/
#define IS_LEAP(y) ( ( ( !( (y) % 400 ) ) || ( ( (y) % 100 ) && ( !( (y) % 4 ) ) ) ) ? 1:0 )

/* w̔N܂łɗL[N̉	*/
#define LEAPS_THRU_END_OF(y)	( ( (y) / 4 ) - ( (y) / 100 ) + ( (y) / 400 ) )

/* [J֐vg^Cv錾	*/
static void setTimeStruct( uint32_t ts ,TIME *t );
static uint8_t getMonthDays( uint16_t year ,uint8_t month );

/*****************************************************************************
*								NTPC 
* Fvoid
* ߒlFvoid
*****************************************************************************/
void ntpc_init( void )
{
	/* ntpT[o[IPAhX擾	*/
	uint8_t retry = 5;
	while ( retry-- ) {
		if ( ( netInfo.ntp = gethostbyname( netInfo.ntpname ) ) != 0L ) {
			break;
		}
		WAIT_MS( 1000 );
	}
}

/*****************************************************************************
*									␳
* Fvoid
* ߒlFvoid
*****************************************************************************/
void ntpc_task( void )
{
	/* NTPNGXgpPbg (48Bytes)	*/
	static const prog_uint8_t reqMessage[] = {
   		0xd9 ,0x00 ,0x0a ,0xf5 ,0x00 ,0x00 ,0x00 , 0x00 ,0x00 ,0x01 ,0x04 ,0x00 ,0x00 ,0x00 ,0x00 , 0x00 ,
		0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , 0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , 0x00 ,
		0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , 0x00 ,0x83 ,0xaa ,0x7e ,0x80 ,0x00 ,0x00 ,0x00 , 0x00
	};

	uint16_t port;
	uint32_t ip;
	uint8_t msg[64];
	uint16_t len;

	if ( !netInfo.ntp ) {
		return;
	}	
	
	if ( ntpcInfo.timeout ) {
		return;
	}

	/* ^CAEgϐ		*/
	ntpcInfo.timeout = NTPC_RETRY_TIME;

	/* \PbgI[v				*/
	if ( udp_open( NTPC_SOCK ,NTPC_PORT ) != SOCK_UDP ) {
		return;
	}

	/* NGXgbZ[W쐬/	*/
	memcpy_P( msg ,reqMessage ,sizeof(reqMessage) );

	/* ԑ^C}[	*/
	#if ADJ
	TCCRB = 0;
	TCNT = 0;
	TCCRB = 0x05;	/* F_CPU / 1024 */
	#endif

	/* NGXgM				*/
	udp_sendto( NTPC_SOCK ,msg ,sizeof(reqMessage) ,netInfo.ntp ,NTPC_PORT );

	/* f[^M҂				*/
	uint16_t timeout = 1500;
	do {
		len = udp_recvfrom( NTPC_SOCK ,msg ,sizeof(reqMessage) ,&ip ,&port );
		if ( len ) {
			break;
		}
		WAIT_MS( 1 );
	} while ( --timeout );

	/* bZ[W				*/
	if ( ( len == sizeof(reqMessage) ) && ( ip == netInfo.ntp ) && ( port == NTPC_PORT ) ) {
		#if ADJ
			TCCRB = 0;
			uint32_t t1 ,t2;
			float t1_p, t2_p ,delay;

			t1 = swapByteorder32( *(uint32_t *)&msg[0x20] );							/* 			*/
			t1_p = (float)swapByteorder32( *(uint32_t *)&msg[0x24] ) / 4294967296.0;	/* Œ菬->float	*/

			t2 = swapByteorder32( *(uint32_t *)&msg[0x28] );							/* 			*/
			t2_p = (float)swapByteorder32( *(uint32_t *)&msg[0x2c] ) / 4294967296.0;	/* Œ菬->float	*/
		
			delay = (float)TCNT * ( 1.0 / (float)( F_CPU / 1024 ) );					/* xvZ			*/
			delay = ( delay - (float)( t2 - t1 ) + ( t2_p - t1_p ) ) / 2.0;
			if ( delay > 0 ) {
				t1_p -= delay ;
				while ( t1_p < 0 ) {
					t1_p++ ;
					t1-- ;
				}
			}
			ntpcInfo.ms10Count = (uint8_t)( t1_p / 0.01 );
			ntpcInfo.systemTime = t1 + LOCAL_TIME;

		#else
			uint32_t tim = swapByteorder32( *(uint32_t *)&msg[0x20] );				/* 			*/
			uint32_t sec = swapByteorder32( *(uint32_t *)&msg[0x24] );				/* 			*/
			sec /= 42949672UL;														/* 10msecPʎ擾	*/
			ntpcInfo.ms10Count = (uint8_t)sec;
			ntpcInfo.systemTime = tim + LOCAL_TIME;
		#endif

		ntpcInfo.lastUpdate = ntpcInfo.systemTime;
		ntpcInfo.timeout = NTPC_NEXT_TIME;
		ntpcInfo.update = 1;
	}

	udp_close( NTPC_SOCK );
}

/*****************************************************************************
*						VXeԂ擾
* FTIME *t    ʊi[\
* ߒlFuint32_t   VXeVAl
*****************************************************************************/
uint32_t ntpc_getTime( TIME *t )
{
	uint32_t ts = ntpcInfo.systemTime;
	setTimeStruct( ts ,t );
	return ( ts );
}

/*****************************************************************************
*						NTPŏI擾
* FTIME *t    ʊi[\
* ߒlFuint32_t   VAl
*****************************************************************************/
uint32_t ntpc_getLastUpdate( TIME *t )
{
	uint32_t ts =  ntpcInfo.lastUpdate;
	setTimeStruct( ts ,t );
	return ( ts );
}

/*****************************************************************************
*						ԃVAlԍ\̂ɃZbg
* Fuint32_t  ts ԃVAl
*		TIME      *t ʊi[\
* ߒlFvoid
*****************************************************************************/
static void setTimeStruct( uint32_t ts ,TIME *t )
{ 
	uint16_t days = (uint16_t)( ts / 86400L );	/* 1900/01/01 00:00:00 ̌oߓvZ	*/
	uint32_t secs = ts % 86400L;				/* 00:00:00 ̌oߕbvZ				*/
	uint16_t i;

	/* vZ						*/
	t->hour = (uint8_t)( secs / 3600L );
	secs %= 3600L;
	t->minute = (uint8_t)( secs / 60L );
	t->second = (uint8_t)( secs % 60L );

	/* jvZ						*/
	t->wday = (uint8_t)( ( days + 1L ) % 7L );

	/* NvZ						*/
	t->year = 1900;
	while ( days >= ( 365 + IS_LEAP( t->year ) ) ) {
		i = t->year + ( days / 365L );
		days -= ( ( (uint32_t)( i - t->year ) * 365L ) + (uint32_t)LEAPS_THRU_END_OF( i - 1 ) - (uint32_t)LEAPS_THRU_END_OF( t->year - 1 ) );
		t->year = i;
	}

	/* vZ						*/
	t->month = 1;
	while ( 1 ) {
		i = getMonthDays( t->year ,t->month );
		if ( days < i ) {
			break;
		}
		days -= i;
		t->month++;
	}

	/* vZ						*/
	t->day = (uint8_t)days + 1;
}

/*****************************************************************************
*							w茎̓擾
*	Fuint16_t year  N
*		  uint8_t  month 
*	ߒlFuint8_t        28`31
*****************************************************************************/
static uint8_t getMonthDays( uint16_t year ,uint8_t month )
{
	static const prog_int8_t days[] = { 31 ,28 ,31 ,30 ,31 ,30 ,31 ,31 ,30 ,31 ,30 ,31 };
	if ( ( month == 2 ) && IS_LEAP( year ) ) {
		return ( 29 );
	}
	return ( pgm_read_byte( &days[ month - 1 ] ) );
}
