/*###########################################################################
#                                                                           #
#        	  				GLCDW[									#
#                                                                           #
###########################################################################*/
#define __GLCD_C__
#include "project.h"
#include "myutil/timer.h"

#define KEY_BUFFER_SIZE 4				/* L[Mobt@TCY			*/
#define RX_BUFFER_SIZE 280				/* Mobt@TCY				*/
#define STS_TEXT_LENGTH 53				/* Xe[^X\̈敶ő咷	*/

/* USART Mݐ				*/
#define USART_ENABLE()  ( UCSRB |=  _BV(RXCIE) )
#define USART_DISABLE() ( UCSRB &= ~_BV(RXCIE) )

/* [Jϐ`					*/
static volatile uint8_t ack_flag = 0;			/* GLCD ACKMtO		*/

/* USART Mobt@Ǘϐ		*/
static uint8_t rxBuf[RX_BUFFER_SIZE];			/* Mobt@{			*/
static uint8_t *wp;								/* Cg|C^			*/
static uint8_t *rp;								/* [h|C^			*/
static uint8_t *endPoint;						/* Mobt@ŏIʒu		*/
static volatile uint16_t rxUsed;				/* Mf[^				*/

/* L[Mobt@Ǘϐ			*/
static uint8_t keyBuf[KEY_BUFFER_SIZE];			/* L[Mobt@{		*/
static uint8_t *keyWp;							/* Cg|C^			*/
static uint8_t *keyRp;							/* [h|C^			*/
static uint8_t *keyEndPoint;					/* Mobt@ŏIʒu		*/
static volatile uint8_t keyUsed;				/* Mf[^				*/
static uint8_t recvAckCmd[3];
static uint8_t recvKeyCmd[3];

/* [J֐錾					*/
static void usart_send_byte( uint8_t c );
static void usart_send_word( uint16_t w );
static void usart_send_string( char *str );
static void usart_send_string_P( const prog_char *str );
static uint8_t usart_recv_byte( void );
static uint16_t usart_recv_word( void );
static void usart_recv_string( uint16_t size ,char *str );
static void rx_clear( void );
static void wait_ack( void );

/*****************************************************************************
*							USART M
*****************************************************************************/
#if ( GLCD_PORT == 0 )
ISR( SIG_USART0_RECV )
#else
ISR( SIG_USART1_RECV )
#endif
{
	uint8_t data = UDR;

	/* GLCDACKR}hobt@Zbg			*/
	recvAckCmd[0] = recvAckCmd[1];
	recvAckCmd[1] = recvAckCmd[2];
	recvAckCmd[2] = data;

	/* GLCD̃{^ZXR}hobt@Zbg	*/
	recvKeyCmd[0] = recvKeyCmd[1];
	recvKeyCmd[1] = recvKeyCmd[2];
	recvKeyCmd[2] = data;

	/* {^^b`M			*/
	if ( ( recvKeyCmd[0] == 0x02 ) && ( (uint8_t)~recvKeyCmd[1] == recvKeyCmd[2] ) ) {
		*keyWp++ = recvKeyCmd[1];
		keyUsed++;
		if ( keyWp > keyEndPoint ) keyWp = keyBuf;
		recvKeyCmd[0] = recvKeyCmd[1] = recvKeyCmd[2] = 0;
	}

	/* ACKM					*/
	if ( ( recvAckCmd[0] == 0x03 ) && ( recvAckCmd[1] == 0x06 ) && ( recvAckCmd[2] == 0xf3 ) ) {
		ack_flag = 1;
		recvAckCmd[0] = recvAckCmd[1] = recvAckCmd[2] = 0;
	}

	/* Mobt@֓			*/
	if ( rxUsed < RX_BUFFER_SIZE ) {
		*wp++ = data;
		rxUsed++;
		if ( wp > endPoint ) wp = rxBuf;
	}
}

/*****************************************************************************
*								ݒ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_init( void )
{
	char cmd[13];
	char ack[3];
	uint16_t timeout;

	UCSRB = 0;

	/* Mobt@				*/
	wp = rp = rxBuf;
	rxUsed = 0;
	endPoint = rxBuf + RX_BUFFER_SIZE - 1;

	/* L[obt@				*/
	keyWp = keyRp = keyBuf;
	keyUsed = 0;
	keyEndPoint = keyBuf + KEY_BUFFER_SIZE - 1;

	/* R}hobt@NA			*/
	memset( recvKeyCmd ,0x00 ,sizeof( recvKeyCmd ) );
	memset( recvAckCmd ,0x00 ,sizeof( recvAckCmd ) );

	/* GLCD Zbg					*/
	GLCD_RESET_ENABLE();
	WAIT_MS( 10 );
	GLCD_RESET_DISABLE();
	WAIT_MS( 50 );

	/* USARTʐMxݒ(ݒ 1200bps)*/
	UBRR = (uint16_t)( F_CPU / ( 16UL * 1200 ) ) - 1;
	UCSRB = _BV(RXEN) | _BV(TXEN);

	do {
		/* R}h 'U' M		*/
		sprintf_P( cmd ,PSTR("U%lu") ,GLCD_BAUD );
		usart_send_string( cmd );

		/* ACKmF						*/
		ack_flag = 0;
		timeout = 100;
		memset( ack ,0x00 ,3 );
		do {
			while ( UCSRA & _BV(RXC) ) {
				ack[0] = ack[1];
				ack[1] = ack[2];
				ack[2] = UDR;
				if ( ( ack[0] == 0x03 ) && ( ack[1] == 0x06 ) && ( ack[2] == 0xf3 ) ) {
					ack_flag = 1;
					break;
				}
			}
			WAIT_MS( 1 );
		} while ( timeout-- && !ack_flag );

	} while ( !ack_flag );

	/* USARTʐMxݒ({ݒ)		*/
	UBRR = (uint16_t)( F_CPU / ( 16UL * GLCD_BAUD ) ) - 1;
	UCSRB = _BV(RXCIE) | _BV(RXEN) | _BV(TXEN);
	WAIT_MS( 50 );
}

/*****************************************************************************
*						R[hzS-JISɕϊ
* Fvoid     *data ϊR[hz
*		uint16_t size  ϊobt@TCY
*		char     *str  ϊ㕶̈
*		uint16_t pr    vCIeB
*							PR_UTF16_UTF8_SJIS
*							PR_UTF8_UTF16_SJIS
*							PR_SJIS_UTF8_UTF16
*							PR_UTF8_SJIS_UTF16
*
* ߒlFuint8_t ϊ̕R[h
*							CODE_NONE    : R[hʂł
*							CODE_SJIS    : S-JIS
*							CODE_UTF16LE : UTF-16LE
*							CODE_UTF16BE : UTF-16BE
*							CODE_UTF8    : UTF-8
*
* f[^̍ṒA'\0' 3Ă邱
*****************************************************************************/
uint8_t g_convSJIS( void *data ,uint16_t size ,char *str ,uint16_t pr )
{
	uint8_t *p = (uint8_t *)data;
	uint8_t zero = 0;

	rx_clear();
	usart_send_byte( 'a' );
	usart_send_word( pr );
	while ( zero < 3 ) {
		if ( *p ) {
			zero = 0;
		} else {
			zero++;
		}
		usart_send_byte( *p++ );
	}

	uint8_t typ = usart_recv_byte();
	if ( typ != CODE_NONE ) {
		usart_recv_string( size ,str );
	}
	wait_ack();

	return ( typ );
}

/*****************************************************************************
*							ʃNA	
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_cls( void )
{
	rx_clear();
	usart_send_byte( 'C' );
	wait_ack();
}

/*****************************************************************************
*							wiύX
* FG_BGMODE mode  wi[h G_BGMODE_COLOR : PF[h
*                                 G_BGMODE_IMAGE : ǎ[h
*		uint16_t color mode = G_BGMODE_COLOR : wiF
*					   mode = G_BGMODE_IMAGE : wiԍ(1`)
* ߒlFvoid
*****************************************************************************/
void g_setBgColor( G_BGMODE mode ,uint16_t color )
{
	rx_clear();
	usart_send_byte( 'Y' );
	usart_send_byte( mode );
	usart_send_word( color );
	wait_ack();
}

/*****************************************************************************
*								obNCg̋Pxݒ
* Fuint8_t lv 0     :obNCgOFF
*				   1`254:PWM(傫邢)
*				   255   :obNCgON(펞_)
* ߒlFvoid
*****************************************************************************/
void g_setBrightness( uint8_t lv )
{
	rx_clear();
	usart_send_byte( 'B' );
	usart_send_byte( lv );
	wait_ack();
}

/*****************************************************************************
*									ʕ\ON
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_on( void )
{
	rx_clear();
	usart_send_byte( 'F' );
	wait_ack();
}

/*****************************************************************************
*									ʕ\OFF
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_off( void )
{
	rx_clear();
	usart_send_byte( 'G' );
	wait_ack();
}

/*****************************************************************************
*							wtHgŕ\
* FG_DRAWMODE  mode    `惂[h G_OPAQUE      ̂܂ܕ`
*                                      G_HALF_ALL    tHgEwi𔼓`
*                                      G_TRANSPARENT tHgʏ` / wi𓧖`
*                                      G_HALF        tHgʏ` / wi𔼓ŕ`
* 		uint8_t fontNum     tHgԍ(1`)
*       uint16_t  x         \JnXW
*		uint16_t  y         \JnYW
*       char     *str       \(S-JIS)
*       uint16_t fColor     \F
*		uint16_t bColor     wiF( mode == G_TRANSPARENT͖)
* ߒlFvoid
******************************************************************************/
void g_puts( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,char *str ,uint16_t fColor ,uint16_t bColor )
{
	if ( *str ) {
		rx_clear();
		usart_send_byte( 'A' );
		usart_send_byte( mode );
		usart_send_byte( fontNum );
		usart_send_word( x );
		usart_send_word( y );
		usart_send_word( fColor );
		usart_send_word( bColor );
		usart_send_string( str );
		wait_ack();
	}
}

void g_puts_P( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,const prog_char *str ,uint16_t fColor ,uint16_t bColor )
{
	if ( pgm_read_byte( str ) ) {
		rx_clear();
		usart_send_byte( 'A' );
		usart_send_byte( mode );
		usart_send_byte( fontNum );
		usart_send_word( x );
		usart_send_word( y );
		usart_send_word( fColor );
		usart_send_word( bColor );
		usart_send_string_P( str );
		wait_ack();
	}
}

/*****************************************************************************
*						wtHgŕ\(XN[)
* FG_DRAWMODE  mode    `惂[h G_OPAQUE      ̂܂ܕ`
*                                      G_HALF_ALL    tHgEwi𔼓`
*                                      G_TRANSPARENT tHgʏ` / wi𓧖`
*                                      G_HALF        tHgʏ` / wi𔼓ŕ`
* 		uint8_t   fontNum   tHgԍ(1`)
*		uint8_t   intervel  \XV(10msecP)  
*       uint16_t  x         \JnXW
*		uint16_t  y         \JnYW
*       uint16_t  clip      XWE[
*       char     *str       \(S-JIS)
*       uint16_t fColor     \F
*		uint16_t bColor     wiF( mode == G_TRANSPARENT͖)
* ߒlFvoid
******************************************************************************/
void g_puts_scroll( G_DRAWMODE mode ,uint8_t fontNum ,uint8_t interval ,uint16_t x ,uint16_t y ,uint16_t clip ,char *str ,uint16_t fColor ,uint16_t bColor )
{
	rx_clear();
	usart_send_byte( 'D' );
	usart_send_byte( mode );
	usart_send_byte( fontNum );
	usart_send_byte( interval );
	usart_send_word( x );
	usart_send_word( y );
	usart_send_word( clip );
	usart_send_word( fColor );
	usart_send_word( bColor );
	usart_send_string( str );
	wait_ack();
}

void g_puts_scroll_P( G_DRAWMODE mode ,uint8_t fontNum ,uint8_t interval ,uint16_t x ,uint16_t y ,uint16_t clip ,const prog_char *str ,uint16_t fColor ,uint16_t bColor )
{
	rx_clear();
	usart_send_byte( 'D' );
	usart_send_byte( mode );
	usart_send_byte( fontNum );
	usart_send_byte( interval );
	usart_send_word( x );
	usart_send_word( y );
	usart_send_word( clip );
	usart_send_word( fColor );
	usart_send_word( bColor );
	usart_send_string_P( str );
	wait_ack();
}

/*****************************************************************************
*						eLXgXN[JnE~
* Fuint8_t enable 0: 1:L
* ߒlFvoid
*****************************************************************************/
void g_textScrollEnable( uint8_t enable )
{
	rx_clear();
	usart_send_byte( 'E' );
	usart_send_byte( (enable)?1:0 );
	wait_ack();
}

/*****************************************************************************
*							XyAi\ݒ
* FG_DRAWMODE mode     `惂[h G_OPAQUE      XyNgʏ`^wi`
*                                      G_HALF_ALL    XyNg𔼓`^wi𔼓`
*                                      G_TRANSPARENT XyNgʏ`^wi[`
*                                      G_HALF        XyNg𔼓`^wi[`
*		uint8_t    intervel \XV(10msecP)  
*		uint16_t   x        \̈`XW
*		uint16_t   y        \̈`YW
* ߒlFvoid
*****************************************************************************/
void g_setSpectrumInfo( G_DRAWMODE  mode ,uint8_t interval ,uint16_t x ,uint16_t y )
{
	rx_clear();
	usart_send_byte( 'S' );
	usart_send_byte( mode );
	usart_send_byte( interval );
	usart_send_word( x );
	usart_send_word( y );
	wait_ack();
}

/*****************************************************************************
*							XyAif[^XV
* Fuint16_t *spVal XyAif[^
* ߒlFvoid
*****************************************************************************/
void g_setSpectrumData( uint16_t *spVal )
{
	rx_clear();
	usart_send_byte( 'T' );
	for ( uint8_t i = 0 ;i < VS_SPECTRUM_VALUES ;i++ ) usart_send_word( *spVal++ );
	wait_ack();
}

/*****************************************************************************
*						XyAi\JnE~
* Fuint8_t enable 0:\XV~ 1:\XVJn
* ߒlFvoid
*****************************************************************************/
void g_setSpectrumEnable( uint8_t enable )
{
	rx_clear();
	usart_send_byte( 'W' );
	usart_send_byte( (enable)?1:0 );
	wait_ack();
}

/*****************************************************************************
*				GLCDSPItbVɊi[Ă摜\
* Fuint16_t    index 摜ԍ( 1 ` )
*		G_DRAWMODE  mode  `惂[h G_OPAQUE      C[Ŵ܂ܕ`
*                                    G_HALF_ALL    SsNZ𔼓`
*                                    G_TRANSPARENT wF𓧖ŕ` / ̑̐Fʏ`
*                                    G_HALF        wF𓧖ŕ` / ̑̐F𔼓`
*		uint16_t   color FL[( G_TRANSPARENT / G_HALF ̎ɋ@\ )
*		uint16_t      x1    \̈`XW
*		uint16_t      y1    \̈`YW
* 		uint16_t      x2    \̈`EXW
*		uint16_t t    y2    \̈`EYW
* ߒlFvoid
*****************************************************************************/
void g_image( uint16_t index ,G_DRAWMODE mode ,uint16_t color ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 )
{
	rx_clear();
	usart_send_byte( 'I' );
	usart_send_word( index );
	usart_send_byte( mode );
	usart_send_word( color );
	usart_send_word( x1 );
	usart_send_word( y1 );
	usart_send_word( x2 );
	usart_send_word( y2 );
	wait_ack();
}

/*****************************************************************************
*								C\
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*       uint16_t    x1    n_XW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y1    n_YW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    x2    I_XW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y2    I_YW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_line( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color )
{
	rx_clear();
	usart_send_byte( 'L' );
	usart_send_byte( mode );
	usart_send_word( x1 );
	usart_send_word( y1 );
	usart_send_word( x2 );
	usart_send_word( y2 );
	usart_send_word( color );
	wait_ack();
}

/*****************************************************************************
*								`\
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*       uint16_t    x1    \̈`XW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y1    \̈`YW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    x2    \̈`EXW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y2    \̈`EYW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_box( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color )
{
	rx_clear();
	usart_send_byte( 'Q' );
	usart_send_byte( mode );
	usart_send_word( x1 );
	usart_send_word( y1 );
	usart_send_word( x2 );
	usart_send_word( y2 );
	usart_send_word( color );
	wait_ack();
}

/*****************************************************************************
*						hԂ`\
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*       uint16_t    x1    \̈`XW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y1    \̈`YW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    x2    \̈`EXW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y2    \̈`EYW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_boxF( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color )
{
	rx_clear();
	usart_send_byte( 'X' );
	usart_send_byte( mode );
	usart_send_word( x1 );
	usart_send_word( y1 );
	usart_send_word( x2 );
	usart_send_word( y2 );
	usart_send_word( color );
	wait_ack();
}

/*****************************************************************************
*								~\
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*       uint16_t    x     \SXW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y     \SYW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    r     a
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_circle( G_DRAWMODE mode ,uint16_t x ,uint16_t y ,uint16_t r ,uint16_t color )
{
	rx_clear();
	usart_send_byte( 'R' );
	usart_send_byte( mode );
	usart_send_word( x );
	usart_send_word( y );
	usart_send_word( r & 0xff );
	usart_send_word( color );
	wait_ack();
}

/*****************************************************************************
*								f[^͉
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*		char        *msg ڕ
*		char        *val ͕(25bytes)
* ߒlFuint8_t          0:OK !0:LZ
*****************************************************************************/
uint8_t g_inputText( G_DRAWMODE mode ,char *msg ,char *val )
{
	rx_clear();
	usart_send_byte( 'Z' );
	usart_send_byte( mode );
	usart_send_string( msg );
	usart_send_string( val );
	uint8_t sts = usart_recv_byte();
	usart_recv_string( 25 ,val );
	wait_ack();

	return ( sts );
}

/*****************************************************************************
*								bZ[W{bNX
* FG_DRAWMODE  mode    `惂[h G_OPAQUE      ʏ\
*                                      G_HALF_ALL    `
*		uint8_t     fontNum tHgԍiP`j
*		char        *msg    \
*		uint8_t     option  0:bZ[Ŵ
*							1:uOKv{^
*							2:uOKvuLZv{^
*							3:u͂vuv{^
* ߒlFuint8_t             1:OK/͂ 2:LZ/
*****************************************************************************/
uint8_t g_msgBox( G_DRAWMODE mode ,uint8_t fontNum ,char *msg ,uint8_t option )
{
	rx_clear();
	usart_send_byte( 'O' );
	usart_send_byte( mode );
	usart_send_byte( fontNum );
	usart_send_byte( option );
	usart_send_string( msg );
	uint8_t sts = usart_recv_byte();
	wait_ack();

	return ( sts );
}

uint8_t g_msgBox_P( G_DRAWMODE mode ,uint8_t fontNum ,const prog_char *msg ,uint8_t option )
{
	rx_clear();
	usart_send_byte( 'O' );
	usart_send_byte( mode );
	usart_send_byte( fontNum );
	usart_send_byte( option );
	usart_send_string_P( msg );
	uint8_t sts = usart_recv_byte();
	wait_ack();

	return ( sts );
}

/*****************************************************************************
*							ʃTCY擾
* Fuint16_t *width
*		uint16_t *height
* ߒlFvoid
*****************************************************************************/
void g_getScreenSize( uint16_t *width ,uint16_t *height )
{
	rx_clear();
	usart_send_byte( 'P' );
	*width = usart_recv_word();
	*height = usart_recv_word();
	wait_ack();
}

/*****************************************************************************
*							^b`plLu[g
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_calibration( void )
{
	rx_clear();
	usart_send_byte( 'V' );
	wait_ack();
}

/*****************************************************************************
*							^b`pl擾
* Fuint16_t *x ^b`XW
*		uint16_t *y ^b`YW
* ߒlFuint8_t     0:^b` 1:^b`
*****************************************************************************/
uint8_t g_getTouch( uint16_t *x ,uint16_t *y )
{
	rx_clear();
	usart_send_byte( 'N' );
	uint8_t touch = usart_recv_byte();
	*x = usart_recv_word();
	*y = usart_recv_word();
	wait_ack();

	return ( touch );
}

/*****************************************************************************
*							o^{^NA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_clearButton( void )
{
	rx_clear();
	usart_send_byte( 'M' );
	wait_ack();
}

/*****************************************************************************
*							{^o^
* Fuint8_t    code    L[ԍiP`j
*		G_DRAWMODE mode    {^`惂[h
*		uint8_t    fontNum tHgԍ(1`)
*		uint16_t   x1      {^̈捶XW
*		uint16_t   y1	   {^̈捶YW
*		uint16_t   x2	   {^̈EXW
*		uint16_t   y2	   {^̈EYW
*		char       *str    \( NULLwœȃ{^o^łj
*		uint16_t   fc	   tHgF
*		uint16_t   bc	   {^F
* ߒlFvoid
*****************************************************************************/
void g_addButton( uint8_t code ,G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,char *str ,uint16_t fc ,uint16_t bc )
{
	rx_clear();
	usart_send_byte( 'H' );
	usart_send_byte( code );
	usart_send_byte( mode );
	usart_send_byte( fontNum );
	usart_send_word( x1 );
	usart_send_word( y1 );
	usart_send_word( x2 );
	usart_send_word( y2 );

	if ( str == NULL ) {
		usart_send_word( 0 );
		usart_send_word( 0 );
		usart_send_byte( '\0' );
	} else {
		usart_send_word( fc );
		usart_send_word( bc );
		usart_send_string( str );
	}
	wait_ack();
}

/*****************************************************************************
*							o^{^S\
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_buttonAllDraw( void )
{
	rx_clear();
	usart_send_byte( 'K' );
	wait_ack();
}

/*****************************************************************************
*							w{^\
* Fuint8_t code L[ԍiP`j
*		uint8_t sw   0:OFF 1:ON
* ߒlFvoid
*****************************************************************************/
void g_buttonDraw( uint8_t code ,uint8_t sw )
{
	rx_clear();
	usart_send_byte( 'J' );
	usart_send_byte( code );
	usart_send_byte( sw );
	wait_ack();
}

/*****************************************************************************
*							L[obt@NA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_clearInkey( void )
{
	USART_DISABLE();
	keyUsed = 0;
	keyWp = keyRp = keyBuf;
	USART_ENABLE();
}

/*****************************************************************************
*							L[obt@P擾
* Fvoid
* ߒlFuint8_t 0: !0:L[ԍ
*****************************************************************************/
uint8_t g_inkey( void )
{
	uint8_t key = 0;
	if ( keyUsed ) {
		key = *keyRp++;
		if ( keyRp > keyEndPoint ) keyRp = keyBuf;
		USART_DISABLE();
		keyUsed--;
		USART_ENABLE();
	}

	return ( key );
}

/*****************************************************************************
*							Xe[^X\
* Fconst prog_char *str \(ő53byte)
* ߒlFvoid
*****************************************************************************/
void printSts_P( const prog_char *str )
{
	char txt[ STS_TEXT_LENGTH + 1 ];
	uint16_t len = strlen_P( str );

	memset( txt ,' ' ,STS_TEXT_LENGTH );
	txt[STS_TEXT_LENGTH] = '\0';

	if ( len > STS_TEXT_LENGTH ) {
		len = STS_TEXT_LENGTH;
	}
	memcpy_P( txt ,str ,len );

	g_puts( G_TRANSPARENT ,1 ,0 ,228 ,txt ,RGB(255,255,0) ,RGB(0,0,0) );
}

/*****************************************************************************
*							Xe[^X\
* Fchar *str \(ő53byte)
* ߒlFvoid
*****************************************************************************/
void printSts( char *str )
{
	char txt[ STS_TEXT_LENGTH + 1 ];
	uint16_t len = strlen( str );

	memset( txt ,' ' ,STS_TEXT_LENGTH );
	txt[STS_TEXT_LENGTH] = '\0';

	if ( len > STS_TEXT_LENGTH ) {
		len = STS_TEXT_LENGTH;
	}
	memcpy( txt ,str ,len );

	g_puts( G_TRANSPARENT ,1 ,0 ,228 ,txt ,RGB(255,255,0) ,RGB(0,0,0) );
}

/*****************************************************************************
*						USART1oCgM
* Fuint8_t c MR[h
* ߒlFvoid
******************************************************************************/
static void usart_send_byte( uint8_t c )
{
	while ( !( UCSRA & _BV(UDRE) ) );
	UDR = c;
}

/*****************************************************************************
*						USART1[hMigGfBAj
* Fuint16_t w MR[h
* ߒlFvoid
******************************************************************************/
static void usart_send_word( uint16_t w )
{
	uint8_t *p = (uint8_t *)&w;
	usart_send_byte( *p++ );
	usart_send_byte( *p );
}

/*****************************************************************************
*							USART֕񑗐M
* Fchar *str
* ߒlFvoid
*****************************************************************************/
static void usart_send_string( char *str )
{
	char c;
	do {
		c = *str++;
		usart_send_byte( c );
	} while ( c != '\0' );
}

static void usart_send_string_P( const prog_char *str )
{
	char c;
	do {
		c = pgm_read_byte( str++ );
		usart_send_byte( c );
	} while ( c != '\0' );
}

/*****************************************************************************
*								USART1oCgM
* Fvoid
* ߒlFuint8_t
*****************************************************************************/
static uint8_t usart_recv_byte( void )
{
	while ( !rxUsed );										/* M҂		*/
	uint8_t c = *rp++;
	if ( rp > endPoint ) rp = rxBuf;
	USART_DISABLE();
	rxUsed--;
	USART_ENABLE();
	return ( c );
}

/*****************************************************************************
*							USART烏[hM(gGfBA)
* Fvoid
* ߒlFuint16_t
*****************************************************************************/
static uint16_t usart_recv_word( void )
{
	uint16_t val = (uint16_t)usart_recv_byte();
	val |= ( (uint16_t)usart_recv_byte() << 8 );
	return ( val );
}

/*****************************************************************************
*							USART當擾M
* Fuint16_t size obt@TCY
*		char     *str obt@
* ߒlFvoid
*****************************************************************************/
static void usart_recv_string( uint16_t size ,char *str )
{
	char c;
	uint16_t len = 0;
	do {
		c = usart_recv_byte();
		if ( len < size - 1 ) {
			*str++ = c;
		}
	} while ( c != '\0' );
	*str = '\0';
}

/*****************************************************************************
*					USARTMobt@NAACKtONA
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void rx_clear( void )
{
	USART_DISABLE();
	wp = rp = rxBuf;
	rxUsed = 0;
	ack_flag = 0;
	recvAckCmd[0] = recvAckCmd[1] = recvAckCmd[2] = 0;
	USART_ENABLE();
}

/*****************************************************************************
*									ACK҂
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void wait_ack( void )
{
	LED_R_ON();
	while ( !ack_flag );
	LED_R_OFF();
}
