/*###########################################################################
#                                                                           #
#  			            		 GLCDCu								#
#                                                                           #
###########################################################################*/
#ifndef __GLCD_H__
#define __GLCD_H__

#include <avr/io.h>
#include <avr/pgmspace.h>

/* ʐM|[gݒ				*/
#ifdef __GLCD_C__
#define GLCD_PORT 1							/* USART gp|[gԍ 0 or 1	*/
#define GLCD_BAUD ( 1000L * 1000L )			/* USARTʐMx				*/

/* Zbg|[gݒ			*/
#define GLCD_RESET_ENABLE() ( PORTD &= ~_BV(PD4) )
#define GLCD_RESET_DISABLE() ( PORTD |= _BV(PD4) )

#if ( GLCD_PORT == 0 )
#define UBRR  UBRR0
#define UCSRA UCSR0A
#define UCSRB UCSR0B
#define UDRE  UDRE0
#define UDR   UDR0
#define TXC   TXC0
#define RXC   RXC0
#define RXEN  RXEN0
#define TXEN  TXEN0
#define RXCIE RXCIE0
#define U2X   U2X0

#elif ( GLCD_PORT == 1 )
#define UBRR  UBRR1
#define UCSRA UCSR1A
#define UCSRB UCSR1B
#define UDRE  UDRE1
#define UDR   UDR1
#define TXC   TXC1
#define RXC   RXC1
#define RXEN  RXEN1
#define TXEN  TXEN1
#define RXCIE RXCIE1
#define U2X   U2X1
#endif

#endif

/* 摜\[h				*/
#define G_OPAQUE 0x00						/* C[Ŵ܂ܕ`						*/
#define G_HALF_ALL 0x81	 					/* SsNZ𔼓`						*/
#define G_TRANSPARENT 0x82					/* wF𓧖ŕ` / ̑̐Fʏ`	*/
#define G_HALF 0x83		 					/* wF𓧖ŕ` / ̑̐F𔼓`	*/
typedef uint8_t G_DRAWMODE;

/* BG(wi)ݒl				*/
typedef enum {
	G_BGMODE_COLOR ,						/* wFwiFƂ			*/
	G_BGMODE_IMAGE 							/* w摜wiƂ			*/
} G_BGMODE;


#ifndef NA
#define NA 0
#endif

/* Fϊ}N (r 0`255 / g 0`255 / b 0`255 )@*/
#ifndef RGB
#define RGB(r,g,b) ( ( ( (uint16_t)(r) << 8 ) & 0xf800 ) | ( ( (uint16_t)(g) << 3 ) & 0x07e0 ) |( ( (uint16_t)(b) >> 3 ) & 0x001f ) )
#endif

/*	S-JIS1oCgڃ`FbN	*/
#ifndef IS_SJIS1
#define IS_SJIS1(code) ( ( ( (uint8_t)(code) >= 0x81 ) && ( (uint8_t)(code) <= 0x9f ) ) || ( ( (uint8_t)(code) >= 0xe0 ) && ( (uint8_t)(code) <= 0xfc ) ) )
#endif

/*	S-JIS2oCgڃ`FbN	*/
#ifndef IS_SJIS2
#define IS_SJIS2(code) ( ( ( (uint8_t)(code) >= 0x40 ) && ( (uint8_t)(code) <= 0x7e ) ) || ( ( (uint8_t)(code) >= 0x80 ) && ( (uint8_t)(code) <= 0xfc ) ) )
#endif

/* R[h^Cv : g_convSJIS()p	*/
#define CODE_NONE    0						/* R[hʂł		*/
#define CODE_SJIS    1						/* S-JIS					*/
#define CODE_UTF16LE 2						/* UTF-16LE					*/
#define CODE_UTF16BE 3						/* UTF-16BE					*/
#define CODE_UTF8    4						/* UTF-8					*/

/* ϊvCIeB : g_convSJIS()p	*/
#define PR_UTF16_UTF8_SJIS	( CODE_UTF16LE | ( CODE_UTF16BE << 3 ) | ( CODE_UTF8    << 6 ) | ( CODE_SJIS    << 9 ) )
#define PR_UTF8_UTF16_SJIS  ( CODE_UTF8    | ( CODE_UTF16LE << 3 ) | ( CODE_UTF16BE << 6 ) | ( CODE_SJIS    << 9 ) )
#define PR_SJIS_UTF8_UTF16  ( CODE_SJIS    | ( CODE_UTF8    << 3 ) | ( CODE_UTF16LE << 6 ) | ( CODE_UTF16BE << 9 ) )
#define PR_UTF8_SJIS_UTF16  ( CODE_UTF8    | ( CODE_SJIS    << 3 ) | ( CODE_UTF16LE << 6 ) | ( CODE_UTF16BE << 9 ) )

/* ֐vg^Cv錾			*/
void g_init( void );

uint8_t g_convSJIS( void *data ,uint16_t size ,char *str ,uint16_t pr );

void g_cls( void );
void g_setBgColor( G_BGMODE mode ,uint16_t color );
void g_setBrightness( uint8_t lv );
void g_on( void );
void g_off( void );

void g_puts( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,char *str ,uint16_t fColor ,uint16_t bColor );
void g_puts_P( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,const prog_char *str ,uint16_t fColor ,uint16_t bColor );

void g_puts_scroll( G_DRAWMODE mode ,uint8_t fontNum ,uint8_t interval ,uint16_t x ,uint16_t y ,uint16_t clip ,char *str ,uint16_t fColor ,uint16_t bColor );
void g_puts_scroll_P( G_DRAWMODE mode ,uint8_t fontNum ,uint8_t interval ,uint16_t x ,uint16_t y ,uint16_t clip ,const prog_char *str ,uint16_t fColor ,uint16_t bColor );
void g_textScrollEnable( uint8_t enable );

void g_setSpectrumInfo( G_DRAWMODE  mode ,uint8_t interval ,uint16_t x ,uint16_t y );
void g_setSpectrumData( uint16_t *spVal );
void g_setSpectrumEnable( uint8_t enable );

void g_image( uint16_t index ,G_DRAWMODE mode ,uint16_t color ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 );

void g_line( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color );
void g_box( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color );
void g_boxF( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color );
void g_circle( G_DRAWMODE mode ,uint16_t x ,uint16_t y ,uint16_t r ,uint16_t color );

uint8_t g_inputText( G_DRAWMODE mode ,char *msg ,char *val );

uint8_t g_msgBox( G_DRAWMODE mode ,uint8_t fontNum ,char *msg ,uint8_t option );
uint8_t g_msgBox_P( G_DRAWMODE mode ,uint8_t fontNum ,const prog_char *msg ,uint8_t option );

void g_getScreenSize( uint16_t *width ,uint16_t *height );

void g_calibration( void );
uint8_t g_getTouch( uint16_t *width ,uint16_t *height );

void g_clearInkey( void );
uint8_t g_inkey( void );

void g_clearButton( void );
void g_addButton( uint8_t code ,G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,char *str ,uint16_t fc ,uint16_t bc );
void g_buttonAllDraw( void );
void g_buttonDraw( uint8_t code ,uint8_t sw );

void printSts_P( const prog_char *str );
void printSts( char *str );

#endif
