/*############################################################################
#                                                                            #
#   		                  SHCASTWIC	                         #
#                                                                            #
############################################################################*/
#define __MAIN_C__
#include "project.h"

#define TIMER_NUM 3
#include "myutil/timer.h"

/* O[oϐ錾(system.hŌJ)	*/
SYSTEM sys;
EEPSYS eep;
const prog_uint8_t volumeTable[ VOLUME_MAXVALUE + 1 ] = { 0 ,60 ,70 ,81 ,92 ,103 ,114 ,125 ,136 ,147 ,158 ,169 ,180 };

/* [J֐vg^Cv錾								*/
static void hardwareInit( void );

/*****************************************************************************
*					timer0(8bit)ɂ0.5msec̊荞
*                           	Đp
*****************************************************************************/
ISR( SIG_OUTPUT_COMPARE0A ,ISR_NOBLOCK )
{
	TIMSK0 &= ~_BV(OCIE0A);

	/* XyAif[^擾	*/
	if ( !sys.spTimer ) {
		if ( sys.sp_enable == 0 ) {
			vsRegWrite( SCI_WRAMADDR ,0x1804 );
			for ( uint8_t i = 0 ;i < VS_SPECTRUM_VALUES ;i++ ) sys.dsp_sp[i] = vsRegRead( SCI_WRAM );
		}

		sys.dsp_hDat0  = vsRegRead( SCI_HDAT0 );
		sys.dsp_hDat1  = vsRegRead( SCI_HDAT1 );
		sys.dsp_auData = vsRegRead( SCI_AUDATA );

		sys.spTimer = SP_INTERVAL / 2;
		sys.sp_enable = 1;

	/* ʃtF[hCEAEg		*/
	} else if ( !sys.fadeIn_timer && !sys.mute ) {
		uint8_t vol = vsGetVolume();
		uint8_t n = pgm_read_byte( &volumeTable[ eep.volume ] );
		if ( vol != n ) {
			if ( vol < n ) {
				vol += VOLUME_FADE_STEP;
				if ( vol > n ) {
					vol = n;
				}
			} else if ( vol > n ) {
				if ( vol >= VOLUME_FADE_STEP ) {
					vol -= VOLUME_FADE_STEP;
				} else {
					vol = 0;
				}
			}
			vsSetVolume( vol );
		}
		sys.fadeIn_timer = 10;

	/* SHOUTCAST Xg[~O		*/
	} else if ( eep.playMode == 0 ) {
		shoutcast_task();

	/* ~[WbNv[[		*/
	} else {
		player_task();
	}

	/* ̊荞݃^C~O		*/
	TCNT0 = 0;
	TIMSK0 |= _BV(OCIE0A);
}

/*****************************************************************************
*					timer1(16bit)ɂ10msec̊荞
*                           VXe^C}[
*****************************************************************************/
ISR( SIG_OUTPUT_COMPARE1A ,ISR_NOBLOCK )
{
	static uint8_t powerSwFlag = 0;

	static uint8_t powerCount = 0;
	static uint8_t powerCnd = 0;
	static uint8_t powerClick = 0;

	TIMSK1 &= ~_BV(OCIE1A);

	/* d{^gvNbNo	*/
	if ( powerCount == 0 ) {
		if ( POWER_SW() == 0 ) {
			powerCount = 80;
			powerCnd = 1;
			powerClick = 0;
		}
	} else {
		powerCount--;
		if ( ( powerCnd == 1 ) && ( POWER_SW() != 0 ) ) {
			powerCnd = 0;
			if ( ++powerClick >= 3 ) {
				sys.cal = 1;			/* Lu[VtOON			*/
			}
		} else if ( ( powerCnd == 0 ) && ( POWER_SW() == 0 ) ) {
			powerCnd = 1;
		}
	}
	
	/* d{^o	*/
	if ( powerSwFlag ) {
		if ( POWER_SW() == 0 ) {		/* d{^H					*/
			if ( sys.powerSwCount < 0xff ) {
				sys.powerSwCount++;
			}
		} else {
			sys.powerSwCount = 0;
		}
	} else {
		powerSwFlag = ( POWER_SW() != 0 );
	}

	if ( PHONE_IN() != 0 ) {			/* wbhzWbN}o			*/
		sys.jackCount = 0;
	} else if ( sys.jackCount != 0xff ) {
		sys.jackCount++;
	}

	net_timer();						/* lbg[[Np^C}[				*/

	if ( sys.noProcessTimer ) {			/* 쎞ԃ^C}[					*/
		sys.noProcessTimer--;
	}

	if ( sys.fadeIn_timer ) {			/* ʃtF[hCEAEg^C}[		*/
		sys.fadeIn_timer--;
	}

	if ( sys.spTimer ) {				/* VS1053bXyAif[^擾^C}[	*/
		sys.spTimer--;
	}

	if ( shoutInfo != NULL ) {
		if ( shoutInfo->recvTimeout ) {	/* Xg[~OM^CAEg		*/
			shoutInfo->recvTimeout--;
		}
	}

	if ( playSys != NULL ) {			/* ~[WbNv[[pĐ		*/
		if ( ++playSys->playTime10 >= 100 ) {
			playSys->playTime10 = 0;
			playSys->playTime++;
			playSys->tickPlayTime = 1;
		}
	}

	if ( ++sys.shutdown_count >= 100 ) {	/* Vbg_E^C}[			*/
		sys.shutdown_count = 0;
		if ( sys.shutdown_timer_enable && sys.shutdown_timer ) {
			sys.shutdown_timer--;
		}
	}

	/* ̊荞݃^C~O	*/
	OCR1A += OCR1B;
	TIMSK1 |= _BV(OCIE1A);
}

/*****************************************************************************
*								n[hEGA
*	F
*	ߒlF
*****************************************************************************/
static void hardwareInit( void )
{
	/*  PortB +--------7: Out(H) : S-RAM4 #CS                               */
	/*        |+-------6: Out(H) : S-RAM3 #CS                               */
	/*        ||+------5: Out(H) : S-RAM2 #CS                               */
	/*        |||+-----4: Out(H) : S-RAM1 #CS                               */
	/*        ||||+----3: HIZ    : SD / S-RAM SO                            */
	/*        |||||+---2: Out(L) : SD / S-RAM SI                            */
	/*        ||||||+--1: Out(L) : SD / S-RAM SCk                           */
	/*        |||||||+-0: Out(H) : SD #CS                                   */
	DDRB  = 0b11110111;
	PORTB = 0b11110001;

	/* 	PortC +--------7: ZHI    : AD15										*/
	/*        |+-------6: ZHI    : AD14										*/
	/*        ||+------5: ZHI    : AD13										*/
	/*        |||+-----4: ZHI    : AD12										*/
	/*        ||||+----3: ZHI    : AD11										*/
	/*        |||||+---2: ZHI    : AD10	 									*/
	/*        ||||||+--1: ZHI    : AD9										*/
	/*        |||||||+-0: ZHI    : AD8										*/
	DDRC  = 0b00000000;
	PORTC = 0b00000000;

	/*  PortD +--------7: Out(H) : #Power-LED                               */
	/*        |+-------6: Out(L) : Power-hold                               */
	/*        ||+------5: Pullup : O                                     */
	/*        |||+-----4: Out(L) : GLCD #RESET                            */
	/*        ||||+----3: Pullup : GLCD RX                                */
	/*        |||||+---2: Pullup : GLCD TX                                */
	/*        ||||||+--1: Pullup : FM-RADIO SDA                             */
	/*        |||||||+-0: Pullup : FM-RADIO SCL                             */
	DDRD  = 0b11010000;
	PORTD = 0b10101111;

	/*  PortE +--------7: HIZ    : W5100 INT		                        */
	/*        |+-------6: Out(L) : VS #RESET								*/
	/*        ||+------5: HIZ    : VS DREQ									*/
	/*        |||+-----4: Out(H) : VS #XDCS									*/
	/*        ||||+----3: Out(H) : VS #XCS									*/
	/*        |||||+---2: Out(L) : VS SCLK									*/
	/*        ||||||+--1: Out(L) : VS SI / ISP(MISO)						*/
	/*        |||||||+-0: HIZ    : VS SO / ISP(MOSI)						*/
	DDRE  = 0b01011110;
	PORTE = 0b00011000;

	/*  PortF +--------7: Out(L) : W5100 #RESET                             */
	/*        |+-------6: Pullup : gp                                   */
	/*        ||+------5: Pullup : O                                     */
	/*        |||+-----4: Pullup : O                                     */
	/*        ||||+----3: Pullup : PHONE-IN                                 */
	/*        |||||+---2: Out(L) : #AMP MUTE                                */
	/*        ||||||+--1: Out(L) : #AMP SHUTDOWN                            */
	/*        |||||||+-0: Pullup : #Power-SW                                */
	DDRF  = 0b10000110;
	PORTF = 0b01111001;

	/*  PortG +--------7: ---                                               */
	/*        |+-------6: ---                                               */
	/*        ||+------5: Pullup : gp                                   */
	/*        |||+-----4: Pullup : SD #ins                                  */
	/*        ||||+----3: Out(H) : SD #pow                                  */
	/*        |||||+---2: Pullup : W5300 ALE                                */
	/*        ||||||+--1: Pullup : W5100 #RD                                */
	/*        |||||||+-0: Pullup : W5100 #WR                                */
	DDRG  = 0b00001000;
	PORTG = 0b11111111;

	/* C^[tF[X		*/
	XMCRA = 0b11001111;								/* 2WAIT				*/
//	XMCRA = 0b11000101;								/* 1WAIT				*/
//	XMCRA = 0b11000000;								/* 0WAIT				*/
	XMCRB = 0;

	/* AiORp[^OFF					*/
	ACSR = _BV(ACD);

	/*^C}[1(16bit)ݒ 10msec				*/
	OCR1B = (uint16_t)( ( F_CPU / 256L ) / 100L );
	OCR1A = OCR1B;
	TCNT1 = 0;
	TCCR1B = 0x04;									/* F_CPU / 256			*/
	TIMSK1 |= _BV(OCIE1A);

	/* d{^莞ԉ܂ő҂		*/
	TIMER_SET_TIMEOUT( 500 );
	while ( ( POWER_SW() == 0 ) && !TIMER_IS_TIMEOUT() );
	if ( !TIMER_IS_TIMEOUT() ) mcu_soft_reset();
	TIMER_STOP();

	/* dnmz[h							*/
	ENABLE_POWER_HOLD();

	/* dvnm							*/
	POWER_LED_ON();

	/* GLCD								*/
	g_init();

	/* VS1053b							*/
	vsInit();

	/* FatFs(SPI-SRAMɏׁ̈j	*/
	disk_initialize( 0 );
	f_mount( 0 ,&sys.fs );

	/* SPI-SRAM							*/
	sram_init();

	/* FMWIW[					*/
	fmReset();

	/* O[oC^vgL				*/
	sei();
}

/*****************************************************************************
*							C֐
*****************************************************************************/
int main( void )
{
	/* O[oϐNA			*/
	memset( &sys ,0x00 ,sizeof(sys) );

	/* ݒ						*/
	hardwareInit();

	/* SPI-SRAMNA				*/
	ss_memset( 0x0000 ,0x00 ,32768U );

	/* lbg[N			*/
	load_netInfo( &netInfo );
	net_init();

	/* EEPp[^擾			*/
	load_eepSys_eep( &eep );

	/* ʃ~bg					*/
	if ( eep.volume > 7 ) eep.volume = 7;

	/* wiݒ						*/
	g_setBrightness( 255 );						/* Pxő							*/
//	g_off();									/* dăX|X̂Ŗ	*/
//	g_setBgColor( G_BGMODE_IMAGE ,1 );

	/* C					*/
	while ( 1 ) {
		if ( eep.playMode == SYSTEM_MODE_SHOUTCAST ) {
			menu001();

		} else if ( eep.playMode == SYSTEM_MODE_MUSIC_PLAYER ) {
			menu002();

		} else if ( eep.playMode == SYSTEM_MODE_FM_RADIO ) {
			menu003();

		}
	}

	return ( 1 );
}
