/*###########################################################################
#                                                                           #
#   @ 				Đt@C̓W[							#
#                                                                           #
###########################################################################*/
#define __GET_PLAY_FILE_INFO_C__
#include "project.h"
#include "myutil/timer.h"

#define wdt_reset()						/* EIb`hbNgpɂ avr/wdt.h CN[h邱	*/

#define ENABLE_WAV 1					/* 1WAVEt@CΉ				*/
#define ENABLE_WMA 1					/* 1WMAt@CΉ				*/
#define ENABLE_AAC 1					/* 1AACt@CΉ				*/
#define ENABLE_PLS 1					/* 1PLSt@CΉ				*/

#define WAVE_MAX_FREQ 44100L
//#define WAVE_MAX_FREQ 48000L

/* [J֐vg^Cv錾	*/
#if ( ENABLE_WAV != 0 )
static uint8_t chkWaveFile( FIL *fl ,PLAY_FILE_INFO *info );
#endif

#if ( ENABLE_WMA != 0 )
static uint8_t chkWmaFile( FIL *fl ,PLAY_FILE_INFO *info );
static void convertWMA_ID( uint8_t *id ,char *ids );
#endif

static uint8_t chkMidiFile( FIL *fl ,PLAY_FILE_INFO *info );
static uint8_t chkOggVorbisFile( FIL *fl ,PLAY_FILE_INFO *info );
static uint8_t chkMp3File( FIL *fl ,PLAY_FILE_INFO *info );
static uint8_t file_getVariableValue( FIL *fl ,uint32_t *val );
static uint8_t makeDefaultTag( char *fname ,PLAY_FILE_INFO *info );

/*****************************************************************************
*		VS1053b̃WX^rbg[g^Tv[g^^擾
* Fuint16_t hdat0   HDAT0WX^l
*		uint16_t hdat1   HDAT1WX^l
*		uint16_t audata  AUDATAWX^l
*		uint16_t *bit    rbg[giPCM̒l͎gȂj
*		uint16_t *sample Tv[g
* ߒlFPLAY_FILE_TYPE   f[^^
*****************************************************************************/
PLAY_FILE_TYPE getVsInfo( uint16_t hdat0 ,uint16_t hdat1 ,uint16_t audata ,uint16_t *bit ,uint16_t *sample )
{
	/* MP3 rbg[ge[u`	*/
	static const prog_uint16_t tbl1[] = {  0 , 32 , 40 , 48 , 56 , 64 , 80 , 96 ,112 ,128 ,160 ,192 ,224 ,256 ,320 ,  0 };
	static const prog_uint16_t tbl2[] = {  0 ,  8 , 16 , 24 , 32 , 40 , 48 , 56 , 64 , 80 , 96 ,112 ,128 ,144 ,160 ,  0 };

	*sample = 0;
	*bit = 0;
	PLAY_FILE_TYPE typ = F_OTHER;

	if ( hdat0 && hdat1 && audata ) {

		*sample = audata & 0xfffe;
		if ( ( hdat1 == 0x4154 ) || ( hdat1 == 0x4144 ) || ( hdat1 == 0x4d34 ) ) {		/* AAC ?		*/
			typ = F_AAC;

		} else if ( hdat1 == 0x7665 ) {	/* PCM ?	*/
			*bit = 1;
			typ = F_PCM;

		} else if ( hdat1 == 0x574d ) {	/* WMA ?	*/
			typ = F_WMA;

		} else if ( hdat1 == 0x4d54 ) {	/* MIDI ?	*/
			typ = F_MIDI;

		} else if ( hdat1 == 0x4f67 ) {	/* Ogg Vorbis ?	*/
			typ = F_OGG;

		} else if ( hdat1 >= 0xffe0 ) {	/* MP3 ?		*/
			typ = F_MP3;
			if ( ( ( hdat1 & 0x0018 ) >>  3 ) == 3 ) {
				*bit = pgm_read_word( &tbl1[ ( ( hdat0 & 0xf000 ) >> 12 ) ] );
			} else {
				*bit = pgm_read_word( &tbl2[ ( ( hdat0 & 0xf000 ) >> 12 ) ] );
			}
		}
	}

	if ( *bit == 0 ) {
		*bit = (uint16_t)( ( (uint32_t)hdat0 * 8L ) / 1000L );
	}

	if ( ( *sample <= 8000 ) || ( *bit == 0 ) ) {
		*sample = 0;
		*bit = 0;
		typ = F_OTHER;
	}

	return ( typ );
}

/*****************************************************************************
*							wt@C̎ނ𔻕
* Fchar           *fileName 	tpX̃t@C
* ߒlFPLAY_FILE_TYPE t@C
* gqmFȂȈՓIȃ`FbNs
*****************************************************************************/
PLAY_FILE_TYPE getPlayFileType( char *fileName )
{
	PLAY_FILE_TYPE ret = F_OTHER;

	char *p = getExtension( fileName );
	if ( p != NULL ) {
		if ( strcasecmp_P( p ,PSTR("mp3") ) == 0 ) {			/* MP3		*/
			ret = F_MP3;

#if ( ENABLE_WAV != 0 )
		} else if ( strcasecmp_P( p ,PSTR("wav") ) == 0 ) {		/* WAVE		*/
			ret = F_WAVE;
#endif

#if ( ENABLE_WMA != 0 )
		} else if ( strcasecmp_P( p ,PSTR("wma") ) == 0 ) {		/* WMA		*/
			ret = F_WMA;
#endif

#if ( ENABLE_AAC != 0 )
		} else if ( strcasecmp_P( p ,PSTR("aac") ) == 0 ) {		/* AAC		*/
			ret = F_AAC;
#endif

#if ( ENABLE_AAC != 0 )
		} else if ( strcasecmp_P( p ,PSTR("m4a") ) == 0 ) {		/* MP4		*/
			ret = F_AAC;
#endif

#if ( ENABLE_PLS != 0 )
		} else if ( strcasecmp_P( p ,PSTR("pls") ) == 0 ) {		/* PLS		*/
			ret = F_PLS;
#endif

		} else if ( strcasecmp_P( p ,PSTR("ogg") ) == 0 ) {		/* OGG		*/
			ret = F_OGG;

		} else if ( strcasecmp_P( p ,PSTR("mid") ) == 0 ) {		/* MIDI		*/
			ret = F_MIDI;

		} else if ( strcasecmp_P( p ,PSTR("smf") ) == 0 ) {		/* MIDI		*/
			ret = F_MIDI;
		}
	}

	return ( ret );
}

/*****************************************************************************
*							wt@C̏擾
* Fchar      *fileName 	tpX̃t@C
*       PLAY_FILE_INFO *info    t@C\̂ւ̃|C^
* ߒlFuint8_t             	0:Đ\ȃt@Cł
*								1:t@CI[vł܂
*								2`:ĐłȂt@Cł
*
*	WAVEWMA̓t@Crbg[g̏擾邪AȊÕt@C
*	DSP̃Xe[^X擾邱Ƃł
*****************************************************************************/
uint8_t getPlayFileInfo( char *fileName ,PLAY_FILE_INFO *info )
{
	FIL fl;
	uint8_t ret = 1;
	uint16_t pr = PR_UTF8_UTF16_SJIS;

	/* t@Cf[^NA			*/
	clearFileInfo( info );

	/* t@C^Cv(gq)		*/
	PLAY_FILE_TYPE type = getPlayFileType( fileName );
	if ( type == F_OTHER ) {
		return ( 2 );
	}

	/* t@CI[v					*/
	if ( f_open( &fl ,fileName ,FA_READ ) ) {
		return ( 1 );
	}

	/* t@Cɉ			*/
	switch ( type ) {
#if ( ENABLE_WAV != 0 )
		case F_WAVE:
			ret = chkWaveFile( &fl ,info );
			pr = PR_UTF16_UTF8_SJIS;
			break;
#endif

		case F_MP3:
			ret = chkMp3File( &fl ,info );
			pr = PR_UTF8_SJIS_UTF16;
			break;
		
#if ( ENABLE_WMA != 0 )
		case F_WMA:
			ret = chkWmaFile( &fl ,info );
			pr = PR_UTF16_UTF8_SJIS;
			break;
#endif

		case F_MIDI:
			ret = chkMidiFile( &fl ,info );
			pr = PR_SJIS_UTF8_UTF16;
			break;

#if ( ENABLE_AAC != 0 )
		case F_AAC:
			info->type = F_AAC;
			ret = 0;
			pr = PR_UTF16_UTF8_SJIS;
			break;
#endif

		case F_OGG:
			ret = chkOggVorbisFile( &fl ,info );
			pr = PR_UTF8_UTF16_SJIS;
			break;

		default:
			ret = 2;
			break;
	}

	/* t@CN[Y					*/
	f_close( &fl );
	if ( ret ) {
		clearFileInfo( info );
		return ( ret );
	}

	/* A[eBXgEȖ̉擾łȂꍇ̓t@CKp	*/
	if ( ( info->text.textItem.author[0] == '\0' ) && ( info->text.textItem.title[0] == '\0' ) ) {
		pr = PR_UTF16_UTF8_SJIS;
		if ( makeDefaultTag( fileName ,info ) != 0 ) {
			ret = 1;
		}
	}

	if ( ret == 0 ) {

		/* 擾A[eBXg^Ȗ̃R[hϊ				*/
		g_convSJIS( info->text.textItem.author ,sizeof(info->text.textItem.author) ,info->text.textItem.author ,pr );
		strtrim( info->text.textItem.author );

		g_convSJIS( info->text.textItem.title ,sizeof(info->text.textItem.title) ,info->text.textItem.title ,pr );
		strtrim( info->text.textItem.title );

		/* A[eBXgEȖA									*/
		uint16_t len = strlen( info->text.textBuffer );
		char *p = info->text.textBuffer;
		if ( len ) {
			p += len;
			if ( info->text.textItem.title[0] ) {
				strcpy_P( p ,PSTR(" ` ") );
				p += 4;
			}
		}

		if ( info->text.textItem.title[0] ) {
			strcpy( p ,info->text.textItem.title );
		}

	} else {
		clearFileInfo( info );
	}

	return ( ret );
}

/*****************************************************************************
*							t@C\̃NA
* FPLAY_FILE_INFO *info	t@C\
* ߒlFvoid
*****************************************************************************/
void clearFileInfo( PLAY_FILE_INFO *info )
{
	memset( info ,0x00 ,sizeof(PLAY_FILE_INFO) );
	info->type = F_OTHER;				/* t@C							*/
}

#if ( ENABLE_WAV != 0 )
/*****************************************************************************
*							WAVEt@C`FbN
* FFIL *fl         		t@C\
*		PLAY_FILE_INFO *info	t@C\
* ߒlFuint8_t         	 	0:OK !0:NG
*****************************************************************************/
static uint8_t chkWaveFile( FIL *fl ,PLAY_FILE_INFO *info )
{
	/* WAVEt@C̊g܂܂Ȃfmt`N(16bytes)	*/
	typedef struct WAVE_FMT_t {
		uint16_t id;					/* tH[}bgID					*/
		uint16_t amountOfChannel;		/* `l						*/
		uint32_t samplesPerSec;			/* TvO[g(Hz)			*/
		uint32_t dataRate;				/* f[^x(Byte/sec)				*/
		uint16_t blockSize;				/* 1ubÑoCg(ACg)*/
		uint16_t bitsPerSamples;		/* Tvӂ̃rbg			*/
	} WAVE_FMT;

	/*	ϐ錾							*/
	WAVE_FMT fmt;
	uint16_t n = 0;
	uint32_t size = 0L;
	uint8_t buf[8];

	PLAY_FILE_TYPE ret = F_OTHER;

	f_lseek( fl ,0L );

	/* "RIFF" ʎqmF					*/
	if ( ( f_read( fl ,buf ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
		return ( 10 );
	}

	if ( memcmp_P( buf ,PSTR("RIFF") ,4 ) != 0 ) {
		return ( 11 );
	}

	/* t@CTCYmF					*/
	if ( ( f_read( fl ,&size ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
		return ( 12 );
	}

	if ( size < 52L ) {
		f_close( fl );
		return ( 13 );
	}

	/* "WAVE" ʎqmF					*/
	if ( ( f_read( fl ,buf ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
		return ( 14 );
	}

	if ( memcmp_P( buf ,PSTR("WAVE") ,4 ) != 0 ) {
		return ( 15 );
	}

	/* "fmt "`NʎqmF				*/
	if ( ( f_read( fl ,&buf ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
		return ( 16 );
	}

	if ( memcmp_P( buf ,PSTR("fmt ") ,4 ) != 0 ) {
		return ( 17 );
	}

	/* "fmt "`NTCYmF				*/
	if ( ( f_read( fl ,&size ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
		return ( 18 );
	}

	if ( size < (uint32_t)sizeof(WAVE_FMT) ) {
		return ( 19 );
	}

	/* "fmt "`Nǂݍ				*/
	if ( ( f_read( fl ,&fmt ,sizeof(WAVE_FMT) ,&n ) != FR_OK ) || ( n != sizeof(WAVE_FMT) ) ) {
		return ( 20 );
	}
	
	/* jAPCM̏					*/
	if ( fmt.id == 0x0001 ) {

		/* 8bit/16bitTvȊO͍Đs	*/
		if ( ( fmt.bitsPerSamples != 8 ) && ( fmt.bitsPerSamples != 16 ) ) {
			return ( 21 );
		}
		ret = F_PCM;

	/* IMA ADPCM̏					*/
	} else if ( fmt.id == 0x0011 ) {

		/* 4bitTvȊO͍Đs		*/
		if ( fmt.bitsPerSamples != 4 ) {
			return ( 22 );
		}
		ret = F_ADPCM;

	/* T|[gÕf[^̏			*/
	} else {
		return ( 23 );

	}

	/* `l`FbN / mEXeÎݍĐ	*/
	if ( ( fmt.amountOfChannel != 1 ) && ( fmt.amountOfChannel != 2 ) ) {
		return ( 24 );
	}

	/* TvO[g`FbN ő44.1KHz܂ōĐ\	*/
	if ( ( fmt.samplesPerSec == 0L ) || ( fmt.samplesPerSec > WAVE_MAX_FREQ ) ) {
		return ( 25 );
	}

	/* ̃`NʒuփV[N				*/
	if ( f_lseek( fl ,20L + size ) != FR_OK ) {
		return ( 26 );
	}

	/* "data"`N					*/
	while ( 1 ) {
		if ( ( f_read( fl ,buf ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
			return ( 27 );
		}

		if ( ( f_read( fl ,&size ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
			return ( 28 );
		}

		if ( memcmp_P( buf ,PSTR("data") ,4 ) == 0 ) {
			break;
		}

		/* ̃f[^`NʒuփV[N	*/
		if ( f_lseek( fl ,fl->fptr + size ) != FR_OK ) {
			return ( 29 );
		}
	}
	
	/* 쐬								*/
	if ( ret ) {
		info->type = ret;								/* t@C							*/
		info->startPos = fl->fptr;						/* f[^̊Jnʒu						*/
		info->samplesPerSeconds = fmt.samplesPerSec;	/* TvOg(Hz)				*/
		info->blockSize = fmt.blockSize;				/* 1ubÑoCg(ACg)	*/
		info->bitsPerSamples = fmt.bitsPerSamples;		/* PTvӂ̃rbg				*/

		/* rbg[gvZ					*/
		uint32_t bit = (uint32_t)fmt.bitsPerSamples;
		bit *= (uint32_t)fmt.samplesPerSec;
		bit *= (uint32_t)fmt.amountOfChannel;
		info->bitRate = (uint16_t)( bit / 1000L );
	}

	return ( 0 );
}
#endif // if ( ENABLE_WAV != 0 )

/*****************************************************************************
*							MIDIt@C`FbN
* FFIL *fl         		t@C\
*		PLAY_FILE_INFO *info	t@C\
* ߒlFuint8_t         		0:OK !0:NG
* ^Cxg "0x03" ݂܂ŃCxgPʂœXL
* ŌɃf[^lȏꍇ10b߂Ԃ
*****************************************************************************/
static uint8_t chkMidiFile( FIL *fl ,PLAY_FILE_INFO *info )
{
	uint8_t stsByte;					/* Xe[^XoCg					*/
	uint8_t backSts;					/* ÕXe[^XoCg			*/
	uint8_t typ;
	uint8_t ret;
	uint16_t n;
	uint16_t val16;
	uint32_t val32;
	uint32_t len;
	uint32_t trackSize;
	char buf[22];

	/* 擪f[^擾						*/
	if ( ( f_read( fl ,buf ,22 ,&n ) != FR_OK ) || ( n != 22 ) ) {
		return ( 1 );
	}
	
	/* ʕmF							*/
	if ( memcmp_P( &buf[0] ,PSTR("MThd") ,4 ) != 0 ) {
		return ( 2 );
	}

	/* wb_mF							*/
	val32 = ( (uint32_t)buf[4] << 24 ) | ( (uint32_t)buf[5] << 16 ) | ( (uint32_t)buf[6] << 8 ) | (uint32_t)buf[7];
	if ( val32 != 6L ) {
		return ( 3 );
	}

	/* tH[}bgԍmF			*/
	val16 = ( (uint16_t)buf[8] << 8 ) | (uint16_t)buf[9];
	if ( val16 != 0 ) {						/* tH[}bgÔݑΉ	*/
		return ( 4 );
	}

	/* gbNmF				*/
	val16 = ( (uint16_t)buf[10] << 8 ) | (uint16_t)buf[11];
	if ( val16 != 1 ) {					/* tH[}bgO͂PŒ	*/
		return ( 5 );
	}

	/* ԒPʎ擾					*/
	val16 = ( (uint16_t)buf[12] << 8 ) | (uint16_t)buf[13];

	/* gbNʎq 'MTrk' mF	*/
	if ( memcmp_P( &buf[14] ,PSTR("MTrk") ,4 ) != 0 ) {
		return ( 6 );
	}

	/* gbN擾				*/
	trackSize = ( (uint32_t)buf[18] << 24 ) | ( (uint32_t)buf[19] << 16 ) | ( (uint32_t)buf[20] << 8 ) | (uint32_t)buf[21];
	if ( fl->fsize != ( trackSize + 22L ) ) {			/* t@CTCYG[?	*/
		return ( 7 );
	}

	/* ŏɌ^Cxg̕^CgƂ	*/
	backSts = 0;
	while ( fl->fptr < fl->fsize ) {
		wdt_reset();

		/* f^^C擾						*/
		if ( file_getVariableValue( fl ,&val32 ) ) {
			return ( 8 );
		}

		/* Xe[^XoCg擾					*/
		if ( ( f_read( fl ,&stsByte ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
			return ( 9 );
		}

		/* jOXe[^XL̏		*/
		if ( ( stsByte & 0x80 ) == 0 ) {
			if ( ( backSts == 0 ) || ( f_lseek( fl ,fl->fptr - 1L ) != FR_OK ) ) {
				return ( 10 );
			}
			stsByte = backSts;
		}

		/* SysExCxg		*/
		if ( ( stsByte == 0xf0 ) || ( stsByte == 0xf7 ) ) {
			backSts = 0;
			ret = file_getVariableValue( fl ,&len );
			ret |= f_lseek( fl ,fl->fptr + len );
			if ( ret ) {
				return ( 11 );
			}

		/* ^Cxg			*/
		} else if ( stsByte == 0xff ) {
			backSts = 0;
			ret  = ( f_read( fl ,&typ ,1 ,&n ) != FR_OK ) || ( n != 1 );
			ret |= file_getVariableValue( fl ,&len );
			if ( ret ) {
				return ( 12 );
			}

			if ( typ == 0x00 ) {							/* Sequence Number			*/
			
			} else if ( typ == 0x01 ) {						/* Text						*/
				;
			
			} else if ( typ == 0x02 ) {						/* 쌠					*/
				;
			
			} else if ( typ == 0x03 ) {						/* V[PXEgbN */
				if ( len > sizeof(info->text.textItem.title) - 3 ) {
					len = sizeof(info->text.textItem.title) - 3;
				}

				if ( ( f_read( fl ,info->text.textItem.title ,len ,&n ) != FR_OK ) || ( n != len ) ) {
					return ( 33 );
				}

				memset( &info->text.textItem.title[len] ,0x00 ,3 );
				break;

			} else if ( typ == 0x04 ) {						/* y햼				 	*/
				;

			} else if ( typ == 0x05 ) {						/* ̎						*/
				;
			
			} else if ( typ == 0x06 ) {						/* }[J[					*/
				;

			} else if ( typ == 0x07 ) {						/* L[|C^			*/
				;
			
			} else if ( typ == 0x08 ) {						/* vOiFj		*/
				;

			} else if ( typ == 0x09 ) {						/* foCX				*/
				;
			
			} else if ( typ == 0x20 ) {						/* MIDI`lvtBbNX 	*/
				;
			
			} else if ( typ == 0x21 ) {						/* o̓|[g				*/
				;
			
			} else if ( typ == 0x2f ) {						/* gbNI[				*/
				break;

			} else if ( typ == 0x51 ) {						/* e|ݒ				*/
				;
			
			} else if ( typ == 0x54 ) {						/* SMPTE ItZbg 		*/
				;

			} else if ( typ == 0x58 ) {						/* qL					*/
				;
			
			} else if ( typ == 0x59 ) {						/* 						*/
				;
			
			} else if ( typ == 0x7f ) {						/* V[PT[胁^Cxg	*/
				;
			}

			if ( f_lseek( fl ,fl->fptr + len ) ) {
				return ( 13 );
			}

		/* MIDICxg		*/
		} else {
			backSts = stsByte;

			stsByte &= 0x80;
			if ( ( stsByte == 0xc0 ) || ( stsByte == 0xd0 ) ) {
				len = 1L;

			} if ( ( stsByte == 0x80 ) || ( stsByte == 0x90 ) || ( stsByte == 0xa0 ) || ( stsByte == 0xb0 ) || ( stsByte == 0xe0 ) ) {
				len = 2L;

			} else {
				return ( 14 );
			}
			
			if ( f_lseek( fl ,fl->fptr + len ) ) {
				return ( 15 );
			}
		}
	}

	/* 쐬								*/
	info->type = F_MIDI;							/* t@C							*/
	info->startPos = 22L;							/* f[^̊Jnʒu						*/
	info->samplesPerSeconds = 0;					/* TvOg(Hz)				*/
	info->blockSize = 0;							/* 1ubÑoCg(ACg)	*/
	info->bitRate = 0;								/* rbg[g(Kbps)					*/
	info->bitsPerSamples = 0;						/* PTvӂ̃rbg				*/

	return ( 0 );
}

#if ( ENABLE_WMA != 0 )
/*****************************************************************************
*							WMAt@C`FbN
* FFIL *fl					t@C\
*		PLAY_FILE_INFO *info	t@C\
* ߒlFuint8_t         		0:OK !0:NG
*****************************************************************************/
static uint8_t chkWmaFile( FIL *fl ,PLAY_FILE_INFO *info )
{
	typedef struct COMMON_t {						/* 24Bytes				*/
		uint8_t id[16];								/* ̃ubNID		*/
		uint32_t blockLength;						/* ̃ubN̒	*/
		uint32_t dumy;
	} COMMON;

	typedef struct HEADER_OBJECT_t {				/* 32bytes				*/
		uint8_t id[16];								/* ̃ubNID		*/
		uint32_t blockLength;						/* ̃ubN̒	*/
		uint32_t dumy;
		uint32_t headerObjects;
		uint8_t alignment;
		uint8_t architecture;
	} HEADER_OBJECT;

	typedef struct STREAM_PROPERTIES_OBJECT_t {		/* 70bytes				*/
		uint8_t streamType[16];
		uint8_t errorCorrectionType[16];
		uint8_t timeOffset[8];
		uint32_t typeSpecificDataLength;
		uint32_t errorCorrectionDataLength;
		uint8_t flags[2];
		uint8_t reserved[4];
		uint16_t FormatTag;
		uint16_t Channels;
		uint32_t SamplesPerSeconds;
		uint32_t AverageBytesPerSecond;
		uint16_t BlockAlign;
		uint16_t BitsPerSample;
	} STREAM_PROPERTIES_OBJECT;

	typedef struct CONTENT_DESCRIPTION_OBJECT_t {	/* 34bytes				*/
		uint16_t titleLength;
		uint16_t authorLength;
		uint16_t copyrightLength;
		uint16_t descriptionLength;
		uint16_t ratingLength;
	} CONTENT_DESCRIPTION_OBJECT;

	HEADER_OBJECT header;
	COMMON com;
	STREAM_PROPERTIES_OBJECT streamProperties;
	CONTENT_DESCRIPTION_OBJECT contentDescription;
	char buf[40];

	uint16_t n;
	uint32_t nextFpos;

	/* Header Object 擾		*/
	f_lseek( fl ,0L );
	if ( ( f_read( fl ,&header ,sizeof(HEADER_OBJECT) ,&n ) != FR_OK ) || ( n != sizeof(HEADER_OBJECT) ) ) {
		return ( 40 );
	}

	convertWMA_ID( header.id ,buf );
	if ( strcmp_P( buf ,PSTR("75B22630-668E-11CF-A6D9-00AA0062CE6C") ) ) {	/* WMAwb_ł͂Ȃ	*/
		return ( 41 );
	}

	/* wb_̊eIuWFNg	*/
	while ( fl->fptr < header.blockLength ) {
		wdt_reset();

		/* IDƃf[^擾			*/
		if ( ( f_read( fl ,&com ,sizeof(COMMON) ,&n ) != FR_OK ) || ( n != sizeof(COMMON) ) ) {
			return ( 42 );
		}

		if ( com.blockLength <= sizeof(COMMON) ) {
			return ( 43 );
		}

		nextFpos = fl->fptr + ( com.blockLength - sizeof(COMMON) );
		convertWMA_ID( com.id ,buf );

		/* File Properties Object				*/
		if ( !strcmp_P( buf ,PSTR("8CABDCA1-A947-11CF-8EE4-00C00C205365") ) ) {
			;

		/* Header Extension Object 				*/
		} else if ( !strcmp_P( buf ,PSTR("5FBF03B5-A92E-11CF-8EE3-00C00C205365") ) ) {
			;

		/* Extended Content Description Object  */
		} else if ( !strcmp_P( buf ,PSTR("D2D0A440-E307-11D2-97F0-00A0C95EA850") ) ) {
			;

		/* Codec List Object					*/
		} else if ( !strcmp_P( buf ,PSTR("86D15240-311D-11D0-A3A4-00A0C90348F6") ) ) {
			;

		/* Stream Properties Object				*/
		} else if ( !strcmp_P( buf ,PSTR("B7DC0791-A9B7-11CF-8EE6-00C00C205365") ) ) {
			if ( ( f_read( fl ,&streamProperties ,sizeof(STREAM_PROPERTIES_OBJECT) ,&n ) != FR_OK ) || ( n != sizeof(STREAM_PROPERTIES_OBJECT) ) ) {
				return ( 44 );
			}

			/* ݒ					*/
			info->samplesPerSeconds = streamProperties.SamplesPerSeconds;						/* TvOg(Hz)				*/
			info->blockSize = streamProperties.BlockAlign;										/* 1ubÑoCg(ACg)	*/
			info->bitRate = (uint16_t)( ( streamProperties.AverageBytesPerSecond * 8L ) / 1024L );	/* σrbg[g(Kbps)			*/
			info->bitsPerSamples = streamProperties.BitsPerSample;								/* PTvӂ̃rbg				*/

		/* Stream Bitrate Properties Object  	*/
		} else if ( !strcmp_P( buf ,PSTR("7BF875CE-468D-11D1-8D82-006097C9A2B2") ) ) {
			;

		/* Content Description Object	 		*/
		} else if ( !strcmp_P( buf ,PSTR("75B22633-668E-11CF-A6D9-00AA0062CE6C") ) ) {
			if ( ( f_read( fl ,&contentDescription ,sizeof(CONTENT_DESCRIPTION_OBJECT) ,&n ) != FR_OK ) || ( n != sizeof(CONTENT_DESCRIPTION_OBJECT) ) ) {
				return ( 45 );
			}

			uint32_t fpos = fl->fptr;

			/* ^Cg擾						*/
			if ( contentDescription.titleLength ) {
				uint16_t rn = contentDescription.titleLength;
				if ( rn > sizeof(info->text.textItem.title) - 3 ) {
					rn = sizeof(info->text.textItem.title) - 3;
				}

				if ( ( f_read( fl ,info->text.textItem.title ,rn ,&n ) != FR_OK ) || ( n != rn ) ) {
					return ( 7 );
				}
				memset( &info->text.textItem.title[rn] ,0x00 ,3 );
			}

			/* Ҏ擾							*/
			if ( contentDescription.authorLength ) {
				if ( f_lseek( fl ,fpos + (uint32_t)contentDescription.titleLength ) != FR_OK ) {
					return ( 8 );
				}

				uint16_t rn = contentDescription.authorLength;
				if ( rn > sizeof(info->text.textItem.author) - 3 ) {
					rn = sizeof( info->text.textItem.author) - 3;
				}

				if ( ( f_read( fl ,info->text.textItem.author ,rn ,&n ) != FR_OK ) || ( n != rn ) ) {
					return ( 9 );
				}
				memset( &info->text.textItem.author[rn] ,0x00 ,3 );
			}
		}

		/* ̃IuWFNgփV[N				*/
		if ( f_lseek( fl ,nextFpos ) ) {
			return ( 46 );
		}
	}

	/* ݒ					*/
	info->type = F_WMA;								/* t@C			*/
	info->startPos = fl->fptr;						/* f[^̊Jnʒu		*/

	return ( 0 );
}
#endif // if ( ENABLE_WMA != 0 )

/*****************************************************************************
*								MP3t@C`FbN
* FFIL *fl         		t@C\
*		PLAY_FILE_INFO *info	t@C\
* ߒlFuint8_t         		0:OK !0:NG
*****************************************************************************/
static uint8_t chkMp3File( FIL *fl ,PLAY_FILE_INFO *info )
{
	uint8_t buf[12];
	uint8_t ver;
	uint8_t flg;
	uint16_t n;
	uint16_t rn;
	uint32_t size;
	uint32_t nextFpos;

	/* t@Cݒ					*/
	info->type = F_MP3;

	/* ID3v2 擾						*/
	f_lseek( fl ,0 );
	if ( ( f_read( fl ,buf ,10 ,&n ) != FR_OK ) || ( n != 10 ) ) {
		return ( 50 );
	}

	if ( memcmp_P( buf ,PSTR("ID3") ,3 ) == 0 ) {
		ver = (uint8_t)buf[3];					/* o[W擾			*/
		flg = 0x00;								/* ItOZbg	*/
		while ( 1 ) {
			wdt_reset();
	
			/* f[^TCY擾	*/
			if ( ver == 2 ) {
				if ( ( f_read( fl ,buf ,6 ,&n ) != FR_OK ) || ( n != 6 ) ) {
					return ( 8 );
				}
				size = ( (uint32_t)buf[3] << 16 ) + ( (uint32_t)buf[4] << 8 ) + (uint32_t)buf[5];

			} else {
				if ( ( f_read( fl ,buf ,10 ,&n ) != FR_OK ) || ( n != 10 ) ) {
					return ( 9 );
				}
				size = ( (uint32_t)buf[4] << 24 ) + ( (uint32_t)buf[5] << 16 ) + ( (uint32_t)buf[6] << 8 ) + (uint32_t)buf[7];
			}

			/* ʎqmF		*/
			if ( ( buf[0] < 'A' ) || ( buf[0] > 'Z' ) ) {
				break;
			}

			/* ̃t[|WVvZ	*/
			nextFpos = fl->fptr + size;

			/* ^Cg擾					*/
			if ( ( memcmp_P( buf ,PSTR("TIT2") ,4 ) == 0 ) || ( memcmp_P( buf ,PSTR("TT2") ,3 ) == 0 ) ) {

				if ( size > 1L ) {
					size--;
					if ( size > sizeof(info->text.textItem.title) - 3 ) {
						rn = sizeof(info->text.textItem.title) - 3;
					} else {
						rn = (uint16_t)size;
					}

					if ( ( f_read( fl ,buf ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
						return ( 51 );
					}

					if ( ( f_read( fl ,info->text.textItem.title ,rn ,&n ) != FR_OK ) || ( n != rn ) ) {
						return ( 52 );
					}
					memset( &info->text.textItem.title[rn] ,0x00 ,3 );
				}

				flg |= 0x01;
				if ( flg == 0x03 ) {
					break;
				}

			/* A[eBXg擾				*/
			} else if ( ( memcmp_P( buf ,PSTR("TPE1") ,4 ) == 0 ) || ( memcmp_P( buf ,PSTR("TP1") ,3 ) == 0 ) ) {

				if ( size > 1L ) {
					size--;
					if ( size > sizeof(info->text.textItem.author) - 3 ) {
						rn = sizeof(info->text.textItem.author) - 3;
					} else {
						rn = (uint16_t)size;
					}

					if ( ( f_read( fl ,buf ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
						return ( 8 );
					}

					if ( ( f_read( fl ,info->text.textItem.author ,rn ,&n ) != FR_OK ) || ( n != rn ) ) {
						return ( 9 );
					}

					memset( &info->text.textItem.author[rn] ,0x00 ,3 );
				}

				flg |= 0x02;
				if ( flg == 0x03 ) {
					break;
				}
			}

			/* ̃t[փV[N			*/
			if ( f_lseek( fl ,nextFpos ) != FR_OK ) {
				return ( 53 );
			}
		}

	/* ID3v1(ID3v2݂Ȃꍇ擾)		*/
	} else {
		if ( ( fl->fsize > 128 ) && ( f_lseek( fl ,fl->fsize - 128L ) == FR_OK ) ) {
			if ( ( f_read( fl ,buf ,3 ,&n ) != FR_OK ) || ( n != 3 ) ) {
				return ( 54 );
			}

			if ( memcmp_P( buf ,PSTR("TAG") , 3 ) == 0 ) {
				if ( ( f_read( fl ,info->text.textItem.title ,30 ,&n ) != FR_OK ) || ( n != 30 ) ) {
					return ( 55 );
				}
				memset( &info->text.textItem.title[30] ,0x00 ,3 );

				if ( f_lseek( fl ,( fl->fsize - 128L ) + 33L ) != FR_OK ) {
					return ( 56 );
				}

				if ( ( f_read( fl ,info->text.textItem.author ,30 ,&n ) != FR_OK ) || ( n != 30 ) ) {
					return ( 57 );
				}
				memset( &info->text.textItem.author[30] ,0x00 ,3 );
			}
		}
	}

	return ( 0 );
}

/*****************************************************************************
*								OggVorbist@C`FbN
* FFIL *fl         		t@C\
*		PLAY_FILE_INFO *info	t@C\
* ߒlFuint8_t         		0:OK !0:NG
*****************************************************************************/
static uint8_t chkOggVorbisFile( FIL *fl ,PLAY_FILE_INFO *info )
{
	/* pPbgwb_				*/
	typedef struct PACKET_HEADER_t {
		char pattern[4];			/* capture pattern "OggS"				*/
		uint8_t ssv;				/* stream structure version ʏ0		*/
		uint8_t flag;				/* header type flag						*/
									/* 1:f[^͍Ō̃y[W瑱	*/
									/* 2:Xg[̍ŏ̃y[Wł		*/
									/* 3:Xg[̍Ō̃y[Wł		*/
		uint8_t pos[8];				/* absolute granule position 			*/
		uint32_t serial;			/* stream serial number					*/
		uint32_t seq;				/* page sequence number					*/
		uint32_t csum;				/* check sum (CRC32)					*/
		uint8_t segs;				/* page segments sengment count			*/
	} PACKET_HEADER;

	/* pbN^Cv 0x01 f[^\	*/
	typedef struct PACK0_t {
		uint32_t zero;
		uint8_t channel;
		uint32_t freq;
		uint32_t bititrate_upper;
		uint32_t bitrate_nominal;
		uint32_t bitrate_lower;
		uint8_t blocksizes;
		uint8_t one;
	} PACK0;

	union {
		PACKET_HEADER packetHed;
		uint8_t buf[8];
	} u;

	uint32_t packetDataTopFpos;				/* ݂̃pPbg̎f[^擪t@Cʒu	*/
	uint32_t NowPacketDataTopFpos = 0;		/* ݂̃pPbg̐擪t@Cʒu			*/

	uint16_t packetDataSize;				/* pPbgɊ܂܂f[^				*/
	uint16_t packetDataQuantity;			/* ̃pPbgf[^				*/

	uint16_t itemDataSize;					/* 擾ACẽf[^					*/
	uint16_t itemDataQuantity;				/* ACef[^					*/
	uint16_t itemDataLength;				/* ς݂̃ACef[^				*/

	uint16_t pageItemCount;					/* y[WACe						*/
	uint16_t pageItemIndex;					/* y[WACeCfbNX				*/

	uint8_t flagPageBegin;					/* y[WtO						*/
	uint8_t flagItemBegin;					/* ACetO						*/

	uint16_t tc;							/* A[eBXg^^Cg擾			*/
	uint8_t flagGet = 0;					/* A[eBXg^^Cg擾tO			*/
	uint8_t flagLoop = 1;

	char itemData[8];						/* ACef[^擪ۑpobt@			*/

	uint16_t n;

	uint32_t val32;
	uint16_t val16;
	uint8_t val8;

	packetDataTopFpos = 0L;
	packetDataSize = 0L;
	flagPageBegin = 0;
	while ( flagLoop ) {
		wdt_reset();

		/* ̃pPbgwb_փV[N	*/
		packetDataTopFpos += (uint32_t)packetDataSize;
		if ( packetDataTopFpos >= fl->fsize ) {
			break;
		}

		NowPacketDataTopFpos = fl->fptr;
		if ( f_lseek( fl ,packetDataTopFpos ) != FR_OK ) {
			return ( 1 );
		}

		/* pPbgwb_擾			*/
		if ( ( f_read( fl ,&u.packetHed ,sizeof(PACKET_HEADER) ,&n ) != FR_OK ) || ( n != sizeof(PACKET_HEADER) ) ) {
			return ( 2 );
		}

		if ( memcmp_P( u.packetHed.pattern ,PSTR("OggS") ,4 ) != 0 ) {
			return ( 3 );
		}

		/* ZOge[uv		*/
		packetDataSize = 0;
		while ( u.packetHed.segs-- ) {
			wdt_reset();
			if ( ( f_read( fl ,&val8 ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
				return ( 4 );
			}
			packetDataSize += (uint16_t)val8;
		}

		/* ݂̃t@CʒuL		*/
		packetDataTopFpos = fl->fptr;

		/* pPbgf[^[v		*/
		packetDataQuantity = packetDataSize;
		while( packetDataQuantity && flagLoop ) {
			wdt_reset();
			if ( packetDataQuantity > packetDataSize ) {
				return ( 5 );
			}

			/* y[W̎n܂菈		*/
			if ( flagPageBegin == 0 ) {

				/* pbN^Cv擾		*/
				if ( ( f_read( fl ,&u.buf[0] ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
					return ( 6 );
				}

				/* _~[pbNXLbv						*/
				if ( u.buf[0] == 0x00 ) {
					continue;
				}

				/* "vorbis" ʎq擾						*/
				if ( ( f_read( fl ,&u.buf[1] ,6 ,&n ) != FR_OK ) || ( n != 6 ) ) {
					return ( 7 );
				}

				/* "vorbis" ʎq`FbN					*/
				if ( memcmp_P( &u.buf[1] ,PSTR("vorbis") ,6 ) != 0 ) {
					return ( 8 );
				}

				packetDataQuantity -= 7L;

				/* pbN^Cv 1 (PACK_INFO)				*/
				if ( u.buf[0] == 1 ) {
					#if DEBUG
					puts_P( PSTR("packtype : [0x01 PACK_INFO]") );
					#endif
					if ( f_lseek( fl ,fl->fptr + sizeof(PACK0) ) != FR_OK ) {
						return ( 9 );
					}
					packetDataQuantity -= sizeof(PACK0);
					continue;

				/* pbN^Cv 5 (PACK_BOOK)				*/
				} else if ( u.buf[0] == 5 ) {			/* ̃pbNf[^o͂I	*/
					flagLoop = 0;
					break;

				/* pbN^Cv 3 (PACK_COMMENT)			*/
				} else if ( u.buf[0] == 3 ) {

					/* x_[XLbv						*/
					if ( ( f_read( fl ,&val32 ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
						return ( 10 );
					}
					packetDataQuantity -= 4;

					if ( val32 > packetDataQuantity ) {
						return ( 11 );
					}

					if ( f_lseek( fl ,fl->fptr + val32 ) != FR_OK ) {
						return ( 12 );
					}
					packetDataQuantity -= (uint16_t)val32;

					/* y[WACe擾					*/
					if ( ( f_read( fl ,&val32 ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
						return ( 13 );
					}
					packetDataQuantity -= 4;

					if ( val32 > 255L ) {
						return ( 14 );
					}
					pageItemCount = (uint16_t)val32;

					if ( packetDataQuantity >= packetDataSize ) {
						continue;
					}

					flagPageBegin = 1;
					flagItemBegin = 0;
					pageItemIndex = 0;

				/* ȃpbNԍ			*/
				} else {
					return ( 15 );
				}
			}

			/* pbN^CvRiACe擾Jnj		*/
			if ( flagItemBegin == 0 ) {
				pageItemIndex++;
				if ( pageItemIndex > pageItemCount ) {				/* ACeIH	*/
					if ( ( f_read( fl ,&val8 ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
						return ( 16 );
					}
					packetDataQuantity--;
					flagPageBegin = 0;
					continue;
				}

				/* ACe擾	*/
				if ( ( f_read( fl ,&val32 ,4 ,&n ) != FR_OK ) || ( n != 4 ) ) {
					return ( 17 );
				}

				if ( val32 >= 65025U ) {
					return ( 18 );
				}
					
				packetDataQuantity -= 4;
				itemDataSize = (uint16_t)val32;

				#if DEBUG
				printf_P( PSTR("page %lu : item %u : length %u : ") ,pageIndex ,pageItemIndex ,itemDataSize );
				#endif

				itemDataQuantity = itemDataSize;
				flagItemBegin = 1;
				itemDataLength = 0;
			}

			if ( itemDataQuantity > itemDataSize ) {
				return ( 19 );
			}

			/* ACef[^擾				*/
			val16 = itemDataQuantity;
			if ( val16 > packetDataQuantity ) {
				val16 = packetDataQuantity;
			}

			if ( packetDataQuantity < val16 ) {
				return ( 20 );
			}
			packetDataQuantity -= val16;

			if ( itemDataQuantity < val16 ) {
				return ( 21 );
			}
			itemDataQuantity -= val16;

			while ( val16-- ) {
				wdt_reset();
				if ( ( f_read( fl ,&val8 ,1 ,&n ) != FR_OK ) || ( n != 1 ) ) {
					return ( 22 );
				}

				if ( itemDataLength < ( sizeof(itemData) - 1 ) ) {
					itemData[itemDataLength++] = val8;
					itemData[itemDataLength] = '\0';

					if ( ( itemDataLength == 6 ) && ( strcasecmp_P( itemData ,PSTR("TITLE=") ) == 0 ) ) {			/* ^Cgf[^JnH		*/
						flagGet |= 0x80;
						tc = 0;
						continue;

					} else if ( ( itemDataLength == 7 ) && ( strcasecmp_P( itemData ,PSTR("ARTIST=") ) == 0 ) ) {	/* A[eBXgf[^JnH	*/
						flagGet |= 0x08;
						tc = 0;
						continue;
					}
				}

				if ( ( ( flagGet & 0x80 ) == 0x80 ) && ( tc < sizeof(info->text.textItem.title) - 3 ) ) {					/* obt@ɋ󂫂΃^Cg擾		*/
					info->text.textItem.title[tc++] = val8;
				} else if ( ( ( flagGet & 0x08 ) == 0x08 ) && ( tc < sizeof(info->text.textItem.author) - 3 ) ) {			/* obt@ɋ󂫂΃A[eBXg擾	*/
					info->text.textItem.author[tc++] = val8;
				}
			}

			/* ACef[^擾̏			*/
			if ( itemDataQuantity == 0 ) {
				flagItemBegin = 0;

				if ( ( flagGet & 0x80 ) == 0x80 ) {
					flagGet |= 0x40;
					flagGet &= ~0x80;
					memset( &info->text.textItem.title[tc] ,0x00 ,3 );
				} else if ( ( flagGet & 0x08 ) == 0x08 ) {
					flagGet |= 0x04;
					flagGet &= ~0x08;
					memset( &info->text.textItem.author[tc] ,0x00 ,3 );
				}
			}
		}
	}

	/* ĐZbg			*/
	info->startPos = NowPacketDataTopFpos;			/* f[^̊Jnʒu		*/
	info->type = F_OGG;								/* t@C			*/

	return ( 0 );
}

#if ( ENABLE_WMA != 0 )
/*****************************************************************************
*					WMAt@C̃IuWFNgID𕶎ɕϊ
*@Fuint8_t *id  IDf[^(16bytes)
*        char *ids    IDi[̈(36bytes)
****************************************************************************/
static void convertWMA_ID( uint8_t *id ,char *ids )
{
	/* f[^CfbNX prog_.... gpꍇ 'static const' ŏCȂƃn}!!	*/
	static const prog_uint8_t idx[16] = { 0x03 ,0x02 ,0x01 ,0x00 ,0x05 ,0x04 ,0x07 ,0x06 ,0x08 ,0x09 ,0x0a ,0x0b ,0x0c ,0x0d ,0x0e ,0x0f };

	for ( uint8_t i = 0 ;i < 16 ;i++ ) {
		if ( ( i == 4 ) || ( i == 6 ) || ( i == 8 ) || ( i == 10 ) ) { 
			*ids++ = '-';
		}
		sprintf_P( ids ,PSTR("%02X") ,id[ pgm_read_byte( &idx[i] ) ] );
		ids += 2;
	}
}
#endif // #if ( ENABLE_WMA != 0 )

/*****************************************************************************
*				MIDIt@CŎgpĂϒf[^擾
* FFIL      *fl  t@C\
*		uint32_t *val li[obt@
* ߒlFuint8_t       0:OK !0:NG
*****************************************************************************/
static uint8_t file_getVariableValue( FIL *fl ,uint32_t *val )
{
	uint8_t dat;
	uint16_t n;

	(*val) = 0L;
	while ( ( f_read( fl ,&dat ,1 ,&n ) == FR_OK ) && ( n == 1 ) ) {
		(*val) <<= 7;
		(*val) |= (uint32_t)( dat & 0x7f );
		if ( ( dat & 0x80 ) == 0 ) {
			return ( 0 );
		}
	}

	return ( 1 );
}

/*****************************************************************************
*			tpX̃t@CefBNg{t@C擾
* Fchar *fname			 t@Ci8.3tpXj
*		PLAY_FILE_INFO *info PLAY_FILE_INFO *info
* ߒlFuint8_t         	 0:OK !0:NG
******************************************************************************/
static uint8_t makeDefaultTag( char *fname ,PLAY_FILE_INFO *info )
{
	char buf[ LFN_LENGTH + 8 ];
	char *p;
	uint8_t ret;	

	/* efBNg擾i[g̏ꍇ͋󔒁j				*/
	p = inStrRev( fname ,'/' );
	if ( p != NULL ) {

		/* efBNgLFN擾							*/
		*p = '\0';
		ret = f_getLFN( fname ,buf );
		*p = '/';

		if ( ret == 0 ) {
			memcpy( info->text.textItem.author ,buf ,sizeof(info->text.textItem.author) );
		}
	}

	/* t@CLFN擾										*/
	ret = f_getLFN( fname ,buf );
	if ( ret == 0 ) {
		memcpy( info->text.textItem.title ,buf ,sizeof(info->text.textItem.title) );
	}

	return ( 0 );
}
