/*###########################################################################
#                                                                           #
#  			        	v[[W[                                #
#                                                                           #
###########################################################################*/
#ifndef __PLAYER_H__
#define __PLAYER_H__

#include <avr/io.h>
#include "FatFs/tff.h"

/* v[[R}h				*/
typedef enum {
	 PLAY_CURRENT			= 0x01				/* JgACeĐ(W[Lj		*/
	,PLAY_NEXT				= 0x02				/* ̋ȂĐ									*/
	,PLAY_BACK				= 0x03				/* ŐȂĐ								*/
} PLAY_MODE;

/* v[[Xe[^X				*/
/* 7bit    : G[tO			*/
/* 6bit    : DSP]tO		*/
/* 5bit    : t@CI[vtO	*/
/* 0`3bit : Xe[^Xԍ			*/
#define PLAY_STS_ERROR_BIT		0x80
#define PLAY_STS_DSP_BIT		0x40
#define PLAY_STS_OPEN_BIT		0x20
#define PLAY_STS_DSP_ERROR_BIT	0x10
typedef enum {
	 PLAY_STS_NONE          = 0x00				/* player_process()/player_play()֐̐pߒl */
	,PLAY_STS_STOP			= 0x01				/* Đ										*/
	,PLAY_STS_PLAYING		= 0x62				/* Đ										*/
	,PLAY_STS_FAINARAIZ		= 0x63				/* t@CiCY								*/
	,PLAY_STS_FINISH		= 0x04				/* RɍĐI							*/
	,PLAY_STS_PAUSE			= 0x25				/* |[Y										*/
	,PLAY_STS_ERROR			= 0x96				/* DSP]荞ݓŃG[				*/
	,PLAY_STS_NOT_INSERT	= 0x87				/* SDJ[h}								*/
	,PLAY_STS_ACCESS_ERROR  = 0x88				/* SDJ[hANZXG[						*/
	,PLAY_STS_NOT_SYPPORT   = 0x09				/* T|[gt@C							*/
} PLAYER_STS;

/* TEh`						*/
typedef enum {
	 SOUND_LOWBATT = 0							/* obe[dቺVbg_E			*/
	,SOUND_ALERT								/* obe[dቺx						*/
	,SOUND_ERROR								/* VXeG[̉							*/
	,SOUND_POWER_ON								/* dON̉									*/
	,SOUND_POWER_OFF							/* dOFF̉								*/
	,SOUND_NEXT_MUSIC							/* ̋ȍĐ̉								*/
	,SOUND_BACK_MUSIC							/* ŐȍĐ̉								*/
	,SOUND_PAUSE								/* ꎞ~										*/
	,SOUND_TOP_OF_MUSIC							/* Đ̋Ȃ̐擪ɖ߂鎞̉					*/
	,SOUND_CHANGE_MODE							/* v[[EWI[hؑւ̉				*/
	,SOUND_CHANGE_STATION						/* FMWIǕύX̉						*/
	,SOUND_SEEK_START							/* FMWIXLJn̉				*/
} SOUND_TYPE;

/* W[̍Đ[h`	*/
typedef enum {
	 RESUME_NONE = 0							/* W[񖳌							*/
	,RESUME_TOP = 1								/* t@C̐擪Đ						*/
	,RESUME_SEEK = 2							/* t@C̓rĐ						*/
	,RESUME_NEXT = 3							/* ̋ȂĐ									*/
} RESUME_MODE;

/* W[\				*/
typedef struct RESUME_INFO_t {
	RESUME_MODE mode;							/* W[̍Đ[h						*/
												/* 0:t@C̐擪Đ						*/
												/* 1:t@C̓rĐ						*/
												/* 2:̃t@CĐ							*/
	uint32_t fpos;								/* Đ𒆒ft@Cʒu					*/
	uint32_t time;								/* Đ𒆒fĐ(10msecP)			*/
	char fname[PLAY_LIST_PATH_LEGNTH + 16];		/* Đt@C								*/
} RESUME_INFO;

/* v[[Ǘ\(EEP)		*/
typedef struct PLAYER_EEP_t {
	RESUME_INFO resume;
	REPET_TYPE repetMode;						/* s[gĐ[h							*/
	uint8_t playTimeDisable;					/* sys.playTimetO 0:L !0:		*/
} PLAYER_EEP;

/* v[[Ǘ\				*/
typedef struct PLAYER_SYS_t {
	volatile uint8_t regType;					/* 擾郌WX^								*/
	volatile uint8_t dspBusy;					/* MIDIp DSPԃtO 0:Ready 1:Busy		*/
	volatile uint8_t endFillByte;				/* endFillByte̒l								*/
	volatile uint16_t endFillByteCounter;		/* MendFillByte ̐						*/
	volatile uint8_t fainaraizStep;				/* t@CiCYXebvԍ					*/
	volatile PLAYER_STS playMode;				/* v[[̃Xe[^X						*/
	volatile uint16_t playTime;					/* ĐԃJE^(b)							*/
	volatile uint8_t playTime10;				/* ĐԃJE^(10msec)						*/
	volatile uint8_t tickPlayTime;				/* ĐԃJE^XVL						*/
	uint8_t erroring;							/* G[tO(player)					*/
	uint8_t backupErroring;						/* erroringtOobNAbv					*/
	uint8_t flag_sdChange;						/* SDJ[h}ԕωtO					*/
	uint8_t flag_sdInsert;						/* SDJ[h}ԃtO						*/
	PLAY_FILE_INFO playInfo;					/* Đt@C							*/
	FIL playFL;									/* Đt@C\ / ^Ɏgp			*/
	PLAYLIST playList;							/* ĐXg\								*/
	PLAYER_EEP eepInfo;							/* EEPɕۑp[^					*/
	uint8_t sd_ins;								/* SDJ[h}(0:} !0:})			*/
	uint32_t fileBlockSize;						/* V[No[P̃t@CTCY			*/
	uint8_t seekPos;							/* V[No[\ʒu							*/
	uint8_t backupSeekPos;						/* ÕV[No[ʒu							*/
} PLAYER_SYS;

/* O[oϐ`				*/
#ifndef __PLAYER_C__
extern PLAYER_SYS *playSys;
#endif

/* ֐vg^Cv錾				*/
void player_init( PLAYER_SYS *p );
void player_task( void );
PLAYER_STS player_poll( void );
PLAYER_STS player_play( PLAY_MODE mode );
void player_pause( void );
void player_stop( void );
void player_sound( SOUND_TYPE type );

#endif
