/*###########################################################################
#                                                                           #
#   		                  SHOUTCAST W[                          #
#                                                                           #
###########################################################################*/
#define __SHOUT_CAST_C__
#include "project.h"

/* Timer3 EGCgpɎgp		*/
#define TIMER_NUM 3
#include "myutil/timer.h"

/* O[oϐ					*/
SHOUTCAST *shoutInfo = NULL;

/* [J֐vg^Cv錾		*/
static uint8_t shoutcast_search_connect( SOCKET sok ,char *key ,uint16_t *stsRes );

/*****************************************************************************
*							
* FSHOUTCAST *buffer Ǘϐւ̃|C^
* ߒlFvoid
*****************************************************************************/
void shoutcast_init( SHOUTCAST *buffer )
{
	char url[ SIZE_pUrl ];

	shoutInfo = buffer;
	memset( shoutInfo ,0x00 ,sizeof(SHOUTCAST) );
	shoutcast_stop();

	/* EEPURLAhX擾	*/
	if ( ss_read_byte( ADDR_pUrl ) == '\0' ) {
		load_shoutCast_eep( url );
		ss_strcpy_s( ADDR_pUrl ,SIZE_pUrl ,url );
	}
	shoutcast_start();

	/* ݎݒ			*/
	TCNT0 = 0;
	OCR0A = 16;
	TCCR0B = 0x05;									/* F_CPU / 1024		*/
}

/*****************************************************************************
*							Xg[~OĐ^XN
* Fvoid
* ߒlFvoid
*****************************************************************************/
void shoutcast_task( void )
{
	uint16_t len;
	uint8_t c;
	SSMP p1 ,p2;

	/* lbg[N`FbN						*/
	if ( ( netInfo.netInit != 0xff ) || ( netInfo.ip == 0L ) ) {
		return;
	}

	/* Xg[~OĐtO`FbN		*/
	if ( !( shoutInfo->mode & 0x80 ) ) {
		return;
	}

	/* \Pbgԁ^^CAEg`FbN		*/
	if ( ( shoutInfo->recvTimeout == 0 ) || !tcp_isConnected( SHOUT_SOCK ) ) {
		shoutInfo->mode = SHOUTCAST_TIMEOUT;
		shoutInfo->recvTimeout = 0;
		return;
	}

	/* Xg[~Of[^SPI-SRAMɕۑ	*/
	len = wiz_getSn_RX_RSR( SHOUT_SOCK );
	if ( len >= STREAMING_BLOCK_SIZE ) {
		ss_ringBuffer_recv( SHOUT_SOCK ,STREAMING_BLOCK_SIZE );
		shoutInfo->recvTimeout = STREAMING_TIMEOUT;		/* timeoutZbg	*/
	}
		
	/* obt@O`FbN				*/
	if ( shoutInfo->mode == SHOUTCAST_BUFFERING ) {
		if ( ss_ringBuffer_getDataSize() > SRAM_RING_BUFFER_SIZE / 2 ) {
			shoutInfo->mode = SHOUTCAST_PLAYING;
			vsResetPlayMode();
			vsSetVolume( 0 );
			vsHighPitchedSoundEmphasis( eep.hi_freq ,eep.hi_lv );
			vsBassEmphasis( eep.low_freq ,eep.low_lv );
			vsSetEarSpeaker( eep.earSpeaker );
		}
	}

	/* Đ[hȊO͂ŏI				*/
	if ( shoutInfo->mode != SHOUTCAST_PLAYING ) {
		return;
	}

	/* ^f[^擾							*/
	if ( shoutInfo->metaFlag ) {												/* ^f[^擾҂H		*/
		if ( ss_ringBuffer_getDataSize() >= (uint32_t)shoutInfo->metaLength ) {	/* ^f[^MH			*/

			ss_ringBuffer_read_SS( ADDR_pMetaBuffer ,shoutInfo->metaLength );	/* ^擾(ő4080byte)	*/
			ss_write_byte( ADDR_pMetaBuffer + shoutInfo->metaLength ,'\0' );

			p1 = ss_strcasestr_P( ADDR_pMetaBuffer ,PSTR("StreamTitle='") );	/* Xg[^Cg		*/
			if ( p1 != 0 ) {
				p1 += 13;
				p2 = ss_strcasestr_P( p1 ,PSTR("';") );
				if ( p2 != 0 ) {
					ss_write_byte( p2 ,'\0' );
					if ( ss_strcmp_SS( ADDR_pStreamTile ,p1 ) != 0 ) {
						ss_strcpy_s_SS( ADDR_pStreamTile ,SIZE_pStreamTile ,p1 );
						shoutInfo->recvMetaData = 1;
					}
				}
			}

			shoutInfo->metaFlag = 0;
		}

	/* obt@Đ								*/
	} else if ( ss_ringBuffer_getDataSize() >= PLAY_BLOCK_SIZE ) {
		if ( shoutInfo->metaInterval && ( shoutInfo->dataCount + PLAY_BLOCK_SIZE > shoutInfo->metaInterval ) ) {	/* ^ubNH	*/
			len = shoutInfo->metaInterval - shoutInfo->dataCount;	/* ^f[^܂ł̎cf[^Đ	*/
			while ( len ) {
				len -= ss_ringBuffer_transfer_VS1053B( len );
			}
			ss_ringBuffer_read( &c ,1 );						/* ^f[^擾				*/
			shoutInfo->metaLength = (uint16_t)c * 16;			/* ő4080byte					*/
			if ( shoutInfo->metaLength ) {
				shoutInfo->metaFlag = 1;
			}
			shoutInfo->dataCount = 0;

		} else {
			shoutInfo->dataCount += ss_ringBuffer_transfer_VS1053B( PLAY_BLOCK_SIZE );	/* Xg[~OĐ	*/
		}
		shoutInfo->recvTimeout = STREAMING_TIMEOUT;		/* timeoutZbg							*/

	} else {											/* obt@̏ꍇ̓obt@Os	*/
		shoutInfo->mode = SHOUTCAST_BUFFERING;
	}
}

/*****************************************************************************
*						Xg[~O|[O
* Fvoid
* ߒlFvoid
* OKɃR[Ă邱
*****************************************************************************/
void shoutcast_poll( void )
{
	HTTP_CONNECT cn;
	uint8_t ret;
	uint16_t res;
	SSMP p1 ,p2;
	uint16_t n;

	/* lbg[N`FbN						*/
	if ( ( netInfo.netInit != 0xff ) || ( netInfo.ip == 0L ) ) {
		return;
	}

	/* Đ[hωo					*/
	if ( shoutInfo->pollStep == 0 ) {
		if ( shoutInfo->mode == SHOUTCAST_CONNECT ) {
			shoutInfo->pollStep = 1;

		} else if ( shoutInfo->mode == SHOUTCAST_TIMEOUT ) {
			if ( shoutInfo->recvTimeout == 0 ) {
				shoutInfo->pollStep = 1;
			}
		}

		if ( shoutInfo->pollStep ) {
			printSts_P( PSTR("SHOUTCASTڑJn") );
		}

	/* SHOUTCAST ڑJn				*/
	} else if ( shoutInfo->pollStep == 1 ) {
		shoutcast_stop();

		memset( &cn ,0x00 ,sizeof(HTTP_CONNECT) );
		cn.flag = Sn_MR_ND;
		cn.defPort = 8000;
		strcpy_s_SS( cn.url ,sizeof(cn.url) ,ADDR_pUrl );
		strcpy_s_P( cn.command ,sizeof(cn.command) ,PSTR("GET") );
		strcpy_s_P( cn.requestMessage ,sizeof(cn.requestMessage) ,PSTR("User-Agent: WinampMPEG/2.9\r\n") );
		strcat_s_P( cn.requestMessage ,sizeof(cn.requestMessage) ,PSTR("Icy-MetaData: 1\r\n") );
		strcpy_s_P( cn.strRes ,sizeof(cn.strRes) ,PSTR("ICY") );
		cn.resBuffer = ADDR_pConnectInfo;
		cn.resBufferSize = SIZE_pConnectInfo;

		ret = https_connect1( &shoutInfo->hp ,SHOUT_SOCK ,&cn );
		if ( ret == 1 ) {
			shoutInfo->pollStep = 2;
		} else if ( ret > 1 ) {
			shoutInfo->pollStep = 0;
			shoutInfo->mode = SHOUTCAST_TIMEOUT;
		}
		shoutInfo->recvTimeout = 500;

	/* T[o[ڑ҂						*/
	} else if ( shoutInfo->pollStep == 2 ) {
		if ( shoutInfo->recvTimeout == 0 ) {					/* ^CAEgH		*/
			https_cancel( &shoutInfo->hp );
			shoutInfo->mode = SHOUTCAST_TIMEOUT;
			shoutInfo->pollStep = 0;

		} else {
			ret = https_connect2( &shoutInfo->hp ,&res );
			if ( ret == 0 ) {
				shoutInfo->pollStep = 3;
			} else if ( ret > 1 ) {
				shoutInfo->pollStep = 0;
				shoutInfo->mode = SHOUTCAST_TIMEOUT;
			}
		}
		shoutInfo->recvTimeout = 500;

	/* T[o[̉҂				*/
	} else if ( shoutInfo->pollStep == 3 ) {
		if ( !tcp_isConnected( SHOUT_SOCK ) ) {				/* \PbgؒfH		*/
			shoutInfo->pollStep = 0;
			shoutInfo->mode = SHOUTCAST_TIMEOUT;
			shoutInfo->recvTimeout = 500;

		} else if ( shoutInfo->recvTimeout == 0 ) {			/* ^CAEgH		*/
			https_cancel( &shoutInfo->hp );
			shoutInfo->pollStep = 0;
			shoutInfo->mode = SHOUTCAST_TIMEOUT;
			shoutInfo->recvTimeout = 500;

		/* T[o[̃bZ[W		*/
		} else if ( wiz_getSn_RX_RSR( SHOUT_SOCK ) ) {		/* f[^MH			*/
			p1 = ADDR_pConnectInfo;
			while ( ( p2 = ss_read_word( p1 ) ) != 0 ) {
				p1 += 2;
				if ( ss_strcasestr_P( p2 ,PSTR("icy-br:") ) == p2 ) {				/* rbg[g擾		*/
					atou_SS( p2 + 7 ,&n );
					ss_write_word( ADDR_pBr ,n );

				} else if ( ss_strcasestr_P( p2 ,PSTR("content-type:") ) == p2 ) {	/* f[^`擾		*/
					ss_strcpy_s_SS( ADDR_pContentType ,SIZE_pContentType ,p2 + 13 );
					strtrim_SS( ADDR_pContentType );

				} else if ( ss_strcasestr_P( p2 ,PSTR("icy-name:") ) == p2 ) {		/* Xe[V擾	*/
					ss_strcpy_s_SS( ADDR_pStationName ,SIZE_pStationName ,p2 + 9 );
					strtrim_SS( ADDR_pStationName );
					shoutInfo->recvMetaData = 1;

				} else if ( ss_strcasestr_P( p2 ,PSTR("icy-url:") ) == p2 ) {		/* Xe[VURL擾	*/
					ss_strcpy_s_SS( ADDR_pStationURL ,SIZE_pStationURL ,p2 + 8 );
					strtrim_SS( ADDR_pStationURL );

				} else if ( ss_strcasestr_P( p2 ,PSTR("icy-metaint:") ) == p2 ) {	/* ^f[^Ԋu擾	*/
					atou_SS( p2 + 12 ,&n );
					shoutInfo->metaInterval = n;
				}
			}

			/* ĐJn							*/
			shoutInfo->recvTimeout = STREAMING_TIMEOUT;
			shoutInfo->mode = SHOUTCAST_BUFFERING;
			shoutInfo->pollStep = 0;
			PLAY_ISR_ENABLE();
			printSts_P( PSTR("") );
		}
	}
}

/*****************************************************************************
* 						SHUTCASTXg[~OڑJn
* Fvoid
* ߒlFvoid
*****************************************************************************/
void shoutcast_start( void )
{
	shoutcast_stop();
	if ( ss_read_byte( ADDR_pUrl ) != '\0' ) {
		shoutInfo->recvTimeout = 0;
		shoutInfo->mode = SHOUTCAST_CONNECT;
	}
}

/*****************************************************************************
* 								SHUTCASTĐ~
* Fvoid
* ߒlFvoid
*****************************************************************************/
void shoutcast_stop( void )
{
	PLAY_ISR_DISABLE();

	/* VS1053b Zbg					*/
	vsResetPlayMode();

	/* DSPp[^WX^ޔϐNA*/
	memset( (void *)sys.dsp_sp ,0x00 ,sizeof(sys.dsp_sp) );
	sys.dsp_hDat0 = 0;
	sys.dsp_hDat1 = 0;
	sys.dsp_auData = 0;
	sys.sp_enable = 0;
	sys.fadeIn_timer = 0;
	sys.spTimer = 0;

	/* HTTPCڑLZ				*/
	https_cancel( &shoutInfo->hp );
	shoutInfo->pollStep = 0;

	/* Xg[~ONA			*/
	ss_ringBuffer_clear();
	shoutInfo->mode = SHOUTCAST_STOP;
	shoutInfo->recvTimeout = 0;
	shoutInfo->dataCount = 0;
	shoutInfo->metaLength = 0;
	shoutInfo->metaFlag = 0;
	shoutInfo->metaInterval = 0;
	shoutInfo->recvMetaData = 0;

	/* Xe[VNA(URLc)	*/
	ss_memset( ADDR_pStationURL ,0x00 ,SIZE_pStationURL );
	ss_memset( ADDR_pStationName ,0x00 ,SIZE_pStationName );
	ss_memset( ADDR_pStreamTile ,0x00 ,SIZE_pStreamTile );
	ss_memset( ADDR_pContentType ,0x00 ,SIZE_pContentType );
	ss_write_word( ADDR_pBr ,0 );
}

/*****************************************************************************
*							PLSt@Cǂݍ(HTTP)
* Fchar     *id     ID
*		SSMP     addr    SRAM̈擪|C^
*		uint16_t size    SRAM̈TCY
* ߒlFuint8_t          0:OK !0:NG
*****************************************************************************/
uint8_t shoutcast_download_pls( char *id ,SSMP addr ,uint16_t size )
{
	SOCKET sok = SHOUT_SOCK;

	HTTP_CONNECT cn;
	SSMP p1 ,p2;
	SSMP ptr = 0;
	uint16_t itemCount = 0;
	uint16_t itemIndex = 0;
	uint16_t res;
	uint16_t len;
	uint8_t flag;
	uint8_t ret;

	/* p[^`FbN				*/
	if ( ( strlen( id ) == 0 ) || ( strlen( id ) >= SHOUTCAST_ID_SIZE ) ) {
		return ( 2 );
	}

	/* ACeNA					*/
	ss_write_word( addr ,0 );

	/* HTTPT[o[ڑp[^쐬	*/
	memset( &cn ,0x00 ,sizeof(HTTP_CONNECT) );
	cn.defPort = 80;
	cn.ver = 1;

	strcpy_s_P( cn.url ,sizeof(cn.url) ,SHOUTCAST_URL );
	strcat_s_P( cn.url ,sizeof(cn.url) ,SHOUTCAST_BASE );
	strcat_s_P( cn.url ,sizeof(cn.url) ,PSTR("?id=") );
	strcat_s( cn.url ,sizeof(cn.url) ,id );

	strcpy_s_P( cn.command ,sizeof(cn.command) ,PSTR("GET") );

	strcpy_s_P( cn.requestMessage ,sizeof(cn.requestMessage) ,PSTR("User-Agent: Mozilla/4.0\r\n") );

	strcpy_s_P( cn.strRes ,sizeof(cn.strRes) ,PSTR("HTTP/1") );

	/* HTTPT[o[ڑ					*/
	ret = https_connect( sok ,&cn ,&res );
	if ( ret || ( res != 200 ) ) {
		return ( ret );
	}

	printSts_P( PSTR("PLSt@C擾") );

	/* t@C\					*/
	flag = 0;
	ret = 0;
	while ( 1 ) {
		if ( tcp_ss_gets( sok ,SIZE_pRecvBuffer ,ADDR_pRecvBuffer ) != 0 ) {
			break;
		}
		strtrim_SS( SIZE_pRecvBuffer );

		/* ACeXg擪o		*/
		if ( flag == 0 ) {
			if ( ss_strcasecmp_P( ADDR_pRecvBuffer ,PSTR("[playlist]") ) == 0 ) {
				flag = 1;
			}

		/* ACeo				*/
		} else if ( flag == 1 ) {
			p1 = ss_strcasestr_P( ADDR_pRecvBuffer ,PSTR("numberofentries=") );		/* ACe擾			*/
			if ( p1 == ADDR_pRecvBuffer ) {
				p1 += 16;
				strtrim_SS( p1 );
				atou_SS( p1 ,&itemCount );
				if ( itemCount > 32 ) itemCount = 32;

				ss_write_word( addr ,itemCount );									/* ACe		*/
				for ( uint16_t i = 0 ;i < itemCount ;i++ ) {
					ss_write_word( addr + 2 + ( i * 2 ) ,0x0000 );					/* |C^NA		*/
				}

				ptr = addr + 2 + ( itemCount * 2 );									/* f[^|C^		*/
				size -= ( 2 + ( itemCount * 2 ) );
				flag = 2;
			}

		/* t@Co				*/
		} else if ( ( flag == 2 ) && ( itemIndex < itemCount ) ) {
			p1 = ss_strcasestr_P( ADDR_pRecvBuffer ,PSTR("version=") );				/* ŏIH				*/
			if ( p1 == ADDR_pRecvBuffer ) {
				break;
			}

			p1 = ss_strcasestr_P( ADDR_pRecvBuffer ,PSTR("file") );
			if ( p1 ) {
				p1 += 4;
				p2 = ss_strstr_P( p1 ,PSTR("=") );
				if ( p2 ) {
					strtrim_SS( ++p2 );
					len = strlen_SS( p2 );
					if ( len != 0 ) {
						if ( ( len + 1 ) <= size ) {
							ss_write_word( addr + 2 + ( itemIndex * 2 ) ,ptr );		/* |C^			*/
							ss_memcpy_SS( ptr ,p2 ,len );							/* f[^				*/
							ss_write_byte( ptr + len ,'\0' );						/* I[				*/
							ptr += ( len + 1 );
							size -= ( len + 1 );
							itemIndex++;
						}
					}
				}
			}
		}
	}

	tcp_disconnect( sok );
	printSts_P( PSTR("") );

	return ( ret );
}

/*****************************************************************************
*							PLSt@Cǂݍ(SD-CARD)
* Fchar     *fname  t@C
*		SSMP     addr    SRAM̈擪|C^
*		uint16_t size    SRAM̈TCY
* ߒlFuint8_t          0:OK !0:NG
*****************************************************************************/
uint8_t shoutcast_load_pls( char *fname ,SSMP addr ,uint16_t size )
{
	char *p1 ,*p2;
	SSMP ptr = 0;
	uint16_t itemCount = 0;
	uint16_t itemIndex = 0;
	uint16_t len;
	uint8_t flag;
	uint8_t ret;
	FIL fl;
	char buf[256];

	/* p[^`FbN				*/
	if ( *fname == '\0' ) {
		return ( 1 );
	}
	
	/* ACeNA					*/
	ss_write_word( addr ,0 );

	/* t@CI[v					*/
	if ( f_open( &fl ,fname ,FA_READ ) != FR_OK ) {
		return ( 2 );
	}

	/* t@C\					*/
	flag = 0;
	ret = 0;
	while ( !f_eof(&fl) && ( f_gets( buf ,sizeof(buf) ,&fl ) != NULL ) ) {
		strtrim( buf );

		/* ACeXg擪o		*/
		if ( flag == 0 ) {
			if ( strcasecmp_P( buf ,PSTR("[playlist]") ) == 0 ) {
				flag = 1;
			}

		/* ACeo				*/
		} else if ( flag == 1 ) {
			p1 = strcasestr_P( buf ,PSTR("numberofentries=") );						/* ACe擾			*/
			if ( p1 == buf ) {
				p1 += 16;
				strtrim( p1 );
				atou16( p1 ,&itemCount );
				if ( itemCount > 32 ) itemCount = 32;

				ss_write_word( addr ,itemCount );									/* ACe		*/
				for ( uint16_t i = 0 ;i < itemCount ;i++ ) {
					ss_write_word( addr + 2 + ( i * 2 ) ,0x0000 );					/* |C^NA		*/
				}

				ptr = addr + 2 + ( itemCount * 2 );									/* f[^|C^		*/
				size -= ( 2 + ( itemCount * 2 ) );
				flag = 2;
			}

		/* t@Co				*/
		} else if ( ( flag == 2 ) && ( itemIndex < itemCount ) ) {
			p1 = strcasestr_P( buf ,PSTR("version=") );								/* ŏIH				*/
			if ( p1 == buf ) {
				break;
			}

			p1 = strcasestr_P( buf ,PSTR("file") );
			if ( p1 ) {
				p1 += 4;
				p2 = strstr_P( p1 ,PSTR("=") );
				if ( p2 ) {
					strtrim( ++p2 );
					len = strlen( p2 );
					if ( len != 0 ) {
						if ( ( len + 1 ) <= size ) {
							ss_write_word( addr + 2 + ( itemIndex * 2 ) ,ptr );		/* |C^			*/
							ss_memcpy( ptr ,p2 ,len );								/* f[^				*/
							ss_write_byte( ptr + len ,'\0' );						/* I[				*/
							ptr += ( len + 1 );
							size -= ( len + 1 );
							itemIndex++;
						}
					}
				}
			}
		}
	}

	f_close( &fl );
	return ( ret );
}

/*****************************************************************************
*							nԖڂPLSACe擾
* FSSMP     addr    PLSXgAhX
*		uint16_t index   CfbNXԍ(0`)
*		uint16_t size    obt@TCY
*		char     *buf    obt@
* ߒlFuint8_t          0:OK !0:NG
****************************************************************************/
uint8_t shoutcast_pls_item( SSMP addr ,uint16_t index ,uint16_t size ,char *buf )
{
	buf[0] = '\0';
	uint16_t itemCount = ss_read_word( addr );

	if ( index >= itemCount ) {
		return ( 1 );
	}

	SSMP ptr = ss_read_word( addr + 2 + ( index * 2 ) );
	if ( ptr == 0 ) {
		return ( 2 );
	}

	strcpy_s_SS( buf ,size ,ptr );

	return ( 0 );
}

/*****************************************************************************
*							PLSXgACe擾
* FSSMP     addr    PLSXgAhX
* ߒlFuint16_t
****************************************************************************/
uint16_t shoutcast_pls_count( SSMP addr )
{
	uint16_t count = ss_read_word( addr );
	return ( count );
}

/*****************************************************************************
*					shoutcast_search() ō쐬ACe擾
* FSSMP addr  SRAM̈擪|C^
* ߒlFuint8_t    ACe
*****************************************************************************/
uint8_t shoutcast_stationItemCount( SSMP addr )
{
	SHOUTCAST_LIST *lp = (SHOUTCAST_LIST *)addr;
	uint16_t cnt = ss_read_word( (SSMP)&lp->count );
	if ( cnt > 255 ) {
		cnt = 0;
	}
	return ( cnt );
}

/*****************************************************************************
*					shoutcast_search() ō쐬ACe擾
* FSSMP     addr    SRAM̈擪|C^
*		uint8_t  index   擾CfbNXԍ( 0 ` )
*		uint8_t  itemNum 擾ACeԍ SHOUTCAST_ITEM_NAME  0
*                                         SHOUTCAST_ITEM_MT    1
*                                         SHOUTCAST_ITEM_ID    2
*                                         SHOUTCAST_ITEM_BR    3
*		char     *buf    ACei[obt@
*		uint16_t size    obt@TCY
* ߒlFuint8_t          0:OK !0:NG
*****************************************************************************/
uint8_t shoutcast_stationItem( SSMP addr ,uint8_t index ,uint8_t itemNum ,char *buf ,uint16_t size )
{
	SSMP ptr;
	SHOUTCAST_LIST *lp = (SHOUTCAST_LIST *)addr;

	uint8_t itemCount = shoutcast_stationItemCount( addr );
	if ( index >= itemCount ) {
		return ( 1 );
	}

	if ( size ) {
		*buf = '\0';

		if ( itemNum == SHOUTCAST_ITEM_NAME ) {
			ptr = ss_read_word( (SSMP)&lp->items[index].ptr_name );

		} else if ( itemNum == SHOUTCAST_ITEM_MT ) {
			ptr = ss_read_word( (SSMP)&lp->items[index].ptr_mt );

		} else if ( itemNum == SHOUTCAST_ITEM_ID ) {
			ptr = ss_read_word( (SSMP)&lp->items[index].ptr_id );

		} else if ( itemNum == SHOUTCAST_ITEM_BR ) {
			ptr = ss_read_word( (SSMP)&lp->items[index].ptr_br );

		} else {
			return ( 2 );
		}

		if ( ptr ) {
			strcpy_s_SS( buf ,size ,ptr );
		} else {
			return ( 3 );
		}
	}

	return ( 0 );
}

/*****************************************************************************
*					SHOUTCASTXe[V(HTML)
* Fchar     *key    L[[h(ő32byte)
*		SSMP     addr    SRAM̈擪|C^
*		uint16_t size    SRAM̈TCY
* ߒlFuint8_t          0:OK !0:NG
*****************************************************************************/
uint8_t shoutcast_stationSearch( char *key ,SSMP addr ,uint16_t size )
{
	SOCKET sok = SHOUT_SOCK;

	SHOUTCAST_LIST *pHed = (SHOUTCAST_LIST *)addr;
	SSMP ptr;
	uint8_t ret;
	uint16_t res;
	uint16_t len;

	char buf[512];

	char station_name[SHOUTCAST_NAME_SIZE];
	char station_id[SHOUTCAST_ID_SIZE];
	char station_br[SHOUTCAST_BR_SIZE];
	char station_mt[SHOUTCAST_MT_SIZE];

	uint16_t itemCount = 0;
	char *p1 ,*p2 ,*p3;

	/* wb_NA					*/
	if ( size < sizeof(SHOUTCAST_LIST) ) {
		return ( 1 );
	}

	ss_memset( (SSMP)pHed ,0x00 ,sizeof(SHOUTCAST_LIST) );
	size -= sizeof(SHOUTCAST_LIST);
	ptr = addr + sizeof(SHOUTCAST_LIST);

	/* L[[h`FbN			*/
	if ( strlen( key ) > 32 ) {
		return ( 2 );
	}

	/* ĐԒ~						*/
	shoutcast_stop();
	shoutInfo->mode = SHOUTCAST_CONNECT;

	/* ShoutcastT[o[ڑ		*/
	ret = shoutcast_search_connect( sok ,key ,&res );
	if ( ret || ( res != 200 ) ) {
		return ( ret );
	}

	printSts_P( PSTR("Xe[V擾") );

	station_name[0] = station_id[0] = station_br[0] = station_mt[0] = '\0';
	itemCount = 0;

	/* is󋵕\			*/
	sprintf_P( buf ,PSTR("%u") ,itemCount );
	g_puts( G_TRANSPARENT ,1 ,144 ,228 ,buf ,RGB(0,255,255) ,RGB(0,0,0) );

	/* C		*/
	while ( tcp_gets( sok ,sizeof(buf) ,buf ) == 0 ) {
		strtrim( buf );

		/* Xe[VACeo^	*/
		if ( strcasecmp_P( buf ,PSTR("<div class=\"dirlist\">") ) == 0 ) {

			if ( station_name[0] && station_id[0] && station_br[0] && station_mt[0] ) {

				len = strlen( station_name );
				if ( len > size - 1 ) break;
				if ( len > SHOUTCAST_NAME_SIZE - 1 ) len = SHOUTCAST_NAME_SIZE - 1;
				ss_write_word( (SSMP)&pHed->items[itemCount].ptr_name ,ptr );
				ss_memcpy( ptr ,station_name ,len );
				ptr += len;
				ss_write_byte( ptr++ ,'\0' );

				len = strlen( station_id );
				if ( len > size - 1 ) break;
				if ( len > SHOUTCAST_ID_SIZE - 1 ) len = SHOUTCAST_ID_SIZE - 1;
				ss_write_word( (SSMP)&pHed->items[itemCount].ptr_id ,ptr );
				ss_memcpy( ptr ,station_id ,len );
				ptr += len;
				ss_write_byte( ptr++ ,'\0' );

				len = strlen( station_br );
				if ( len > size - 1 ) break;
				if ( len > SHOUTCAST_BR_SIZE - 1 ) len = SHOUTCAST_BR_SIZE - 1;
				ss_write_word( (SSMP)&pHed->items[itemCount].ptr_br ,ptr );
				ss_memcpy( ptr ,station_br ,len );
				ptr += len;
				ss_write_byte( ptr++ ,'\0' );

				len = strlen( station_mt );
				if ( len > size - 1 ) break;
				if ( len > SHOUTCAST_MT_SIZE - 1 ) len = SHOUTCAST_MT_SIZE - 1;
				ss_write_word( (SSMP)&pHed->items[itemCount].ptr_mt ,ptr );
				ss_memcpy( ptr ,station_mt ,len );
				ptr += len;
				ss_write_byte( ptr++ ,'\0' );

				station_name[0] = station_id[0] = station_br[0] = station_mt[0] = '\0';
				itemCount++;

				/* is󋵕\			*/
				sprintf_P( buf ,PSTR("%u") ,itemCount );
				g_puts( G_TRANSPARENT ,1 ,144 ,228 ,buf ,RGB(0,255,255) ,RGB(0,0,0) );
			}
		}

		/* IǃN`FbN			*/
		if ( strcasestr_P( buf ,PSTR("<a href=\"") ) == buf ) {	/* <A>^OH				*/
			p1 = &buf[9];
			p2 = strstr_P( p1 ,PSTR("\"") );
			if ( p2 != NULL ) {
				*p2 = '\0';
				p3 = strstr_P( p1 ,SHOUTCAST_BASE );			/* PLSt@Cւ̃NH	*/
				if ( p3 != NULL ) {
					p1 = p2 + 1;
					p1 = strcasestr_P( p1 ,PSTR("TITLE=\"") );
					if ( p1 != NULL ) {
						p1 += 7;
						p2 = strstr_P( p1 ,PSTR("\"") );
						if ( p2 != NULL ) {
							*p2 = '\0';
							strcpy_s( station_name ,sizeof(station_name) ,p1 );	/* Xe[V̑Ҕ	*/

							p1 = p2 + 1;
							p2 = strcasestr_P( p1 ,PSTR(" ID=\"") );
							if ( p2 != NULL ) {
								p1 = p2 + 5;
								p2 = strstr_P( p1 ,PSTR("\"") );
								if ( p2 != NULL ) {
									*p2 = '\0';
									strcpy_s( station_id ,sizeof(station_id) ,p1 );	/* Xe[VIDҔ	*/
								}
							}
						}
					}
				}
			}
			continue;
		}

		/* TCgrbg[g擾		*/
		if ( strcasestr_P( buf ,PSTR("<div class=\"dirbitrate\">") ) == buf ) {
			p1 = &buf[24];
			if ( p1 != NULL ) {
				p2 = strstr_P( p1 ,PSTR("<") );
				if ( p2 != NULL ) {
					*p2 = '\0';
					strcpy_s( station_br ,sizeof(station_br) ,p1 );
				}
			}
			continue;
		}

		/* TCgf[^^Cv擾		*/
		if ( strcasestr_P( buf ,PSTR("<div class=\"dirtype\">") ) == buf ) {
			p1 = &buf[21];
			if ( p1 != NULL ) {
				p2 = strstr_P( p1 ,PSTR("<") );
				if ( p2 != NULL ) {
					*p2 = '\0';
					strcpy_s( station_mt ,sizeof(station_mt) ,p1 );
				}
			}
			continue;
		}
	}

	if ( station_name[0] && station_id[0] && station_br[0] && station_mt[0] ) {

		len = strlen( station_name );
		if ( !( len > size - 1 ) ) {
			if ( len > SHOUTCAST_NAME_SIZE - 1 ) len = SHOUTCAST_NAME_SIZE - 1;
			ss_write_word( (SSMP)&pHed->items[itemCount].ptr_name ,ptr );
			ss_memcpy( ptr ,station_name ,len );
			ptr += len;
			ss_write_byte( ptr++ ,'\0' );

			len = strlen( station_id );
			if ( !( len > size - 1 ) ) {
				if ( len > SHOUTCAST_ID_SIZE - 1 ) len = SHOUTCAST_ID_SIZE - 1;
				ss_write_word( (SSMP)&pHed->items[itemCount].ptr_id ,ptr );
				ss_memcpy( ptr ,station_id ,len );
				ptr += len;
				ss_write_byte( ptr++ ,'\0' );

				len = strlen( station_br );
				if ( !( len > size - 1 ) ) {
					if ( len > SHOUTCAST_BR_SIZE - 1 ) len = SHOUTCAST_BR_SIZE - 1;
					ss_write_word( (SSMP)&pHed->items[itemCount].ptr_br ,ptr );
					ss_memcpy( ptr ,station_br ,len );
					ptr += len;
					ss_write_byte( ptr++ ,'\0' );

					len = strlen( station_mt );
					if ( !( len > size - 1 ) ) {
						if ( len > SHOUTCAST_MT_SIZE - 1 ) len = SHOUTCAST_MT_SIZE - 1;
						ss_write_word( (SSMP)&pHed->items[itemCount].ptr_mt ,ptr );
						ss_memcpy( ptr ,station_mt ,len );
						ptr += len;
						ss_write_byte( ptr++ ,'\0' );

						itemCount++;

						/* is󋵕\			*/
						sprintf_P( buf ,PSTR("%u") ,itemCount );
						g_puts( G_TRANSPARENT ,1 ,144 ,228 ,buf ,RGB(0,255,255) ,RGB(0,0,0) );
					}
				}
			}
		}
	}

	/* ڑؒf							*/
	tcp_disconnect( sok );

	/* wb_XV						*/
	if ( ret == 0 ) {
		ss_write_word( (SSMP)&pHed->count ,itemCount );
	}

	/* ԕ\̈NA				*/
	printSts_P( PSTR("") );

	return ( ret );
}

/*****************************************************************************
*				 SHOUTCASTT[o[֌Xg₢킹ڑJn
* FSOCKET       sok     \Pbgԍ
*		char         *key    L[[h
*		uint16_t     *stsRes T[o[X|XR[h
* ߒlFuint8_t              1:OK 1>:NG
*****************************************************************************/
static uint8_t shoutcast_search_connect( SOCKET sok ,char *key ,uint16_t *stsRes )
{
	/* T[o[NGXgbZ[W͈ȉ̂Ƃ										*/
	/* POST /search-ajax/JPOP HTTP/1.0[\r\n]	<---- uJPOPvL[[h	*/
	/* Content-Type: application/x-www-form-urlencoded[\r\n]							*/
	/* User-Agent: Mozilla[\r\n]														*/
	/* Host: www.shoutcast.com[\r\n]            <---- IPAhXwłNGƂȂ		*/
	/* Content-Length: 61[\r\n]					<---- bZ[W̕		*/
	/* [\r\n]									<---- wb_̏I[}[N				*/
	/* order=desc&mode=listenershead2&ajax=true&count=100&strIndex=0 <--̕ Content-Length: ̒lɂȂ(Ōɂ[\r\n]͕sv	*/

	char buf[ 96 ];
	HTTPC_INFO hp;
	uint16_t timeout = 4000;						/* ^CAEg			*/
	uint8_t ret = 1;
	uint8_t cnt;

	*stsRes = 0xffff;

	if ( netInfo.netInit != 0xff ) {
		return ( 10 );
	}

	/* p[^					*/
	memset( &hp ,0x00 ,sizeof(HTTPC_INFO) );
	hp.sok = sok;
	hp.cn.defPort = SHOUTCAST_SEARCH_PORT;
	hp.cn.ver = 0;
	strcpy_s_P( hp.cn.strRes ,sizeof(hp.cn.strRes) ,PSTR("HTTP/1") );

	/* T[o[NGXg쐬	*/
	strcpy_s_P( hp.msg ,sizeof(hp.msg) ,PSTR("POST /search-ajax/") );			/* POST L[[h				*/
	strcat_s( hp.msg ,sizeof(hp.msg) ,key );
	strcat_s_P( hp.msg ,sizeof(hp.msg) ,PSTR(" HTTP/1.0\r\n") );

	strcat_s_P( hp.msg ,sizeof(hp.msg) ,PSTR("Content-Type: application/x-www-form-urlencoded\r\n") );

	strcat_s_P( hp.msg ,sizeof(hp.msg) ,PSTR("Host: ") );						/* Host: hC					*/
	strcat_s_P( hp.msg ,sizeof(hp.msg) ,SHOUTCAST_SEARCH_DOMAIN );				/* hCŎw肵ȂNGƂȂ	*/
	strcat_s_P( hp.msg ,sizeof(hp.msg) ,PSTR("\r\n") );

	sprintf_P( buf ,PSTR("%d") ,SHOUTCAST_ITEM_COUNT );							/* bZ[W	*/
	cnt = 58 + strlen( buf );
	sprintf_P( buf ,PSTR("Content-Length: %d\r\n") ,cnt );
	strcat_s( hp.msg ,sizeof(hp.msg) ,buf );

	strcat_s_P( hp.msg ,sizeof(hp.msg) ,PSTR("\r\n") );							/* wb_I[}[N		*/

	sprintf_P( buf ,PSTR("order=desc&mode=listenershead2&ajax=true&count=%d&strIndex=0") ,SHOUTCAST_ITEM_COUNT );
	strcat_s( hp.msg ,sizeof(hp.msg) ,buf );									/* bZ[W	*/

	hp.flag = 1;

	/* ShoutCastT[o[hCIPAhX擾	*/
	strcpy_s_P( buf ,sizeof(buf) ,SHOUTCAST_SEARCH_DOMAIN );
	hp.ip = gethostbyname( buf );
	hp.port = SHOUTCAST_SEARCH_PORT;
	if ( !hp.ip ) {
		printSts_P( PSTR("DNS G[") );
		return ( 20 );
	}

	/* ڑJn						*/
	while ( ( ret == 1 ) && timeout-- ) {
		ret = https_connect2( &hp ,stsRes );
		WAIT_MS( 1 );
	}

	return ( ret );

	return ( 1 );
}
