/*###########################################################################
#                                                                           #
#   		                  SHOUTCAST W[                          #
#                                                                           #
###########################################################################*/
#ifndef __SHOUT_CAST_H__
#define __SHOUT_CAST_H__

#include <avr/io.h>
#include "23k256/23k256.h"
#include "w5100/w5100.h"

#define STREAMING_BUFFER_SIZE ( 96L * 1024L )	/* Xg[~Oobt@TCY(96KbytesŒ)*/

#define SHOUTCAST_ITEM_COUNT 100				/* XgőACe					*/
#define SHOUTCAST_BASE_KEYWORD 32				/* L[[h							*/

/* Xe[Vf[^eڍő啶	*/
#define SHOUTCAST_NAME_SIZE 	128				/* Xe[Vő					*/
#define SHOUTCAST_TITLE_SIZE    128				/* Đ^Cgő					*/
#define SHOUTCAST_ID_SIZE 		16				/* ID 񒷍ő							*/
#define SHOUTCAST_BR_SIZE 		8				/* "BR"ő							*/
#define SHOUTCAST_MT_SIZE 		8				/* Xg[~O`ő				*/

/* SPI-SRAM gpTCY					*/
#define SIZE_pUrl         URL_SIZE				/* ڑ̃Xe[VURL					*/
#define SIZE_pStationURL  URL_SIZE				/* ڑ̃Xe[VHTTP-URL				*/
#define SIZE_pStationName SHOUTCAST_NAME_SIZE	/* ڑ̃Xe[V					*/
#define SIZE_pStreamTile  SHOUTCAST_TITLE_SIZE	/* ڑ̃Xg[^Cg				*/
#define SIZE_pContentType SHOUTCAST_BR_SIZE		/* ڑ̃Xg[f[^^				*/
#define SIZE_pBr             2					/* ڑ̃Xg[f[^rbg[g		*/
#define SIZE_pConnectInfo 2048					/* HTTPڑ̃X|Xpꎞobt@		*/
#define SIZE_pMetaBuffer  4096					/* ڑ̃Xg[^				*/
#define SIZE_pPlsBuffer   2048					/* PLSt@C_E[hꎞobt@		*/
#define SIZE_pRecvBuffer  2048					/* \PbgMꎞobt@					*/
#define SIZE_pListBuffer  10240					/* Xe[VꗗXgP					*/
#define SIZE_pListBuffer2 10240					/* Xe[VꗗXgQ					*/
#define SIZE_pPlayFile    520					/* v[[ɓnt@C				*/
#if ( ( SIZE_pUrl + SIZE_pStationURL + SIZE_pStationName + SIZE_pStreamTile + SIZE_pContentType + SIZE_pBr + SIZE_pConnectInfo + SIZE_pMetaBuffer + SIZE_pPlsBuffer + SIZE_pRecvBuffer + SIZE_pListBuffer + SIZE_pListBuffer2 + SIZE_pPlayFile ) > 32768U )
#error SPI-SRAM out of memory
#endif

/* SPI-SRAM AhX				*/
#define ADDR_pUrl         0x0000
#define ADDR_pStationURL  ( ADDR_pUrl         + SIZE_pUrl         )
#define ADDR_pStationName ( ADDR_pStationURL  + SIZE_pStationURL  )
#define ADDR_pStreamTile  ( ADDR_pStationName + SIZE_pStationName )
#define ADDR_pContentType ( ADDR_pStreamTile  + SIZE_pStreamTile  )
#define ADDR_pBr          ( ADDR_pContentType + SIZE_pContentType )
#define ADDR_pConnectInfo ( ADDR_pBr          + SIZE_pBr          )
#define ADDR_pMetaBuffer  ( ADDR_pConnectInfo + SIZE_pConnectInfo )
#define ADDR_pPlsBuffer   ( ADDR_pMetaBuffer  + SIZE_pMetaBuffer  )
#define ADDR_pRecvBuffer  ( ADDR_pPlsBuffer   + SIZE_pPlsBuffer   )
#define ADDR_pListBuffer  ( ADDR_pRecvBuffer  + SIZE_pRecvBuffer  )
#define ADDR_pListBuffer2 ( ADDR_pListBuffer  + SIZE_pListBuffer  )
#define ADDR_pPlayFile    ( ADDR_pListBuffer2 + SIZE_pListBuffer2 )

/* Xg[~Op[^		*/
#define STREAMING_TIMEOUT 1000					/* Xg[~OM^CAEg(10msecP)	*/
#define STREAMING_BUFFER_SIZE ( 96L * 1024L )	/* Xg[~Oobt@TCY					*/
#define STREAMING_BLOCK_SIZE 512				/* xɃ\Pbg擾TCY				*/
#define PLAY_BLOCK_SIZE 256						/* xVS1053B֑MTCY				*/

/* ShoutcastT[o[		*/
#define SHOUTCAST_URL PSTR("yp.shoutcast.com")				/* PLSt@C擾T[o[hC	*/
#define SHOUTCAST_BASE PSTR("/sbin/tunein-station.pls")		/* PLSt@C					*/
#define SHOUTCAST_SEARCH_DOMAIN PSTR("www.shoutcast.com")	/* T[o[hC				*/
#define SHOUTCAST_SEARCH_PORT 80						  	/* T[o[|[g   			*/

/* Xg[~O[h			*/
#define SHOUTCAST_STOP      0x70
#define SHOUTCAST_CONNECT   0x71
#define SHOUTCAST_TIMEOUT   0x72
#define SHOUTCAST_BUFFERING 0x83
#define SHOUTCAST_PLAYING   0x84

/* SHOUTAST Xe[VꗗACeԍ*/
#define SHOUTCAST_ITEM_NAME  0					/* Xe[V							*/
#define SHOUTCAST_ITEM_MT    1					/* f[^^Cv								*/
#define SHOUTCAST_ITEM_ID    2					/* Xe[VID							*/
#define SHOUTCAST_ITEM_BR    3					/* f[^rbg[g						*/

/* SHOUCASTNCAgǗ\	*/
typedef struct SHOUTCAST_t {
	volatile uint8_t mode;						/* Xg[~O						*/
	volatile uint16_t recvTimeout;				/* Xg[~O^CAEgJE^		*/
	volatile uint16_t dataCount;				/* ^f[^opf[^JE^			*/
	uint16_t metaInterval;						/* ^f[^Ԋu							*/
	uint16_t metaLength;						/* M^TCY						*/
	uint8_t metaFlag;							/* ^҂							*/
	uint8_t recvMetaData;						/* ^f[^MσtO					*/
	HTTPC_INFO hp;								/* HTTPڑp[^						*/
	uint8_t pollStep;							/* |[Op								*/
} SHOUTCAST;

/* PLSt@CXg\	*/
typedef struct PLS_LIST_t {
	uint16_t count;
	SSMP fname[];
} PLS_LIST;

/* Xe[VXgACe\		*/
typedef struct SHOUTCAST_ITEM_t {
	SSMP ptr_name;
	SSMP ptr_mt;
	SSMP ptr_id;
	SSMP ptr_br;
} SHOUTCAST_ITEM;

/* Xe[VXg\				*/
typedef struct SHOUTCAST_LIST_t {
	uint16_t count;
	char key[SHOUTCAST_BASE_KEYWORD];
	SHOUTCAST_ITEM items[SHOUTCAST_ITEM_COUNT];
} SHOUTCAST_LIST;

/* O[oϐ				*/
#ifndef __SHOUT_CAST_C__
extern SHOUTCAST *shoutInfo;
#endif

/* ֐vg^Cv錾			*/
void shoutcast_init( SHOUTCAST *buffer );
void shoutcast_task( void );
void shoutcast_poll( void );
void shoutcast_start( void );
void shoutcast_stop( void );

uint8_t shoutcast_download_pls( char *id ,SSMP addr ,uint16_t size );
uint8_t shoutcast_load_pls( char *fname ,SSMP addr ,uint16_t size );
uint8_t shoutcast_pls_item( SSMP addr ,uint16_t index ,uint16_t size ,char *buf );
uint16_t shoutcast_pls_count( SSMP addr );

uint8_t shoutcast_stationSearch( char *key ,SSMP addr ,uint16_t size );
uint8_t shoutcast_stationItemCount( SSMP addr );
uint8_t shoutcast_stationItem( SSMP addr ,uint8_t index ,uint8_t itemNum ,char *buf ,uint16_t size );

#endif
