/*###########################################################################
#                                                                           #
#          				VXe֌W(EEPւ̓ǂݏ)      			    #
#                                                                           #
###########################################################################*/
#define __SYSTEM_C__
#include "project.h"
#include "myutil/timer.h"

/* [J֐vg^Cv錾			*/
static void check_station( void );
static void update_station_CRC( void );
static uint8_t _load_eep( void *addr ,void *buf ,uint16_t size );
static void _save_eep( void *addr ,void *buf ,uint16_t size );

/*****************************************************************************
*								VXe^XN
* Fvoid
* ߒlFuint8_t ʏO
*				v[[[h̓VXeԕω
*****************************************************************************/
uint8_t system_task( void )
{
	static uint8_t back_netInit = 0xff;
	static uint8_t jackIn = 0xff;

	uint8_t ret = 0;
	uint8_t shutdown = 0;

	/* LCDplLu[V		*/
	if ( sys.cal ) {
		g_calibration();
		mcu_soft_reset();		/* Zbg	*/
	}

	/* lbg[N|[O			*/
	net_task();
	if ( netInfo.netInit != back_netInit ) {
		if ( back_netInit == 0xff ) {
			printSts_P( PSTR("hoAhX擾") );
		} else if ( netInfo.netInit == 0xff ) {
			printSts_P( PSTR("") );
		}
		back_netInit = netInfo.netInit;
	}

	/* Xg[~O^XN				*/
	if ( eep.playMode == SYSTEM_MODE_SHOUTCAST ) {
		shoutcast_poll();
	
	/* v[[^XN					*/
	} else if ( eep.playMode == SYSTEM_MODE_MUSIC_PLAYER ) {
		ret = player_poll();
	}

	/* wbhzWbNԃ`FbN	*/
	if ( sys.jackCount <= 25 ) {			/* wbhz}H		*/
		if ( jackIn != 1 ) {
			ENABLE_AMP_MUTE();
			WAIT_MS( 100 );
			ENABLE_AMP_SHUTDOWN();
			jackIn = 1;
		}
	} else {								/* wbhz}H		*/
		if ( jackIn != 0 ) {
			DISABLE_AMP_SHUTDOWN();
			WAIT_MS( 100 );
			DISABLE_AMP_MUTE();
			jackIn = 0;
		}
	}

	/* d{^̏			*/
	if ( sys.powerSwCount >= 50 ) {			/* 0.5bȏH				*/
		shutdown = 1;

	/* Vbg_E^C}[		*/
	} else if ( !sys.shutdown_timer && sys.shutdown_timer_enable ) {
		shutdown = 1;
		if ( !sys.mute ) {					/* tF[hAEg			*/
			uint8_t backup_volume = eep.volume;
			eep.volume = 0;
			while ( vsGetVolume() );
			eep.volume = backup_volume;
			sys.mute = 1;
		}
	}

	/* Vbg_E				*/
	if ( shutdown ) {
		g_off();
		cli();

		/* fW^AvVbg_E	*/
		ENABLE_AMP_MUTE();
		WAIT_MS( 100 );
		ENABLE_AMP_SHUTDOWN();

		/* VXeXe[^Xۑ		*/
		save_system_status();

		/* dz[h				*/
		POWER_LED_OFF();
		DISABLE_POWER_HOLD();
		while ( 1 );
	}

	return ( ret );
}

/*****************************************************************************
*							EEPp[^ۑ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void save_system_status( void )
{
	/* v[[[h̃W[p[^쐬	*/
	if ( eep.playMode == SYSTEM_MODE_MUSIC_PLAYER ) {
		player_pause();
		save_player_eep( &playSys->eepInfo );

	/* SHOUTCASTĐURLޔ					*/
	} else if ( eep.playMode == SYSTEM_MODE_SHOUTCAST ) {
		char url[URL_SIZE];
		strcpy_s_SS( url ,URL_SIZE ,ADDR_pUrl );
		save_shoutCast_eep( url );
	}

	/* VXeۑ								*/
	save_eepSys_eep( &eep );
}

/*****************************************************************************
*						Cʂ̋ʏ
* Fuint8_t key ^b`L[ԍ
* ߒlFuint8_t     0: !0:L
*****************************************************************************/
uint8_t main_button_process( uint8_t key )
{
	if ( key == BUTTON_SPEAKER ) {						/* uXs[J[v		*/
		sys.mute ^= 1;
		PLAY_ISR_DISABLE();
		vsSetVolume( 0 );
		PLAY_ISR_ENABLE();
		disp_speaker();

	} else if ( key == BUTTON_VOLUME_DOWN ) {			/* u-v			*/
		if ( eep.volume > 0 ) {
			eep.volume--;
			disp_volume( 1 );
		}

	} else if ( key == BUTTON_VOLUME_UP ) {				/* u+v			*/
		if ( eep.volume < VOLUME_MAXVALUE ) {
			eep.volume++;
			disp_volume( 1 );
		}

	} else if ( key == BUTTON_TIMER ) {					/* u^C}[v			*/
		if ( sys.shutdown_timer_enable == 0 ) {
			if ( eep.shutdown_timer == 0 ) {
				eep.shutdown_timer = 30 * 60;
			}
			sys.shutdown_timer_enable = 1;

		} else {
			if ( ( sys.shutdown_timer / 60 ) == ( eep.shutdown_timer / 60 ) ) {
				eep.shutdown_timer += ( 30 * 60 );
				if ( eep.shutdown_timer > ( 180 * 60 ) ) {
					eep.shutdown_timer = 0;
					sys.shutdown_timer_enable = 0;
				}
			}
		}
		sys.shutdown_count = 0;
		sys.shutdown_timer = eep.shutdown_timer;
		disp_shutdown_timer();

	} else {
		return ( 0 );
	}

	return ( 1 );
}

/*****************************************************************************
*						EEPROMlbg[Nǂݍ
* FNET_CONFIG *cnf lbg[Np[^\
* ߒlFvoid
*****************************************************************************/
void load_netInfo( NET_CONFIG *cnf )
{
	EEPMAP *eep = (EEPMAP *)0;
	if ( _load_eep( &eep->netInfo_crc ,cnf ,sizeof(NET_CONFIG) ) ) {
		/* ftHgp[^[h	*/
		memset( cnf ,0x00 ,sizeof(NET_CONFIG) );

		cnf->dhcpMode = IP_DYNAMIC;								/* DHCPL			*/

		strcpy_P( cnf->hostname ,PSTR("NETRADIO") );			/* zXgl[		*/
		strcpy_P( cnf->ntpname ,PSTR("NTP.NICT.JP") );			/* NTPT[o[	*/

		cnf->mac[0] = 0x00; /* wizЂ̃TvvOŎgpĂMACAhX	*/
		cnf->mac[1] = 0x08;
		cnf->mac[2] = 0xdc;
		cnf->mac[3] = 0x00;
		cnf->mac[4] = 0x00;
		cnf->mac[5] = 0x4f;

		_save_eep( &eep->netInfo_crc ,cnf ,sizeof(NET_CONFIG) );
	}
}

/*****************************************************************************
*						EEPROMɃlbg[Nۑ
* FNET_CONFIG *cnf lbg[Np[^\
* ߒlFvoid
*****************************************************************************/
void save_netInfo( NET_CONFIG *cnf )
{
	EEPMAP *eep = (EEPMAP *)0;
	NET_CONFIG temp;
	uint8_t update = 0;

	if ( _load_eep( &eep->netInfo_crc ,&temp ,sizeof(NET_CONFIG) ) ) {
		update = 1;

	} else if ( memcmp( cnf ,&temp ,sizeof(NET_CONFIG) ) ) {
		update = 1;
	}

	if ( update ) {
		_save_eep( &eep->netInfo_crc ,cnf ,sizeof(NET_CONFIG) );
	}
}

/*****************************************************************************
*							EEPSYS\̂EEP擾
* FEEPSYS *data
* ߒlFvoid
*****************************************************************************/
void load_eepSys_eep( EEPSYS *data )
{
	EEPMAP *eep = (EEPMAP *)0;
	if ( _load_eep( &eep->eepSys_crc ,data ,sizeof(EEPSYS) ) ) {
		/* ftHgp[^[h	*/
		memset( data ,0x00 ,sizeof(EEPSYS) );
		data->volume = 7;
		data->playMode = SYSTEM_MODE_SHOUTCAST;
		data->shutdown_timer = 30 * 60;
		_save_eep( &eep->eepSys_crc ,data ,sizeof(EEPSYS) );
	}
}

/*****************************************************************************
*						EEPROMEEPSYS\̂ۑ
* FEEPSYS *data
* ߒlFvoid
*****************************************************************************/
void save_eepSys_eep( EEPSYS *data )
{
	EEPMAP *eep = (EEPMAP *)0;
	EEPSYS temp;
	uint8_t update = 0;

	if ( _load_eep( &eep->eepSys_crc ,&temp ,sizeof(EEPSYS) ) ) {
		update = 1;

	} else if ( memcmp( data ,&temp ,sizeof(EEPSYS) ) ) {
		update = 1;
	}

	if ( update ) {
		_save_eep( &eep->eepSys_crc ,data ,sizeof(EEPSYS) );
	}
}

/*****************************************************************************
*					PLAYER_EEP\̂EEP擾
* FPLAYER_EEP *data
* ߒlFvoid
*****************************************************************************/
void load_player_eep( PLAYER_EEP *data )
{
	EEPMAP *eep = (EEPMAP *)0;

	if ( _load_eep( &eep->play_eep_crc ,data ,sizeof(PLAYER_EEP) ) ) {
		memset( data ,0x00 ,sizeof(PLAYER_EEP) );
		_save_eep( &eep->play_eep_crc ,data ,sizeof(PLAYER_EEP) );
	}
}

/*****************************************************************************
*						EEPROMPLAYER_EEP\̂ۑ
* FPLAYER_EEP *data
* ߒlFvoid
*****************************************************************************/
void save_player_eep( PLAYER_EEP *data )
{
	EEPMAP *eep = (EEPMAP *)0;
	PLAYER_EEP temp;
	uint8_t update = 0;

	if ( _load_eep( &eep->play_eep_crc ,&temp ,sizeof(PLAYER_EEP) ) ) {
		update = 1;

	} else if ( memcmp( data ,&temp ,sizeof(PLAYER_EEP) ) ) {
		update = 1;
	}

	if ( update ) {
		_save_eep( &eep->play_eep_crc ,data ,sizeof(PLAYER_EEP) );
	}
}

/*****************************************************************************
*						SHOUTCAST-URLEEP擾
* Fchar *url URL
* ߒlFvoid
*****************************************************************************/
void load_shoutCast_eep( char *url )
{
	EEPMAP *eep = (EEPMAP *)0;

	if ( _load_eep( &eep->shoutcast_url_crc ,url ,SIZE_pUrl ) ) {
		memset( url ,0x00 ,SIZE_pUrl );
		_save_eep( &eep->shoutcast_url_crc ,url ,SIZE_pUrl );
	}
}

/*****************************************************************************
*						EEPROMSHOUTCAST-URLۑ
* Fchar *url URL
* ߒlFvoid
*****************************************************************************/
void save_shoutCast_eep( char *url )
{
	EEPMAP *eep = (EEPMAP *)0;
	char temp[ SIZE_pUrl ];
	char data[ SIZE_pUrl ];
	uint8_t update = 0;

	memset( data ,0x00 ,SIZE_pUrl );
	strcpy( data ,url );

	if ( _load_eep( &eep->shoutcast_url_crc ,temp ,SIZE_pUrl ) ) {
		update = 1;

	} else if ( memcmp( data ,temp ,SIZE_pUrl ) ) {
		update = 1;
	}

	if ( update ) {
		_save_eep( &eep->shoutcast_url_crc ,data ,SIZE_pUrl );
	}
}

/*****************************************************************************
*						EEPɃXe[VACeo^
* Fuint8_t  index CfbNXԍ
*		char     *url  ڑURL
*		char     *name Xe[V
*		uint16_t br    rbg[g(128Kbps̏ꍇ128)
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
uint8_t save_station( uint8_t index ,char *url ,char *name ,uint16_t br )
{
	EEPMAP *eep = (EEPMAP *)0;
	uint16_t url_len ,name_len;
	uint16_t size;

	/* EEP̈搮`FbN		*/
	check_station();

	/* CfbNX`FbN		*/
	if ( index >= EEP_STATION_ITEM_MAX ) {
		return ( 1 );
	}

	/* URL񒷃`FbN		*/
	url_len = strlen( url );
	if ( url_len >= URL_SIZE ) {
		return ( 2 );
	}

	/* URL Rs[				*/
	eeprom_busy_wait();
	eeprom_write_byte( &eep->stList.items[index].url_length ,url_len );

	eeprom_busy_wait();
	eeprom_write_block( url ,&eep->stList.items[index].buf[0] ,url_len );

	/* Xe[VRs[		*/
	size = sizeof(eep->stList.items[index].buf) - url_len;
	name_len = strlen( name );
	if ( name_len > size ) {
		name_len = size;
	}
	eeprom_busy_wait();
	eeprom_write_byte( &eep->stList.items[index].name_length ,name_len );

	eeprom_busy_wait();
	eeprom_write_block( name ,&eep->stList.items[index].buf[url_len] ,name_len );

	/* rbg[gRs[		*/
	eeprom_busy_wait();
	eeprom_write_word( &eep->stList.items[index].br ,br );
	
	/* CRC				*/
	update_station_CRC();

	return ( 0 );
}

/*****************************************************************************
*						EEP̃Xe[VACe擾
* Fuint8_t  index    擾CfbNX
*		uint16_t urlSize  urlobt@TCY
*		char     *url     ڑURL
*		uint16_t nameSize nameobt@TCY
*		char     *name    Xe[V
*		uint16_t *br      rbg[g
* ߒlFuint8_t           0:OK !0:NG
*****************************************************************************/
uint8_t load_station( uint8_t index ,uint16_t urlSize ,char *url ,uint16_t nameSize ,char *name ,uint16_t *br )
{
	EEPMAP *eep = (EEPMAP *)0;
	uint8_t url_length ,name_length;

	*url = *name = '\0';

	/* EEP̈搮`FbN		*/
	check_station();

	/* CfbNX`FbN		*/
	if ( index >= EEP_STATION_ITEM_MAX ) {
		return ( 1 );
	}

	/* URL񒷃`FbN		*/
	eeprom_busy_wait();
	url_length = eeprom_read_byte( &eep->stList.items[index].url_length );
	if ( url_length == 0 ) {
		return ( 2 );
	}

	/* Xe[V擾		*/
	eeprom_busy_wait();
	name_length = eeprom_read_byte( &eep->stList.items[index].name_length );

	/* URL擾			*/
	if ( url_length <= ( urlSize - 1 ) ) {
		urlSize = url_length;
	} else {
		urlSize--;
	}

	eeprom_busy_wait();
	eeprom_read_block( url ,&eep->stList.items[ index ].buf[ 0 ] ,urlSize );
	url[ urlSize ] = '\0';

	/* Xe[V擾		*/
	if ( name_length <= ( nameSize - 1 ) ) {
		nameSize = name_length;
	} else {
		nameSize--;
	}

	eeprom_busy_wait();
	eeprom_read_block( name ,&eep->stList.items[ index ].buf[ url_length ] ,nameSize );
	name[ nameSize ] = '\0';

	/* rbg[g擾			*/
	eeprom_busy_wait();
	*br = eeprom_read_word( &eep->stList.items[index].br );

	return ( 0 );
}

/*****************************************************************************
*						EEP̃Xe[VACe폜
* Fuint8_t  index    폜CfbNX
* ߒlFvoid
*****************************************************************************/
void delete_station( uint8_t index )
{
	EEPMAP *eep = (EEPMAP *)0;

	check_station();
	if ( index < EEP_STATION_ITEM_MAX ) {
		eeprom_busy_wait();
		if ( eeprom_read_byte( &eep->stList.items[ index ].url_length ) != 0 ) {
			eeprom_busy_wait();
			eeprom_write_byte( &eep->stList.items[ index ].url_length ,0 );
			update_station_CRC();
		}
	}
}

/*****************************************************************************
*					EEP̃Xe[VACe̋󂫂
* Fuint8_t *index  󂫃CfbNX
* ߒlFuint8_t         0:OK !0:NG
*****************************************************************************/
uint8_t free_station( uint8_t *index )
{
	EEPMAP *eep = (EEPMAP *)0;
	uint8_t i = 0;

	check_station();
	for ( i = 0 ;i < EEP_STATION_ITEM_MAX ;i++ ) {
		eeprom_busy_wait();
		if ( eeprom_read_byte( &eep->stList.items[ i ].url_length ) == 0 ) {
			*index = i;
			return ( 0 );
		}
	}

	*index = 0xff;
	return ( 1 );
}

/*****************************************************************************
*					EEP̃Xe[VꗗwURL
* Fuint8_t *index  YCfbNX
* ߒlFuint8_t         0:OK !0:NG
*****************************************************************************/
uint8_t search_station( char *str ,uint8_t *index )
{
	char url[URL_SIZE] ,name[1];
	uint16_t br;

	*index = 0xff;

	for ( uint8_t i = 0 ;i < EEP_STATION_ITEM_MAX ;i++ ) {
		if ( load_station( i ,sizeof(url) ,url ,sizeof(name) ,name ,&br ) == 0 ) {
			if ( strcasecmp( str ,url ) == 0 ) {
				*index = i;
				return ( 0 );
			}
		}
	}

	return ( 1 );
}

/*****************************************************************************
*				EEP̃Xe[VACëCRC`FbN
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void check_station( void )
{
	EEPMAP *eep = (EEPMAP *)0;
	uint16_t crc1 ,crc2;
	uint8_t i;

	/* CRC`FbN					*/
	eeprom_busy_wait();
	crc1 = eeprom_read_word( &eep->station_crc );
	crc2 = crc16_CalcEEPROM( &eep->stList ,sizeof(STATION_LIST) );

	/* sṽtH[}bg	*/
	if ( crc1 != crc2 ) {
		for ( i = 0 ;i < EEP_STATION_ITEM_MAX ;i++ ) {
			eeprom_busy_wait();
			if ( eeprom_read_byte( &eep->stList.items[i].url_length ) != 0 ) {
				eeprom_busy_wait();
				eeprom_write_byte( &eep->stList.items[i].url_length ,0 );
			}
		}
		update_station_CRC();
	}
}

/*****************************************************************************
*				EEP̃Xe[VACëCRC
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void update_station_CRC( void )
{
	EEPMAP *eep = (EEPMAP *)0;
	uint16_t crc = crc16_CalcEEPROM( &eep->stList ,sizeof(STATION_LIST) );
	eeprom_busy_wait();
	eeprom_write_word( &eep->station_crc ,crc );
}

/*****************************************************************************
*						EEPROMe\̂ǂݍ
* Fvoid *addr    \̐擪AhX
*		void *buf     \̓Ǎobt@
*		uint16_t size \̃TCY
* ߒlFuint8_t       0:OK !0:CRC error
*****************************************************************************/
static uint8_t _load_eep( void *addr ,void *buf ,uint16_t size )
{
	/* CRCǍ						*/
	eeprom_busy_wait();
	uint16_t crc1 = eeprom_read_word( (uint16_t *)addr );

	/* p[^ǂݍ			*/
	eeprom_busy_wait();
	eeprom_read_block( buf ,(char *)addr + 2 ,size );

	/* p[^CRCvZ			*/
	uint16_t crc2 = crc16_CalcRAM( buf ,size );

	return ( crc1 != crc2 );
}

/*****************************************************************************
*						EEPROM֊e\̂
* Fvoid *addr    \̐擪AhX
*		void *buf     \̓Ǎobt@
*		uint16_t size \̃TCY
* ߒlFvoid
*****************************************************************************/
static void _save_eep( void *addr ,void *buf ,uint16_t size )
{ 
	/* CRC			*/
	uint16_t crc = crc16_CalcRAM( buf ,size );
	eeprom_busy_wait();
	eeprom_write_word( (uint16_t *)addr ,crc );

	/* p[^ۑ		*/
	eeprom_busy_wait();
	eeprom_write_block( buf ,(char *)addr + 2 ,size );
}
