/*###########################################################################
#                                                                           #
#                    	VXe֌W                                        #
#                                                                           #
###########################################################################*/
#ifndef __SYSTEM_H__
#define __SYSTEM_H__
#include "project.h"

#define EEP_STATION_ITEM_MAX 10					/* EEPɕۑ\ȃXe[V 							*/
#define VOLUME_MAXVALUE 12						/* ʍől( 0 ` VOLUME_MAXVALUE )ύXs				*/
#define VOLUME_FADE_STEP 15						/* ʃtF[hCEAEgXebv						*/
#define NOT_PROCESS_TIMEOUT 6000				/* ԃ^CAEg(10msec)							*/

#define SP_INTERVAL 8							/* XyAif[^XV(10msecP)						*/
#define TELOP_INTERVAL 5						/* ebvXV(10msecP)								*/

/* XP[ϊ}N val = ϊ  rg1:ϊXP[  rg2:ϊXP[	*/
#define SCALE_CONVERT(val,rg1,rg2) ( ( ( ( ( (uint32_t)(val) * (uint32_t)(rg2) ) * 10L ) + 5L ) / (uint32_t)(rg1) ) / 10L )

/* VXe[h						*/
#define SYSTEM_MODE_SHOUTCAST 0
#define SYSTEM_MODE_MUSIC_PLAYER 1
#define SYSTEM_MODE_FM_RADIO 2

/* VXeϐ\				*/
typedef struct SYSTEM_t {
	volatile uint16_t dsp_hDat0;					/* VS1053bWX^										*/
	volatile uint16_t dsp_hDat1;					/* VS1053bWX^										*/
	volatile uint16_t dsp_auData;					/* VS1053bWX^										*/
	volatile uint16_t dsp_sp[VS_SPECTRUM_VALUES];	/* VS1053bXyAif[^								*/
	volatile uint8_t sp_enable;						/* VS1053bXyAif[^擾							*/
	volatile uint8_t spTimer;						/* XyAiXV^C}[									*/
	volatile uint8_t fadeIn_timer;					/* ʃtF[hC^C}[								*/
	volatile uint8_t jackCount;						/* wbhzWbN}E}o^C}[			*/
	volatile uint8_t powerSwCount;					/* dXCb`Ԍop^C}[						*/
	volatile uint16_t noProcessTimer;				/* 쎞ԃ^C}[									*/
	volatile uint16_t shutdown_timer;				/* Vbg_E^C}[(b)							*/
	volatile uint8_t shutdown_count;				/* Vbg_E^C}[1bJE^					*/
	uint8_t shutdown_timer_enable;					/* Vbg_E^C}[L^						*/
	FATFS fs;										/* FatFsp[N										*/
	uint8_t mute;									/* ~[g 0:OFF 1:ON									*/
	volatile uint8_t cal;							/* LCDLu[VtO							*/
} SYSTEM;

typedef struct EEPSYS_t {
	volatile uint8_t playMode;						/* SYSTEM_MODE_SHOUTCAST / SYSTEM_MODE_MUSIC_PLAYER		*/
	uint8_t volume;									/*  0` 12											*/
	uint8_t earSpeaker;								/* EarSpeakerx(0`3)								*/
	uint8_t hi_freq;								/* g(1`15)KHzȏ				*/
	int8_t hi_lv;									/* x1.5db݂Ŏw(-8`7)					*/
	uint8_t low_freq;								/* g(2`15) Hzȉ̎g(20Hz`150Hz)	*/
	uint8_t low_lv;									/* x1db݂Ŏw(0`15)					*/
	uint16_t shutdown_timer;						/* Ōɐݒ肵Vbg_E^C}[l				*/
} EEPSYS;

/* Xe[VACe				*/
typedef struct STATION_ITEM_t {
	uint8_t url_length;								/* URL(0:)									*/
	uint8_t name_length;							/* Xe[V									*/
	char buf[252];									/* obt@										*/
	uint16_t br;									/* rbg[g											*/
} STATION_ITEM;

/* Xe[VXg				*/
typedef struct STATION_LIST_t {
	STATION_ITEM items[EEP_STATION_ITEM_MAX];
} STATION_LIST;

/* EEP ROM}bv				*/
typedef struct EEP_t {
	uint16_t netInfo_crc;
	NET_CONFIG netInfo;

	uint16_t station_crc;
	STATION_LIST stList;

	uint16_t eepSys_crc;
	EEPSYS eepSys;

	uint16_t play_eep_crc;
	PLAYER_EEP play_eep;

	uint16_t shoutcast_url_crc;
	char shoutcast_url[URL_SIZE];

} EEPMAP;

/* Đݐ					*/
#define PLAY_ISR_ENABLE() ( TIMSK0 |= _BV(OCIE0A) )
#define PLAY_ISR_DISABLE() ( TIMSK0 &= ~_BV(OCIE0A) )

/* e퐧|[g`					*/
#define ENABLE_AMP_MUTE()      ( PORTF &= ~_BV(PF2) )
#define DISABLE_AMP_MUTE()     ( PORTF |=  _BV(PF2) )

#define ENABLE_AMP_SHUTDOWN()  ( PORTF &= ~_BV(PF1) )
#define DISABLE_AMP_SHUTDOWN() ( PORTF |=  _BV(PF1) )

#define PHONE_IN()             ( PINF  &   _BV(PF3) )		/* !0:} 0:}	*/

#define POWER_LED_ON()         ( PORTD &= ~_BV(PD7) )
#define POWER_LED_OFF()        ( PORTD |=  _BV(PD7) )

#define ENABLE_POWER_HOLD()    ( PORTD |=  _BV(PD6) )
#define DISABLE_POWER_HOLD()   ( PORTD &= ~_BV(PD6) )

#define POWER_SW()             ( PINF  &   _BV(PF0) )		/* !0:OFF 0:ON			*/

/* O[oϐ`					*/
#ifndef __MAIN_C__
extern SYSTEM sys;
extern EEPSYS eep;
extern const prog_uint8_t volumeTable[];
#endif

/* ֐vg^Cv錾				*/
uint8_t system_task( void );
void save_system_status( void );
uint8_t main_button_process( uint8_t key );

void load_netInfo( NET_CONFIG *cnf );
void save_netInfo( NET_CONFIG *cnf );

void load_eepSys_eep( EEPSYS *data );
void save_eepSys_eep( EEPSYS *data );

void load_player_eep( PLAYER_EEP *data );
void save_player_eep( PLAYER_EEP *data );

void load_shoutCast_eep( char *url );
void save_shoutCast_eep( char *url );

uint8_t save_station( uint8_t index ,char *url ,char *name ,uint16_t br );
uint8_t load_station( uint8_t index ,uint16_t urlSize ,char *url ,uint16_t nameSize ,char *name ,uint16_t *br );
void delete_station( uint8_t index );
uint8_t free_station( uint8_t *index );
uint8_t search_station( char *str ,uint8_t *index );

#endif
